
/**

Author: Kevin Loughran

**/

(function(window)
{	
	// terminal script for local hosting:
	// python -m SimpleHTTPServer 7000

	//--------------------------- CONSTRUCTOR:
	
	var Main = function()
	{
		
	}
	
	//--------------------------- STATS:
	
	var BASE_URL;
	//BASE_URL = 'http://localhost:8000/Dropbox/_COMPTRANSFER/cartoonNetwork/d2/html5/d2e/';
	//BASE_URL = 'http://staging.cartoonnetwork.com/games/teen-titans-go/drillionaire-2/';
	BASE_URL = 'http://i.cdn.turner.com/toon/games/teen-titans-go/drillionaire-2/';
	
	var DEBUG_CASH = 0;
	var startLevel = 0;
	
	var PLAYER_SPEED = 300;
	var PLAYER_HEALTH = 10;
	var PLAYER_FUEL = 1000;
	var PLAYER_STORAGE = 20;
	var PLAYER_DAMAGE = 1;
	var DRILL_POWER = 20; //1;
	var BULLET_SPEED = 600;
	var BULLET_DELAY = .2; //seconds
	
	//--------------------------- LEVELS:
	
	var statSettings = [];
	statSettings.health	 	= [8,10,12,14,16];
	statSettings.fuel 		= [2000,4000,8000,15000,30000];
	statSettings.storage 	= [10,20,30,40,50];
	statSettings.drill 		= [1,2,3,4,16];
	statSettings.weapons 	= [1,1,2,2,2];
	statSettings.fireRate 	= [.3,.2,.3,.2,.02];
	statSettings.engine 	= [300,320,340,360,400];

	var curCash = 0;
	
	//--------------------------- GRIDNOK:
	
	var tankSpeed = .1;//.1;
	var tankHealth = 200;
	var tankHealthCanon = 10;
	var tankHealthTurret = 10;
	var tankHealthClaw = 10;
	var tankHealthShield = 20;
	var tankStartRow = 180;
	
	var GRIDNOK_SPEED = 100;
	var gridnokHealth = 500;
	var gridnokStartRow = 380;
	
	var BLACKFIRE_SPEED = 200;
	var blackfireHealth = 1000;
	var blackfireLaserSpeed = 500;
	var blackfireRockSpeed = 600;
	var blackfireWaveSpeed = 500;
	var blackfireStartRow = 580;
	
	//--------------------------- CONSTANTS:
	
	var TILE_HEALTH = 40;
	var TILE_WIDTH = 64;
	var MAP_WIDTH = 35;
	var MAP_HEIGHT = 620;
	var MAX_VELOCITY = 50;
	var TERMINAL_VELOCITY = 1500;
	var AIRBAG_VELOCITY = 500;
	var DRILL_THRESH = 80;
	var ROW_LIMIT = 12;
	var HORIZON_Y = 256*4;
	
	var EBULLET_SPEED = 400;
	
	var POWERUP_DELAY = 120; //seconds
	var DRILL_SLIDE = 150;
	
	var ZONE_MARK = 100;
	var DEPTH_MARK = ZONE_MARK/5;
	var FULL_DEPTH = ZONE_MARK*DEPTH_MARK*6;
	
	//--------------------------- GLOBAL VARIABLES:
	
	var main;
	var cont;
	var holder;
	var game;
	var platforms;
	var bullets;
	var boulders;
	var backtiles;
	var backart;
	var effectsLayer;
	var bonusLayer;
	var map;
	var portals;
	
	var darkness;
	var background;
	var door;
	var powerupDoor;
	var surface;
	
	var player;
	var playerg;
	
	var stats;
	var settings;
	
	var testEnemy;
	var enemies;
	var enemySpawns = [];
	var enemyMatrix = [];
	var activeEnemies = [];
	var ebullets;
	
	var bosses;
	var gridnok;
	var blackfire;
	
	var topTiles = [];
	
	var water;
	var waterMatrix = [];
	
	var activeBullets = [];
	var fireButton;
	
	var allTiles;
	var tileData;
	
	var tileMatrix;
	var backMatrix;
	
	var gui;
	var menus;
	var pauseMenu;
	var titleMenu;
	var bossMenu;
	var instMenu;
	var towerMenu;
	
	var loadInterval;
	
	var shopMenu;
	var powerupMenu;
	var curShopNav;
	var curPowerupShopNav;
	
	var fuelWarning;
	var storageWarning;
	
	var powerupA;
	var powerupB;
	var curShop;
	var curWarp;
	
	var musicTrack;
	var drillTrack;
	var flyingTrack;
	var playerLoop;
	var sounds = [];
	
	var tankBodies;
	var pDialogue;
	var bDialogue;
	var curDia;
	
	var lastWarpCol=17;
	var lastWarpRow=-1;
	var isNewDate = false;
	
	var sfxVolume = 1;
	var musicVolume = 1;
	
	//--------------------------- PUBLIC METHODS:
	
	Main.init = function()
	{
		// unbind key
		$( window ).off("keydown", onKeyPress);
		
		// get container
		cont = document.getElementById("container");
		
		// add game holder
		holder = document.createElement("div");
		holder.className = "gameHolder";
		TweenMax.to( holder, 0, {y:0, alpha:1});
		cont.appendChild( holder );
		
		// pull stats data
		stats = [];
		var i;
		var stat;
		var list = ['drill','hull','fuel','storage','weapons','engine','airbag','lantern'];
		for(i=0; i<list.length; i++)
		{
			var stat = localStorage.getItem( 'stat-'+list[i] );
			if(stat)
			{
				console.log('found: ' + list[i] + ', ' + Number(stat) );
				stats[ list[i] ] = Number(stat);
			}
			else
			{
				console.log('not found: ' + list[i] );
				stats[ list[i] ] = startLevel;
				localStorage.setItem( ('stat-'+list[i]) , stats[ list[i] ] );
			}
			
			if(DEBUG_CASH>0){ stats[ list[i] ] = 4; }
		}
		
		// pull settings data
		settings = [];
		settings.gemsCollected = Number( localStorage.getItem( 'gemsCollected' ) );
		settings.warpDialogue = localStorage.getItem( 'warpDialogue' );
		settings.towerLevel = Number( localStorage.getItem( 'towerLevel' ) );
		curCash = Number( localStorage.getItem( 'curCash' ) );
		curCash += DEBUG_CASH;
		
		// pull volume settings
		var chk = localStorage.getItem( 'musicVolume' );
		if( !chk )
		{
			localStorage.setItem( 'musicVolume', 1 );
			localStorage.setItem( 'sfxVolume', 1 );
			musicVolume = 1;
			sfxVolume = 1;
		}
		else
		{
			musicVolume = Number( localStorage.getItem( 'musicVolume' ) );
			sfxVolume = Number( localStorage.getItem( 'sfxVolume' ) );
		}
		
		// reset vars
		curShop = 'shop';
		
		// add gui dom
		gui = document.createElement("div");
		gui.id = "gui";
		TweenMax.to( gui, 0, {y:-400, alpha:1});
		cont.appendChild( gui );
				
		// add title/loader
		buildTitle();
		
		// start phaser on small delay
		TweenMax.delayedCall( 0.5, setupPhaser );
	}
	
	function setupPhaser()
	{
		// setup phaser
		game = new Phaser.Game(600, 400, Phaser.CANVAS, '', { preload: preload, create: create, update: update, render:render});
		loadInterval = setInterval(checkLoadProgress, 30);
	}
	
	//--------------------------- PHASER METHODS:

	function preload() 
	{
		console.log("preload");
		
		var i;
		var j;
		var k;
		var id;
		
		// set to CORS to "anonymous"
		if( BASE_URL )
		{
			game.load.baseURL = BASE_URL;
		}
		game.load.crossOrigin = "anonymous";
		bypassSafariCORSLameness();
		
		// add to container
		holder.appendChild(game.canvas);
		
		// disable focus pause
		game.stage.disableVisibilityChange = true;
		
		////////////////////////////////
		//////// AUDIO /////////////////
		////////////////////////////////
		
		// music
		game.load.audio('m_zone0', 'audio/music/mp3/aboveground_loop.mp3');
		game.load.audio('m_zone1', 'audio/music/mp3/area1_loop.mp3');
		game.load.audio('m_zone2', 'audio/music/mp3/area2_loop.mp3');
		game.load.audio('m_zone3', 'audio/music/mp3/area3_loop.mp3');
		game.load.audio('m_zone4', 'audio/music/mp3/area4_loop.mp3');
		game.load.audio('m_zone5', 'audio/music/mp3/area5_loop.mp3');
		game.load.audio('m_zone6', 'audio/music/mp3/area6_loop.mp3');
		game.load.audio('m_boss1', 'audio/music/mp3/boss_loop_grisnek.mp3');
		game.load.audio('m_boss2', 'audio/music/mp3/boss_loop_gridnock.mp3');
		game.load.audio('m_boss3', 'audio/music/mp3/boss_loop_blackfire.mp3');
		game.load.audio('m_boss_start', 'audio/music/mp3/boss_start_stinger.mp3');
		game.load.audio('m_boss_end', 'audio/music/mp3/boss_end_stinger.mp3');
		
		// sfx: player
		game.load.audio('p_goabove', 'audio/sfx/mp3/player/go_above_02.mp3');
		game.load.audio('p_gobelow', 'audio/sfx/mp3/player/go_below_02.mp3');
		game.load.audio('p_enterPortal', 'audio/sfx/mp3/player/portal_enter.mp3');
		game.load.audio('p_exitPortal', 'audio/sfx/mp3/player/portal_exit.mp3');
		game.load.audio('p_door', 'audio/sfx/mp3/player/door_open_close_01.mp3');
		game.load.audio('p_damage', 'audio/sfx/mp3/player/player_damage_loop_01.mp3');
		game.load.audio('p_death', 'audio/sfx/mp3/player/player_death_01.mp3');
		game.load.audio('p_full', 'audio/sfx/mp3/player/full_01.mp3');
		game.load.audio('p_empty', 'audio/sfx/mp3/player/outoffuel_01.mp3');
		game.load.audio('p_drill', 'audio/sfx/mp3/player/drill_loop_02.mp3');
		game.load.audio('p_fly', 'audio/sfx/mp3/player/drill_flying_loop_01.mp3');
		
		// sfx: obstacles
		game.load.audio('o_dig1', 'audio/sfx/mp3/obstacles/dig_01.mp3');
		game.load.audio('o_dig2', 'audio/sfx/mp3/obstacles/dig_02.mp3');
		game.load.audio('o_dig3', 'audio/sfx/mp3/obstacles/dig_03.mp3');
		game.load.audio('o_dig4', 'audio/sfx/mp3/obstacles/dig_04.mp3');
		game.load.audio('o_boulder', 'audio/sfx/mp3/obstacles/boulder_breaks_01.mp3');
		game.load.audio('o_splash', 'audio/sfx/mp3/obstacles/water_splash_01.mp3');
		game.load.audio('o_radioactive', 'audio/sfx/mp3/obstacles/radioactive_01.mp3');
		
		// sfx: ui
		game.load.audio('u_pickup1', 'audio/sfx/mp3/ui/pickup_01.mp3');
		game.load.audio('u_pickup2', 'audio/sfx/mp3/ui/pickup_02.mp3');
		game.load.audio('u_pickup3', 'audio/sfx/mp3/ui/pickup_03.mp3');
		game.load.audio('u_pickup4', 'audio/sfx/mp3/ui/pickup_04.mp3');
		game.load.audio('u_pickup5', 'audio/sfx/mp3/ui/pickup_05.mp3');
		game.load.audio('u_pickup6', 'audio/sfx/mp3/ui/pickup_06.mp3');
		
		game.load.audio('u_button', 'audio/sfx/mp3/ui/button_01.mp3');
		game.load.audio('u_buy', 'audio/sfx/mp3/ui/buy_01.mp3');
		game.load.audio('u_close', 'audio/sfx/mp3/ui/close_01.mp3');
		game.load.audio('u_tab', 'audio/sfx/mp3/ui/tab_01.mp3');
		game.load.audio('u_upgrade', 'audio/sfx/mp3/ui/tower_upgrade.mp3');
		game.load.audio('u_nomoney', 'audio/sfx/mp3/ui/no_money_01.mp3');
		game.load.audio('u_popup', 'audio/sfx/mp3/ui/popup_01.mp3');
		
		// sfx: weapons
		game.load.audio('w_shot1', 'audio/sfx/mp3/weapons/shot_01.mp3');
		game.load.audio('w_shot2', 'audio/sfx/mp3/weapons/shot_02.mp3');
		game.load.audio('w_shot3', 'audio/sfx/mp3/weapons/shot_03.mp3');
		
		// sfx: tank
		game.load.audio('t_shot1', 'audio/sfx/mp3/tank/gordian_turret_attack_1.mp3');
		game.load.audio('t_shot2', 'audio/sfx/mp3/tank/gordian_turret_attack_2.mp3');
		game.load.audio('t_laser', 'audio/sfx/mp3/tank/gordian_laser_attack.mp3');
		game.load.audio('t_breakCanon', 'audio/sfx/mp3/tank/gordian_cannon_destroyed.mp3');
		game.load.audio('t_breakSheild', 'audio/sfx/mp3/tank/gordian_shield_destroyed.mp3');
		game.load.audio('t_breakTurret', 'audio/sfx/mp3/tank/gordian_turret_destroyed.mp3');
		
		// sfx: gridnok
		game.load.audio('g_active1', 'audio/sfx/mp3/gridnok/gridnock_active_1.mp3');
		game.load.audio('g_active2', 'audio/sfx/mp3/gridnok/gridnock_active_2.mp3');
		game.load.audio('g_boulderhit', 'audio/sfx/mp3/gridnok/gridnock_boulderhit.mp3');
		game.load.audio('g_charge', 'audio/sfx/mp3/gridnok/gridnock_charge.mp3');
		game.load.audio('g_death', 'audio/sfx/mp3/gridnok/gridnock_death.mp3');
		game.load.audio('g_eat', 'audio/sfx/mp3/gridnok/gridnock_eat.mp3');
		game.load.audio('g_step1', 'audio/sfx/mp3/gridnok/gridnock_fs_1.mp3');
		game.load.audio('g_step2', 'audio/sfx/mp3/gridnok/gridnock_fs_2.mp3');
		game.load.audio('g_step3', 'audio/sfx/mp3/gridnok/gridnock_fs_3.mp3');
		game.load.audio('g_step4', 'audio/sfx/mp3/gridnok/gridnock_fs_4.mp3');
		game.load.audio('g_hurt1', 'audio/sfx/mp3/gridnok/gridnock_hurt_1.mp3');
		game.load.audio('g_hurt2', 'audio/sfx/mp3/gridnok/gridnock_hurt_2.mp3');
		game.load.audio('g_hurt3', 'audio/sfx/mp3/gridnok/gridnock_hurt_3.mp3');
		game.load.audio('g_throw1', 'audio/sfx/mp3/gridnok/gridnock_throw_1.mp3');
		game.load.audio('g_throw2', 'audio/sfx/mp3/gridnok/gridnock_throw_2.mp3');
		
		// sfx: blackfire
		game.load.audio('b_bomb', 'audio/sfx/mp3/blackfire/blackfire_bomb.mp3');
		game.load.audio('b_death', 'audio/sfx/mp3/blackfire/blackfire_death.mp3');
		game.load.audio('b_beam1', 'audio/sfx/mp3/blackfire/blackfire_eyebeam_1.mp3');
		game.load.audio('b_beam2', 'audio/sfx/mp3/blackfire/blackfire_eyebeam_2.mp3');
		game.load.audio('b_rocks', 'audio/sfx/mp3/blackfire/blackfire_rain_rocks.mp3');
		game.load.audio('b_rain', 'audio/sfx/mp3/blackfire/blackfire_rain.mp3');
		game.load.audio('b_step1', 'audio/sfx/mp3/blackfire/blackfire_walk_1.mp3');
		game.load.audio('b_step2', 'audio/sfx/mp3/blackfire/blackfire_walk_2.mp3');
		game.load.audio('b_step3', 'audio/sfx/mp3/blackfire/blackfire_walk_3.mp3');
		game.load.audio('b_step4', 'audio/sfx/mp3/blackfire/blackfire_walk_4.mp3');
		game.load.audio('b_wave', 'audio/sfx/mp3/blackfire/blackfire_wave.mp3');
		
		// sfx: chrysalis
		game.load.audio('e_ch_active1', 'audio/sfx/mp3/enemy/chrysalis_active_1.mp3');
		game.load.audio('e_ch_active2', 'audio/sfx/mp3/enemy/chrysalis_active_2.mp3');
		game.load.audio('e_ch_attack1', 'audio/sfx/mp3/enemy/chrysalis_attack_1.mp3');
		game.load.audio('e_ch_attack2', 'audio/sfx/mp3/enemy/chrysalis_attack_2.mp3');
		game.load.audio('e_ch_death1', 'audio/sfx/mp3/enemy/chrysalis_shot_death_1.mp3');
		game.load.audio('e_ch_death2', 'audio/sfx/mp3/enemy/chrysalis_shot_death_2.mp3');
		
		// sfx: flarnop
		game.load.audio('e_fl_attack1', 'audio/sfx/mp3/enemy/flamop_attack_slam.mp3');
		
		// sfx: fly
		game.load.audio('e_fly_active', 'audio/sfx/mp3/enemy/flanorgla_active_loop.mp3');
		game.load.audio('e_fly_attack', 'audio/sfx/mp3/enemy/flanorgla_attack.mp3');
		game.load.audio('e_fly_death', 'audio/sfx/mp3/enemy/flanorgla_death.mp3');
		
		// sfx: glorg
		game.load.audio('e_gl_active1', 'audio/sfx/mp3/enemy/glorg_active_1.mp3');
		game.load.audio('e_gl_active2', 'audio/sfx/mp3/enemy/glorg_active_2.mp3');
		game.load.audio('e_gl_attack1', 'audio/sfx/mp3/enemy/glorg_attack_1.mp3');
		game.load.audio('e_gl_attack2', 'audio/sfx/mp3/enemy/glorg_attack_2.mp3');
		game.load.audio('e_gl_death1', 'audio/sfx/mp3/enemy/glorg_shot_death_1.mp3');
		game.load.audio('e_gl_death2', 'audio/sfx/mp3/enemy/glorg_shot_death_2.mp3');
		
		// sfx: gordian_ex
		game.load.audio('e_gx_active1', 'audio/sfx/mp3/enemy/gordian_ex_active_1.mp3');
		game.load.audio('e_gx_active2', 'audio/sfx/mp3/enemy/gordian_ex_active_2.mp3');
		game.load.audio('e_gx_attack1', 'audio/sfx/mp3/enemy/gordian_ex_attack_1.mp3');
		game.load.audio('e_gx_attack2', 'audio/sfx/mp3/enemy/gordian_ex_attack_2.mp3');
		game.load.audio('e_gx_death1', 'audio/sfx/mp3/enemy/gordian_ex_shot_death_1.mp3');
		game.load.audio('e_gx_death2', 'audio/sfx/mp3/enemy/gordian_ex_shot_death_2.mp3');
		
		// sfx: gordian
		game.load.audio('e_go_active1', 'audio/sfx/mp3/enemy/gordians_active_1.mp3');
		game.load.audio('e_go_active2', 'audio/sfx/mp3/enemy/gordians_active_2.mp3');
		game.load.audio('e_go_attack1', 'audio/sfx/mp3/enemy/gordians_attack_1.mp3');
		game.load.audio('e_go_attack2', 'audio/sfx/mp3/enemy/gordians_attack_2.mp3');
		game.load.audio('e_go_death1', 'audio/sfx/mp3/enemy/gordians_shot_death_1.mp3');
		game.load.audio('e_go_death2', 'audio/sfx/mp3/enemy/gordians_shot_death_2.mp3');
		
		// sfx: perry plant
		game.load.audio('e_pl_attack1', 'audio/sfx/mp3/enemy/perryplant_attack_1.mp3');
		game.load.audio('e_pl_attack2', 'audio/sfx/mp3/enemy/perryplant_attack_2.mp3');
		game.load.audio('e_pl_death1', 'audio/sfx/mp3/enemy/perryplant_death.mp3');
		
		// sfx: worm
		game.load.audio('e_wo_chomp1', 'audio/sfx/mp3/enemy/snervian_active_chomp_1.mp3');
		game.load.audio('e_wo_chomp2', 'audio/sfx/mp3/enemy/snervian_active_chomp_2.mp3');
		game.load.audio('e_wo_chomp3', 'audio/sfx/mp3/enemy/snervian_active_chomp_3.mp3');
		game.load.audio('e_wo_eat1', 'audio/sfx/mp3/enemy/snervian_eat_move_1.mp3');
		game.load.audio('e_wo_eat2', 'audio/sfx/mp3/enemy/snervian_eat_move_2.mp3');
		game.load.audio('e_wo_eat3', 'audio/sfx/mp3/enemy/snervian_eat_move_3.mp3');
		
		////////////////////////////////////////
		//////////////// GRAPHICS //////////////
		////////////////////////////////////////
			
		// tower
		game.load.image('tower', 'img/tower/towerb.png');
		game.load.image('bg00', 'img/tower/layer00.png');
		game.load.image('bg01', 'img/tower/layer01.png');
		game.load.image('bg02', 'img/tower/layer02.png');
		game.load.image('bg03', 'img/tower/layer03.png');
		game.load.image('sky', 'img/tower/sky.png');
		game.load.image('sky2', 'img/tower/sky2.png');
		game.load.image('titan', 'img/tower/titan.png');
		game.load.image('portal', 'img/tower/portal.png');
		game.load.image('shop', 'img/tower/shop.png');
		game.load.spritesheet('enter', 'img/tower/enter.png', 142, 82, 14);
		game.load.spritesheet('portal_dig', 'img/effects/portal_dig.png', 104, 98, 25);
		game.load.spritesheet('portal_surface', 'img/effects/portal_surface.png', 108, 108, 27);
		game.load.spritesheet('radiation', 'img/effects/radiation.png', 92, 92, 9);
		
		// tower upgrades
		for(i=1;i<=15;i++)
		{
			game.load.image('towerup'+i, 'img/tower/upgrades/t'+i+'.png');
		}
		
		// darkness
		game.load.image('dark', 'img/gui/dark.png');
		
		// player
		game.load.image('player_body', 'img/player/player_body.png');
		game.load.image('player_base', 'img/player/player_base.png');
		game.load.spritesheet('drill', 'img/player/drill.png', 64, 64, 2);
		game.load.spritesheet('propeller', 'img/player/propeller2.png', 64, 32, 2);
		game.load.image('smoke', 'img/player/smoke.png');
		game.load.image('shot01', 'img/player/shot01.png');
		game.load.image('shot02', 'img/player/shot02.png');
		game.load.image('shot03', 'img/player/shot03.png');
		game.load.image('shot04', 'img/player/shot04.png');
		game.load.image('shot05', 'img/player/shot05.png');
		game.load.image('drone', 'img/player/drone.png');
		
		for(i=1; i<=5; i++)
		{
			game.load.image('airbag'+i, 'img/player/airbag0'+i+'.png');
		}
		
		// obstacles
		for(i=1; i<=6; i++)
		{
			game.load.image('boulder0'+i, 'img/obstacles/boulder0'+i+'.png');
			game.load.image('boulder0'+i+'_shard', 'img/obstacles/boulder0'+i+'_shard.png');
		}
		
		game.load.spritesheet('portal_ug', 'img/obstacles/portal.png', 72, 72, 4);
		
		// enemies
		game.load.spritesheet('enemy01', 'img/enemies/enemy01b.png', 93, 63, 18);
		game.load.spritesheet('enemy02', 'img/enemies/enemy02.png', 91, 73, 28);
		game.load.spritesheet('enemy03', 'img/enemies/glorg.png', 140, 68, 21);
		game.load.spritesheet('enemy04', 'img/enemies/chrysalis.png', 128, 78, 21);
		game.load.spritesheet('enemy05', 'img/enemies/flarnop.png', 66, 84, 16);
		game.load.spritesheet('enemy06', 'img/enemies/fangora.png', 78, 78, 7);
		game.load.spritesheet('enemy07', 'img/enemies/plant.png', 176, 124, 25);
		game.load.spritesheet('enemy08', 'img/enemies/worm.png', 204, 72, 12);
		
		game.load.spritesheet('poof', 'img/enemies/poof.png', 64, 52, 8);
		game.load.image('perry_row', 'img/enemies/perry_row.png');
		game.load.image('perry', 'img/enemies/perry.png');
		game.load.image('eshot01', 'img/enemies/eshot01.png');
		
		// bosses: tank
		game.load.image('boss01body', 'img/bosses/boss01/body.png');
		game.load.image('boss01body-long', 'img/bosses/boss01/body-long.png');
		game.load.image('boss01body-ext', 'img/bosses/boss01/extension.png');
		game.load.image('boss01canon', 'img/bosses/boss01/canon.png');
		game.load.image('boss01canonB', 'img/bosses/boss01/canon-b.png');
		game.load.image('boss01canonC', 'img/bosses/boss01/canon-c.png');
		game.load.image('boss01turret', 'img/bosses/boss01/turret.png');
		game.load.image('boss01turretB', 'img/bosses/boss01/turret-b.png');
		game.load.image('boss01turretC', 'img/bosses/boss01/turret-c.png');
		game.load.image('boss01shield', 'img/bosses/boss01/shield.png');
		game.load.image('boss01canon-beam', 'img/bosses/boss01/canon-beam.png');
		game.load.image('boss01canon-cap', 'img/bosses/boss01/canon-cap.png');
		game.load.image('boss01drill', 'img/bosses/boss01/drill.png');
		game.load.image('boss01shieldA', 'img/bosses/boss01/shield.png');
		game.load.image('boss01shieldB', 'img/bosses/boss01/shield-b.png');
		game.load.image('boss01shieldC', 'img/bosses/boss01/shield-c.png');
		
		// bosses: gridnok
		game.load.spritesheet('gridnok', 'img/bosses/boss02/gridnok.png', 246, 240, 44);
		
		// bosses: blackfire
		game.load.spritesheet('blackfire', 'img/bosses/boss03/blackfire.png', 256, 272, 54);
		game.load.image('blackfire_laser', 'img/bosses/boss03/laser.png');
		game.load.image('blackfire_wave', 'img/bosses/boss03/wave.png');
		game.load.image('blackfire_boulder', 'img/bosses/boss03/boulder.png');
		game.load.image('blackfire_blast', 'img/bosses/boss03/blast.png');
		game.load.image('blackfire_out', 'img/bosses/boss03/blackfire_out.png');
		
		// water
		game.load.image('pool01', 'img/water/pool01.png');
		game.load.image('pool02', 'img/water/pool02.png');
		
		// tiles (update)
		game.load.image('edge_stone', 'img/tiles/edge_stone.png');
		game.load.image('topsoil', 'img/tiles/topsoil.png');
		
		// back tiles
		for(i=1; i<=4; i++)
		{
			id = 'back0' + i;
			game.load.image(id, 'img/tiles/' + id + '.png');
		}
		
		// top tiles
		for(i=1; i<=3; i++)
		{
			id = 'zone00_plain_0' + i;
			game.load.image(id, 'img/tiles/' + id + '.png');
		}
		
		// depth (all)
		var depthMax = 6;
		for(k=1; k<=depthMax; k++)
		{
			var tList = ['plain','m1','m2','m3','shard','piece','boulder'];
			
			// exceptions: hotspots
			if( (k==3) || (k==6) )
			{
				tList.push('hotspot');
			}
			
			// loop
			for(i=1; i<=5; i++)
			{
				for(j=0; j<tList.length; j++)
				{
					id = 'zone0' + k + '_' + tList[j] + '_0' + i;
					game.load.image(id, 'img/tiles/' + id + '.png');
				}
			}
		}
		
	}

	function create() 
	{
		console.log("create");
		
		// set vars
		var i;
		var j;
		var sprite;
		
		// check for date
		var d = new Date();
		var dstring = '' + (d.getFullYear()) + (d.getMonth()) + (d.getDay());
		if(DEBUG_CASH>0){dstring='reset';}
	    var savedate = localStorage.getItem('last-date');
		var newdate = false;
		if( savedate )
		{
			console.log('has date saved');
			if(savedate==dstring)
			{
				console.log('same date as today');
			}
			else
			{
				console.log('new date!');
				newdate = true;
				localStorage.setItem('last-date', dstring);
			}
		}
		else
		{
			console.log('no date saved, saving');
			newdate = true;
			localStorage.setItem('last-date', dstring);
		}
		
		// check for data
		if(newdate==false)
		{
			var checkMatrix = JSON.parse( localStorage.getItem('row-0') );
			if(checkMatrix)
			{
				console.log('tile matrix loaded');
				loadTileMatrix();
			}
			else
			{
				console.log('no matrix');
				buildTileMatrix();
			}
		}
		else
		{
			console.log('new date, build new matrix');
			
			buildTileMatrix();
			isNewDate = true;
		}
				
		// enable the Arcade Physics system
		var maxHeight = (TILE_WIDTH * MAP_HEIGHT) + HORIZON_Y;
		var maxWidth = (TILE_WIDTH * MAP_WIDTH);
		
		// set game world
	    game.physics.startSystem(Phaser.Physics.ARCADE);
		game.world.setBounds(0, 0, maxWidth, maxHeight);
		game.stage.backgroundColor = 0xc33f24;
				
		// add map layer
		map = game.add.group();
		
		// add darkness
		darkness = game.add.group();
		sprite = game.add.sprite(0, 0, 'dark');
		sprite.anchor.setTo(.5,.5);
		darkness.dark = sprite;
		darkness.add(sprite);
		
		// create background
		buildBackground()
		
		// create backlayer
		backtiles = game.add.group();
		map.add(backtiles);
		
		// create backart
		backart = game.add.group();
		map.add(backart);
		
		// add portals group
	    portals = game.add.group();
	    portals.enableBody = true;
		portals.physicsBodyType = Phaser.Physics.ARCADE;
		map.add(portals);
				
		// player body
		playerg = game.add.group();
	    playerg.enableBody = true;
		map.add(playerg);
		
		player = game.add.sprite(0, 0, 'player_body');		
		game.physics.arcade.enable(player);
		player.body.bounce.y = 0.2;
	    player.body.gravity.y = 500;
		player.body.maxVelocity = MAX_VELOCITY;
	    player.body.collideWorldBounds = true;
		//player.anchor.setTo(.5,.5);
		
		playerg.add(player);
		
		game.camera.follow(player);
		buildCharacter();
		player.alpha = 0;
		
		// add tile group
	    platforms = game.add.group();
	    platforms.enableBody = true;
		map.add(platforms);
		
		// add enemies group
	    enemies = game.add.group();
	    enemies.enableBody = true;
		enemies.physicsBodyType = Phaser.Physics.ARCADE;
		map.add(enemies);
		
		// add boss group
	    bosses = game.add.group();
	    bosses.enableBody = true;
		bosses.physicsBodyType = Phaser.Physics.ARCADE;
		map.add(bosses);
			
		// add bullet group
	    bullets = game.add.group();
	    bullets.enableBody = true;
		bullets.physicsBodyType = Phaser.Physics.ARCADE;
		/*
		bullets.createMultiple(30, 'shot01');
		bullets.setAll('anchor.x', 0.5);
		bullets.setAll('anchor.y', 0.5);
		bullets.setAll('outOfBoundsKill', true);
		bullets.setAll('checkWorldBounds', true);
		*/
		map.add(bullets);
		
		// add enemy bullet group
	    ebullets = game.add.group();
	    ebullets.enableBody = true;
		ebullets.physicsBodyType = Phaser.Physics.ARCADE;
		ebullets.createMultiple(60, 'eshot01');
		ebullets.setAll('anchor.x', 0.5);
		ebullets.setAll('anchor.y', 0.5);
		//ebullets.setAll('outOfBoundsKill', true);
		ebullets.setAll('checkWorldBounds', true);
		map.add(ebullets);
		
		// add water group
	    water = game.add.group();
	   	water.enableBody = true;
		water.physicsBodyType = Phaser.Physics.ARCADE;
		map.add(water);
		
		// add boulder group
	    boulders = game.add.group();
	    boulders.enableBody = true;
		boulders.physicsBodyType = Phaser.Physics.ARCADE;
		map.add(boulders);
			
	    // add first rows
		allTiles = [];
		for(i=0; i<(ROW_LIMIT*.5); i++)
		{
			addRow(i);
		}
		
		// add topsoil
		topTiles = [];
		for(i=0; i<MAP_WIDTH; i++)
		{
			var box = platforms.create( i*64, HORIZON_Y, 'topsoil');
		    box.body.immovable = true;
			box.baseX = box.x;
			box.baseY = box.y;
			box.body.checkCollision.down = false;
			box.body.checkCollision.left = false;
			box.body.checkCollision.right = false;
			box.alpha = 0;
			topTiles[i] = box;
		}
				
		// create effects layer
		effectsLayer = game.add.group();
		map.add(effectsLayer);
		
		// create bonus layer
		bonusLayer = game.add.group();
		map.add(bonusLayer);
		
		// add player properties
		player.id = 'player';
		player.curRow = -1;
		player.curZone = 0;
		player.direction = 1;
		player.bulletReady = true;
		player.inWater = false;
				
		// build gui
		buildGui();
		buildShop();
		buildInstructions();
		
		// add fire button
		fireButton = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
		
		// init
		showSmoke();
		player.x = (maxWidth*.5) + (player.width*.5) - 46;
		player.y = HORIZON_Y - player.height - 6;
		player.alpha = 0;
		player.locked = true;
		player.startX = player.x;
		player.startY = player.y;
		
		// reset boss variables
		tankBodies = [];
		gridnok = null;
		blackfire = null;
		
		// hide title
		TweenMax.to( menus, .5, {delay:0.5, autoAlpha:0, ease:Quad.easeOut});

		// show player
		TweenMax.delayedCall(1.1, exitPlayer);
		
		// start music
		drillTrack = player.audio.drill;
		flyingTrack = player.audio.fly;
		musicTrack = game.add.audio('m_zone0');
   	 	musicTrack.play( '', 0, musicVolume );
		
		// testing: mute
		//game.sound.mute = true;
		
	}

	function update() 
	{
		var i;
		var j;
		var sfx;
		
		// set in water to false 
		player.inWater = false;
		
		// collisions
		game.physics.arcade.collide(boulders, platforms, onBoulderCollision, null, this);
		game.physics.arcade.collide(boulders, boulders, onBoulderCollision, null, this);
		game.physics.arcade.collide(boulders, player, onBoulderCollision, null, this);
		
	    game.physics.arcade.collide(player, platforms, onPlayerCollision, null, this);
		//game.physics.arcade.collide(player, boulders, onPlayerCollision, null, this);
		
		game.physics.arcade.collide(enemies, platforms, onEnemyCollision, null, this);;
		game.physics.arcade.collide(enemies, boulders, onEnemyCollision, null, this);
		
		game.physics.arcade.collide(bosses, platforms, onEnemyCollision, null, this);;
		
		game.physics.arcade.overlap(bullets, platforms, onBulletCollision, null, this);
		game.physics.arcade.overlap(bullets, enemies, onBulletCollision, null, this);
		game.physics.arcade.overlap(bullets, bosses, onBulletCollision, null, this);
		game.physics.arcade.overlap(bullets, boulders, onBulletCollision, null, this);
		
		game.physics.arcade.overlap(ebullets, platforms, onEnemyBulletCollision, null, this);
		game.physics.arcade.overlap(ebullets, playerg, onEnemyBulletCollision, null, this);
		game.physics.arcade.overlap(ebullets, boulders, onEnemyBulletCollision, null, this);
		
		game.physics.arcade.overlap(player, water, onWaterCollision, null, this);
		game.physics.arcade.overlap(player, surface, onSurfaceCollision, null, this);
		game.physics.arcade.overlap(player, bosses, onBossOverlap, null, this);
		game.physics.arcade.overlap(player, portals, onPortalsOverlap, null, this);
		
		// if water, push up
		if( player.inWater )
		{
			//console.log('in water');
			if( player.body.gravity.y == 500 )
			{
				console.log('in water, reset grav');
				PLAYER_SPEED = 200;
				player.body.gravity.y = 100;
				
				background.audio.splash.play('',0,sfxVolume);
				damagePlayer(1);
			}
		}
		else
		{
			if( player.body.gravity.y != 500 )
			{
				if( !player.isWarping && !player.isDead && !player.locked )
				{
					console.log('out water, reset grav');
					PLAYER_SPEED = 300;
					player.body.gravity.y = 500;
					
					background.audio.splash.play('',0,sfxVolume);
				}
			}
		}
		
		// if dead, no grav
		if( player.isDead )
		{
			player.body.gravity.y = 0;
		}
		
		// set player curRow/curCol
		var pCenterX = player.x + (player.width*.5);
		var pCenterY = player.y + (player.height*.5);
		
		var curRow = (pCenterY - HORIZON_Y)/64;
		curRow = Math.floor(curRow);
		if( curRow < -1 ){ curRow=-1 }
		
		var curCol = pCenterX/64;
		curCol = Math.floor(curCol);
		if( curCol < 0){ curCol = 0}
		
		// check for new row
		if( (curRow != player.curRow) && (!player.isWarping) )
		{
			// check zone audio
			var curZone = Math.floor(curRow/ZONE_MARK)+1;
			if( curRow<0 ){ curZone=0; }
			if( curZone>6 ){ curZone=6; }
			
			if( curZone != player.curZone )
			{
				// music
				musicTrack.stop();
				musicTrack = game.add.audio('m_zone' + curZone );
		   	 	musicTrack.play('',0,musicVolume);
				
				
				// sfx
				if( curZone > player.curZone )
				{
					sfx = game.add.audio('p_gobelow' );
				}
				if( curZone < player.curZone )
				{
					sfx = game.add.audio('p_goabove' );
				}
				sfx.play('',0,sfxVolume);
					
				// save zone
				player.curZone = curZone;
				
			}
			
			swapRows(curRow);
		}
		
		// check for surface
		if( (player.y > (HORIZON_Y-player.height-4) ) && (player.y < (HORIZON_Y-player.height+4) ) )
		{
			if( topTiles[0].isOn==false )
			{
				for(i=0; i<topTiles.length; i++)
				{
					topTiles[i].reset( topTiles[i].baseX, topTiles[i].baseY );
					topTiles[i].isOn = true;
				}
			}
		}
		
		// save row and col
		player.curRow = curRow;
		player.curCol = curCol;
				
		// get cursor input
		cursors = game.input.keyboard.createCursorKeys();
				
		// check for player freeze
		if(player.locked)
		{
			cursors.left.isDown = false;
			cursors.right.isDown = false;
			cursors.down.isDown = false;
			cursors.up.isDown = false;
			fireButton.isDown = false;
		}
		
		// reset the players velocity (movement)
		if( (player.curZone==6) && (player.body.touching.down) )
		{
			  player.body.velocity.x *= .7;
		}
		else
		{
			 player.body.velocity.x = 0;
		}
		
		// check falling speed
		player.lastVY = player.body.velocity.y;
		if(player.body.velocity.y > TERMINAL_VELOCITY)
		{
			player.body.velocity.y = TERMINAL_VELOCITY;			
		}
		
		// check for airbag
		if(player.body.velocity.y > AIRBAG_VELOCITY)
		{
			player['airbag'+ ( stats['airbag']+1 ) ].alpha = 1;
		}
		else
		{
			player['airbag'+ ( stats['airbag']+1 ) ].alpha = 0;
		}
		
		// check for powerups
		var speedMod = 1;
		if( (gui.powerup1.isActive) )
		{
			if( gui.powerup1.info.name=='Nitro Canisters' )
			{
				speedMod=2;
			}
		}
		if( (gui.powerup2.isActive) )
		{
			if( gui.powerup2.info.name=='Nitro Canisters' )
			{
				speedMod=2;
			}
		}

		// key input (arrows)
	    if(cursors.left.isDown)
	    {
	        //  Move to the left
	        player.body.velocity.x = -PLAYER_SPEED*speedMod;
			player.direction = -1;
	    }
	    else if (cursors.right.isDown)
	    {
	        //  Move to the right
	        player.body.velocity.x = PLAYER_SPEED*speedMod;
			player.direction = 1;
	    }
	    else
	    {
	        //  Stand still
	        //player.animations.stop();
	    }
				
		// check firing
		if( fireButton.isDown )
		{
			fireWeapon()
		}
		
		// check topsoil hide
		if(cursors.down.isDown)
		{
			if( (player.y > (HORIZON_Y-player.height-4) ) && (player.y < (HORIZON_Y-player.height+4) ) )
			{
				for(i=0; i<topTiles.length; i++)
				{
					topTiles[i].kill();
					topTiles[i].isOn = false;
				}
			}
		}
		
		// check drilling
		if( cursors.down.isDown )
		{
			checkDrill('down');
			
			player.drill.scale.x = 1;
			player.drill.alpha = 1;
			player.drill.angle = -90;
			player.drill.x = -6;
			player.drill.y = 111;
			player.drill.img.animations.play('drill', 48, true);
			player.isDrilling = true;
		}
		else if( cursors.left.isDown )
		{
			checkDrill('left');
			
			player.drill.scale.x = 1
			player.drill.angle = 0;
			player.drill.alpha = 1;
			player.drill.x = -52;
			player.drill.y = 0;
			player.drill.img.animations.play('drill', 48, true);
			player.isDrilling = true;			
		}
		else if( cursors.right.isDown )
		{
			checkDrill('right');
			
			player.drill.angle = 0;
			player.drill.scale.x = -1
			player.drill.alpha = 1;
			player.drill.x = 102;
			player.drill.y = 0;			
			player.drill.img.animations.play('drill', 48, true);
			player.isDrilling = true;
		}
		else if(cursors.up.isDown)
		{
			checkDrill('up');
			
			player.drill.scale.x = 1;
			player.drill.alpha = 0;
			player.drill.angle = 0;
			player.drill.x = 0;
			player.drill.y = 0;
			player.drill.img.animations.stop(null, true);
			player.isDrilling = false;	
		}
		else
		{
			player.drill.scale.x = 1;
			player.drill.alpha = 0;
			player.drill.angle = 0;
			player.drill.x = 0;
			player.drill.y = 0;
			player.drill.img.animations.stop(null, true);
			player.isDrilling = false;
			player.isFlying = false;
		}
		
		// check flying
		if(cursors.up.isDown)
		{
			player.isFlying = true;
		}
		else
		{
			player.isFlying = false;
		}
		
		// hide drill w/o fuel
		if(player.fuel==0)
		{
			player.drill.alpha = 0;
		}

	    // allow the player to fly ( if they are touching the ground ).
	    if (cursors.up.isDown )//&& player.body.touching.down)
	    {
	        player.body.velocity.y = -PLAYER_SPEED*speedMod;
			player.prop.img.animations.play('spin', 48, true);
	    }
		else
		{
			player.prop.img.animations.stop('spin',0);
		}
		
		// checks enemies
		checkEnemies();
		checkBosses();
		checkWater();
		checkPortals();
		
		// check exit shops/portal
		if( player.exitTower )
		{
			var dx,dy,dt1,dt2,dt3;
			
			// dist from tower
			dx = player.x - surface.tower.x;
			dy = player.y - surface.tower.y;
			dt1 = Math.sqrt( (dx*dx)+(dy*dy) );
			
			// dist from upgrade door
			dx = player.x - (powerupDoor.x+46);
			dy = player.y - (powerupDoor.y);
			dt2 = Math.sqrt( (dx*dx)+(dy*dy) );
			
			// dist from upgrade door
			dx = player.x - (surface.portal.x);
			dy = player.y - (surface.portal.y);
			dt3 = Math.sqrt( (dx*dx)+(dy*dy) );
			
			if( (dt1>80) && (dt2>80) && (dt3>100) )
			{
				player.exitTower = false;
				restoreSurface();
			}
			
		}
		
		// lax?
		background.layer01.x = game.camera.x*0.3;
		background.layer02.x = game.camera.x*0.5;
		background.layer00.x = game.camera.x*0.55;
		background.sky.x = (game.camera.x*0.7)-600;
		
		// check drone
		if(player.drone.alpha==1)
		{
			checkDrone();
		}
		
		// check hotspots
		var rmin = player.curRow - 1;
		var rmax = player.curRow + 1;
		var dx,dy,dt;
		if(rmin<0){rmin=0;}
		if(rmax>MAP_HEIGHT){rmax=MAP_HEIGHT;}

		for(i=rmin; i<=rmax; i++)
		{
			if( allTiles[i] )
			{
				for( j=0; j<allTiles[i].length; j++)
				{
					if( allTiles[i][j].isHotspot )
					{
						dx = allTiles[i][j].x - player.x;
						dy = allTiles[i][j].y - player.y;
						dt = Math.sqrt((dx*dx)+(dy*dy));
						if(dt<100)
						{
							damagePlayer(1);
						}
					}
				}
			}
		}
		
		// check light
		//checkLighting();
		
		// music loop hacks
		if( (!musicTrack.isPlaying) && (!player.isDead) )
		{
			musicTrack.play('',0,1);  
		}
		else
		{
			//console.log('music playing');
		}
		
		// drill loop hack
		if( (drillTrack) && (!drillTrack.isPlaying) && (player.isDrilling) )
		{
			//console.log('drilling');
			drillTrack.play('',0,sfxVolume);
		}
		if( (drillTrack) && (drillTrack.isPlaying) && (!player.isDrilling) )
		{
			drillTrack.stop();
			
		}
		
		// flying loop hack
		if( (flyingTrack) && (!flyingTrack.isPlaying) && (player.isFlying) )
		{
			//console.log('drilling');
			flyingTrack.play('',0,sfxVolume);
		}
		if( (flyingTrack) && (flyingTrack.isPlaying) && (!player.isFlying) )
		{
			flyingTrack.stop();
		}
		
	}
	
	function render() 
	{
	    //game.debug.cameraInfo(game.camera, 32, 32);
	    //game.debug.spriteCoords(player, 32, 300);
		
		// set player
		player.art.x = player.x;
		player.art.y = player.y;
		
		// set darkness
		darkness.dark.x = player.x+16;
		darkness.dark.y = player.y;

		//var newA = ( player.curRow/( (FULL_DEPTH*.5) - ( ZONE_MARK*DEPTH_MARK*0 ) ) );
		var newA = player.curRow/( ZONE_MARK*2 );
		newA -= ( .6 * stats['lantern'] );
		newA -= .1;
		if( stats['lantern']==4 )
		{
			newA = 0;
		}
		
		if(newA<0){newA=0;}
		darkness.dark.alpha = newA;

		// test enemy
		if(testEnemy)
		{
			//game.debug.bodyInfo(testEnemy, 10, 80);
			//game.debug.body(testEnemy);
		}
		
		// test tank
		if(tankBodies)
		{
			var i;
			for(i=0; i<tankBodies.length; i++)
			{
				//game.debug.body(tankBodies[i]);
			}
		}
		
		//game.debug.body(player);
	}
	
	//--------------------------- ENGINE METHODS:
	
	function checkLoadProgress()
	{
		// show loading:
		if( game.load.progress < 100 )
		{
			titleMenu.per.innerHTML = game.load.progress + '%';
		}
		else if(titleMenu.per.innerHTML!='100%')
		{
			titleMenu.txt.innerHTML = 'BOOYAH!';
			titleMenu.per.innerHTML = '100%';
			clearInterval(loadInterval);
		}
	}
	
	function resumePlayer()
	{
		console.log('resume player');
		
		door.frame = 13;
		player.art.alpha = 1;
		player.exitTower = true;
		
		if( isNewDate )
		{
			console.log('new date, launch instructions');
			
			isNewDate = false;
			showInstructions();
		}
		else
		{
			console.log('old date, unlock player');
			
			player.locked = false;
		}
	}
	
	function resetEngine()
	{
		console.log('reset');
		
		player.isDead = true;
		musicTrack.stop();
		storeTileMatrix();
		
		cont.removeChild( holder );
		cont.removeChild( gui );
		TweenMax.killAll();
		
		TweenMax.delayedCall( 1.0 , Main.init );
	}
	
	function bypassSafariCORSLameness()
	{
		console.log('check bypass...');
		
		var LoaderProto = Phaser.Loader.prototype;
		var ua = navigator.userAgent;
		var isSafari = /safari/i.test(ua) && !/chrome/i.test(ua);
		if (!isSafari || LoaderProto.originalXhrLoad) return;

		console.log("Monkeypatching Phaser.Loader to bust cache");
		LoaderProto.originalXhrLoad = LoaderProto.xhrLoad;
		LoaderProto.xhrLoad = function(index, url, type, onload, onerror) 
		{
			url = url + '?cacheBust=' + Date.now();
			return this.originalXhrLoad(index, url, type, onload, onerror);
		};
		
	}
	
	//--------------------------- matrix methods:

	function buildTileMatrix()
	{
		console.log('building new matrix');
		
		// set vars
		var i;
		var j;
		var sprite;
		var tileRow;
		
		// pull date seed
		var d = new Date();
		var dstring = '' + (d.getFullYear()) + (d.getMonth()) + (d.getDay());
	    var dnum = Number(dstring);
		game.rnd.sow( dstring );
		
		// build new tile matrix
		tileMatrix = [];
		for(i=0; i<MAP_HEIGHT; i++)
		{
			tileRow = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				var rand = game.rnd.frac();
				rand = Number(rand.toString().match(/^\d+(?:\.\d{0,2})?/));
				if(rand==0)
				{
					rand = .01
				}
				
				tileRow[j] = rand;
				
				if(i==0)
				{
					tileRow[j] = 1;
				}
			}
			tileMatrix[i] = tileRow;
		}
		
		// build back matrix
		backMatrix = [];
		for(i=0; i<MAP_HEIGHT; i++)
		{
			tileRow = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				var rand = game.rnd.integerInRange(1, 4);
				tileRow[j] = rand;
			}
			backMatrix[i] = tileRow;
		}
		
		// build enemy matrix
		enemyMatrix = [];
		for(i=0; i<MAP_HEIGHT; i++)
		{
			tileRow = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				tileRow[j] = 0;
			}
			enemyMatrix[i] = tileRow;
		}
		
		// build water matrix
		waterMatrix = [];
		for(i=0; i<MAP_HEIGHT; i++)
		{
			tileRow = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				tileRow[j] = 0;
			}
			waterMatrix[i] = tileRow;
		}
		
		// add enemy caverns
		var curRow;
		var curCol;
		var offSet = 2;
		var enNum = 1;
		
		var eSet = [];
		var curZone = 0;
		
		for(i=2; i<(MAP_HEIGHT-16); i++)
		{
			if( (i%5) == 0 )
			{	
				if(offSet==2)
				{
					offSet = 0;
				}
				else
				{
					offSet = 2;
				}	
						
				for(j=0; j<4; j++)
				{
					curCol = 2 + (j*8);
					
					if(j%2==0)
					{
						// get enemy by zone
						curZone = Math.floor(i/ZONE_MARK)+1;
						if( curZone==1 ){ eSet = [1,1,2]; }
						if( curZone==2 ){ eSet = [1,2,2]; }
						if( curZone==3 ){ eSet = [2,1,3]; }
						if( curZone==4 ){ eSet = [3,2,4]; }
						if( curZone==5 ){ eSet = [4,6,5]; }
						if( curZone==6 ){ eSet = [6,5,8]; }
						
						enNum = eSet[ Math.floor( Math.random()*eSet.length ) ];
						buildEnemyCavern(i, curCol+offSet, enNum );
					}
					else
					{
						buildWaterCavern(i, curCol+offSet );
					}
					
				}
			}
		}
		
		// test enemy
		//buildEnemyCavern(2, 16, 8, true);
		
		// add water caverns
		//buildWaterCavern(1,16);
		
		////////////////////////
		///// ADD BOSSES ///////
		////////////////////////
		
		// splice in boss cavern 1
		var bc = buildBossCavern();
		var startRow = tankStartRow;
		for(i=0; i<bc.length; i++)
		{
			tileMatrix.splice( startRow+i, 0, bc[i] );
			
			// add empty enemy matrix
			var nullM = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				nullM[j] = 0;
			}
			enemyMatrix.splice( startRow+i, 0, nullM );
			waterMatrix.splice( startRow+i, 0, nullM );
		}
		enemyMatrix[startRow+9][26] = 101;
		
		// splice in boss cavern 2
		var bc = buildBossCavern();
		var startRow = gridnokStartRow;
		for(i=0; i<bc.length; i++)
		{
			tileMatrix.splice( startRow+i, 0, bc[i] );
			
			// add empty enemy matrix
			var nullM = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				nullM[j] = 0;
			}
			enemyMatrix.splice( startRow+i, 0, nullM );
			waterMatrix.splice( startRow+i, 0, nullM );
		}
		enemyMatrix[startRow+11][26] = 201;
		
		// splice in boss cavern 3
		var bc = buildBossCavern();
		var startRow = blackfireStartRow;
		for(i=0; i<bc.length; i++)
		{
			tileMatrix.splice( startRow+i, 0, bc[i] );
			
			// add empty enemy matrix
			var nullM = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				nullM[j] = 0;
			}
			enemyMatrix.splice( startRow+i, 0, nullM );
			waterMatrix.splice( startRow+i, 0, nullM );
		}
		enemyMatrix[startRow+11][26] = 301;
		
		// store tile matrix
		TweenMax.delayedCall( 2.0, storeTileMatrix );
	}
	
	function loadTileMatrix()
	{
		console.log('load matrix');
		
		var i;
		var j;
		var rowLimit = MAP_HEIGHT;
		var myObject;
		
		// tile matrix
		tileMatrix = [];
		backMatrix = [];
		enemyMatrix = [];
		waterMatrix = [];
		
		for(i=0; i<rowLimit; i++)
		{
			myObject = JSON.parse( localStorage.getItem('row-'+i) );
			tileMatrix[i] = myObject;
			
			myObject = JSON.parse( localStorage.getItem('back-'+i) );
			backMatrix[i] = myObject;
			
			myObject = JSON.parse( localStorage.getItem('enemy-'+i) );
			enemyMatrix[i] = myObject;
			
			myObject = JSON.parse( localStorage.getItem('water-'+i) );
			waterMatrix[i] = myObject;
		}		
	}
	
	function storeTileMatrix()
	{
		console.log('store matrix');
		
		var ua = navigator.userAgent;
		var isSafari = /safari/i.test(ua) && !/chrome/i.test(ua);
		if( isSafari )
		{
			storeTileMatrixSafari();
			return;
		}
		
		var i;
		var j;
		var rowLimit = MAP_HEIGHT;
		
		// all matrix:
		for(i=0; i<rowLimit; i++)
		{
			localStorage.setItem('row-'+i, JSON.stringify( tileMatrix[i] ));
			localStorage.setItem('back-'+i, JSON.stringify( backMatrix[i] ));
			localStorage.setItem('enemy-'+i, JSON.stringify( enemyMatrix[i] ));
			localStorage.setItem('water-'+i, JSON.stringify( waterMatrix[i] ));
		}
		
		//console.log('store matrix completed');
	}
	
	function storeTileMatrixSafari()
	{
		console.log('store matrix safari');

		var i;
		var j;
		var rowLimit = MAP_HEIGHT;
		
		// Not sure why, but when I try to store all 620 rows
		// at once, Safari times out.  If I do 200 rows at a 
		// time (2 seconds apart), it doesn't.  Hack.
		
		TweenMax.delayedCall( 0.0, storeMatrixSet, [0,200] );
		TweenMax.delayedCall( 2.0, storeMatrixSet, [201,400] );
		TweenMax.delayedCall( 4.0, storeMatrixSet, [401,620] );
	}
	
	function storeMatrixSet(min, max)
	{
		for(i=min; i<max; i++)
		{
			localStorage.setItem('row-'+i, JSON.stringify( tileMatrix[i] ));
			localStorage.setItem('back-'+i, JSON.stringify( backMatrix[i] ));
			localStorage.setItem('enemy-'+i, JSON.stringify( enemyMatrix[i] ));
			localStorage.setItem('water-'+i, JSON.stringify( waterMatrix[i] ));
		}
	}
	
	function checkLighting()
	{
		var i;
		var t;
		var dx;
		var dy;
		var dt;
		
		for(i=0; i<platforms.children.length; i++)
		{
			t = platforms.children[i];
			dx = t.x-player.x;
			dy = t.y-player.y;
			dt = Math.sqrt( (dx*dx)+(dy*dy) );
			
			if( dt>256 )
			{
				t.tint = 0x444444;
			}
			else if(dt>128)
			{
				t.tint = 0x999999;
			} 
			else
			{
				t.tint = 0xffffff;
			}
		}
		
		for(i=0; i<backtiles.children.length; i++)
		{
			t = backtiles.children[i];
			dx = t.x-player.x;
			dy = t.y-player.y;
			dt = Math.sqrt( (dx*dx)+(dy*dy) );
			
			if( dt>256 )
			{
				t.tint = 0x444444;
			}
			else if(dt>192)
			{
				t.tint = 0x666666;
			}
			else if(dt>128)
			{
				t.tint = 0x888888;
			} 
			else
			{
				t.tint = 0xffffff;
			}
		}
	}
	
	//--------------------------- BACKGROUND METHODS:

	function buildBackground()
	{
		background = game.add.group();
		map.add(background);
		
		var img;
		var i;
		
		/*
		img = game.add.sprite(0, 0, 'sky');
		img.x = 0;
		img.y = 0;
		img.height = HORIZON_Y;
		img.width  = TILE_WIDTH * MAP_WIDTH;
		background.add( img );
		*/
		
		img = game.add.sprite(0, 0, 'sky2');
		img.x = 0;
		img.y = 0;
		background.add( img );
		background.sky = img;
		
		img = game.add.sprite(0, 0, 'bg00');
		img.x = 0;
		img.y = HORIZON_Y - img.height - 90;
		background.add( img );
		background.layer00 = img;
		
		img = game.add.sprite(0, 0, 'bg02');
		img.x = 0;
		img.y = HORIZON_Y - img.height - 90;
		background.add( img );
		background.layer02 = img;
		
		img = game.add.sprite(0, 0, 'bg01');
		img.x = 0;
		img.y = HORIZON_Y - img.height - 20;
		background.add( img );
		background.layer01 = img;
		
		img = game.add.sprite(0, 0, 'bg03');
		img.x = 0;
		img.y = HORIZON_Y - img.height;
		background.add( img );
		background.layer03 = img;
		
		img = game.add.sprite(0, 0, 'shop');
		img.x = 1733;
		img.y = HORIZON_Y - img.height + 2;
		background.add( img );
		
		img = game.add.sprite(0, 0, 'titan');
		img.x = 84;
		img.y = HORIZON_Y - img.height + 2;
		background.add( img );
		
		img = game.add.sprite(0, 0, 'portal');
		img.x = 358;
		img.y = HORIZON_Y - img.height + 2;
		background.add( img );
		
		// tower image (by upgrade level)
		var grp = game.add.group();
		background.tower = grp;
		background.add(grp);
		
		img = game.add.sprite(0, 0, 'towerup' + (settings.towerLevel+5));
		img.x = (TILE_WIDTH*MAP_WIDTH*.5)-(img.width*.5) + 6;
		img.y = HORIZON_Y - img.height + 6;
		background.tower.add( img );
		background.tower.img = img;
		
		// tower placeholder
		img = game.add.sprite(0, 0, 'tower');
		img.x = (TILE_WIDTH*MAP_WIDTH*.5)-(img.width*.5);
		img.y = HORIZON_Y - img.height;
		img.alpha = 0;
		background.add( img );
		
		// door: tower
		var sprite = game.add.sprite(0, 0, 'enter');
		sprite.x = img.x + 233;
		sprite.y = HORIZON_Y - sprite.height;
		sprite.animations.add('enter', [0,1,2,3,4,5,6,7,8,9,10,11,12,13]);
		sprite.animations.add('exit', [13,12,11,10,9,8,7,6,5,4,3,2,1,0,0,13]);
		sprite.frame = 13;
		background.add( sprite );
		door = sprite;
		
		// door: powerups
		var sprite = game.add.sprite(0, 0, 'enter');
		sprite.x = 1800;
		sprite.y = HORIZON_Y - sprite.height;
		sprite.animations.add('enter', [0,1,2,3,4,5,6,7,8,9,10,11,12,13]);
		sprite.animations.add('exit', [13,12,11,10,9,8,7,6,5,4,3,2,1,0,0,13]);
		sprite.frame = 13;
		background.add( sprite );
		powerupDoor = sprite;
		
		// surface colliders
		surface = game.add.group();
	    surface.enableBody = true;
		surface.physicsBodyType = Phaser.Physics.ARCADE;
		surface.alpha = 0;
		map.add(surface);
		
		img = game.add.sprite(0, 0, 'player_body');
		img.width = 16;
		img.height = 16;
		img.x = door.x+62;
		img.y = door.y+50;
		img.alpha = 0;
		img.id = 'shop';
		surface.add( img );
		surface.tower = img;
		
		img = game.add.sprite(0, 0, 'player_body');
		img.width = 16;
		img.height = 16;
		img.x = powerupDoor.x+62;
		img.y = powerupDoor.y+50;
		img.alpha = 0;
		img.id = 'powerup';
		surface.add( img );
		surface.powerups = img;
		
		img = game.add.sprite(0, 0, 'player_body');
		img.width = 8;
		img.height = 16;
		img.x = 414;
		img.y = powerupDoor.y+50;
		img.alpha = .0;
		img.id = 'portal';
		surface.add( img );
		surface.portal = img;
		
		// add world sounds
		background.audio = [];
		background.audio.dig1 = game.add.audio('o_dig1' );
		background.audio.dig2 = game.add.audio('o_dig1' );
		background.audio.dig3 = game.add.audio('o_dig1' );
		background.audio.dig4 = game.add.audio('o_dig1' );
		background.audio.pickup1 = game.add.audio('u_pickup1' );
		background.audio.pickup2 = game.add.audio('u_pickup2' );
		background.audio.pickup3 = game.add.audio('u_pickup3' );
		background.audio.pickup4 = game.add.audio('u_pickup4' );
		background.audio.pickup5 = game.add.audio('u_pickup5' );
		background.audio.pickup6 = game.add.audio('u_pickup6' );
		background.audio.bossStart = game.add.audio('m_boss_start' );
		background.audio.bossEnd = game.add.audio('m_boss_end' );
		
		background.audio.boulder = game.add.audio('o_boulder' );
		background.audio.splash = game.add.audio('o_splash' );
		background.audio.radioactive = game.add.audio('o_radioactive' );
	}
	
	function enterPlayer()
	{
		// save data
		storeTileMatrix();
		
		// show player
		surface.alpha = 0;
		player.locked = true;
		player.body.y = player.startY;
		player.body.gravity.y = 0;
		player.body.velocity.x = 0;
		player.body.velocity.y = 0;
		player.art.alpha = 0;
		
		// choose door
		if( curShop=='shop' )
		{
			player.body.x = player.startX;
			door.animations.play('enter', 24, false);
		}
		else
		{
			player.body.x = powerupDoor.x+46;
			powerupDoor.animations.play('enter', 24, false);
		}
		
		// show shop menu
		TweenMax.delayedCall(.7, showShopMenu);
		
		player.audio.door.play('',0,sfxVolume);
	}
	
	function exitPlayer()
	{
		// reset values
		player.fuel = PLAYER_FUEL;
		player.health = PLAYER_HEALTH;
		
		// choose door
		if( curShop=='shop' )
		{
			door.animations.play('exit', 24, false);
			player.collected = [];
			player.storage = 0;
			setGuiStorage();
			
			// set stats
			var list = ['drill','hull','fuel','storage','weapons','engine','airbag','lantern'];
			for(i=0; i<list.length; i++)
			{
				setStats( list[i] );
			}
		}
		else
		{
			console.log('powerups exit');
			powerupDoor.animations.play('exit', 24, false);
		}
		
		// set fuel gui
		setGuiFuel();
		
		// exit animation
		player.audio.door.play('',0,sfxVolume);
		
		// remove all boss room locks:
		var col,row;
		for(i=16; i<=18; i++)
		{
			col = i;
			
			// tank
			row = (tankStartRow)+7;
			if( tileMatrix[row] )
			{
				tileMatrix[row][col] = 0;
			}
			
			// gridnok
			row = (gridnokStartRow)+7;
			if( tileMatrix[row] )
			{
				tileMatrix[row][col] = 0;
			}
			
			// blackfire
			row = (blackfireStartRow)+7;
			if( tileMatrix[row] )
			{
				tileMatrix[row][col] = 0;
			}
		}
		
		// resume player
		TweenMax.delayedCall(0.5, resumePlayer);
		
		// for testing
		//setDialogues('raven');
	}
	
	function onSurfaceCollision( player, surf )
	{
		if( (surf.id == 'shop') && (surface.alpha==1) )
		{
			curShop = 'shop';
			enterPlayer();
		}
		if( (surf.id == 'powerup') && (surface.alpha==1) )
		{
			curShop = 'powerups';
			enterPlayer();
		}
		if( (surf.id == 'portal') && (surface.alpha==1) && (settings.warpDialogue) )
		{
			if( !player.isWarping )
			{
				curWarp = 'surface';
				warpPlayer( lastWarpRow, lastWarpCol);
			}
			else
			{
				surface.alpha = 0;
				player.exitTower = true;
			}
		}
		
	}
	
	function restoreSurface()
	{
		player.body.gravity.y = 500;
		surface.alpha = 1;
		surface.portal.x = 414;
	}
	
	function onPortalsOverlap( player, portal )
	{
		if(player.isWarping){return;}
		
		lastWarpCol = portal.col;
		lastWarpRow = portal.row;
		
		curWarp = portal;
		warpPlayer(-1,6);
	}
	
	function checkPortals()
	{
		var i;
		var e;
		var erow;
		var prow;
		var dx;
		
		for(i=(portals.children.length-1); i>=0; i--)
		{
			e = portals.children[i];
			erow = Math.floor ( (e.y-HORIZON_Y)/64 );
			prow = Math.floor ( (player.y-HORIZON_Y)/64 );
			
			// remove
			if( Math.abs(erow-prow) >= 15 )
			{
				console.log( 'portal out of range: remove' );
				e.destroy();
			}
			
		}
	}
	
	//--------------------------- PLAYER METHODS:

	function buildCharacter()
	{
		var grp = game.add.group();
		map.add(grp);
		
		// drill
		var drill = game.add.group();
		sprite = game.add.sprite(0, 0, 'drill');
		sprite.animations.add('drill');
		sprite.animations.play('drill', 24, true);
		drill.add( sprite );
		drill.img = sprite;
		drill.alpha = 1;
		grp.add(drill);
		player.drill = drill;
		
		// prop
		var prop = game.add.group();
		sprite = game.add.sprite(0, 0, 'propeller');
		sprite.animations.add('spin');
		prop.add( sprite );
		prop.img = sprite;
		prop.alpha = 1;
		grp.add(prop);
		player.prop = prop;
		prop.x = -7;
		prop.y = -16;
		
		// airbags
		var img;
		var i;
		for(i=1; i<=5; i++)
		{
			img = game.add.sprite(0, 0, 'airbag'+i);
			img.x = 3;
			img.y = 59;
			img.alpha = 0;
			grp.add( img );
			player['airbag'+i] = img;
		}
		
		// base
		var img;
		img = game.add.sprite(0, 0, 'player_base');
		grp.add( img );
		player.base = img;
		
		player.art = grp;
		player.art.alpha = 0;
		
		// add drone
		img = game.add.sprite(0, 0, 'drone');
		grp.add( img );
		player.drone = img;
		hoverDroneX();
		hoverDroneY();
		player.drone.fireReady = true;
		player.drone.alpha = 0;
		
		// audio
		player.audio = [];
		player.audio.enterPortal = game.add.audio('p_enterPortal' );
		player.audio.exitPortal = game.add.audio('p_exitPortal' );
		player.audio.door = game.add.audio('p_door' );
		player.audio.death = game.add.audio('p_death' );
		player.audio.full = game.add.audio('p_full' );
		player.audio.empty = game.add.audio('p_empty' );
		player.audio.shot1 = game.add.audio('w_shot1' );
		player.audio.shot2 = game.add.audio('w_shot2' );
		player.audio.shot3 = game.add.audio('w_shot3' );
		player.audio.drill = game.add.audio('p_drill' );
		player.audio.fly = game.add.audio('p_fly' );
		player.audio.damage = game.add.audio('p_damage' );
	}

	function showSmoke()
	{
		if(player.inWater)
		{
			TweenMax.delayedCall(.05, showSmoke);
			return;
		}
		if(player.art.alpha==0)
		{
			TweenMax.delayedCall(.05, showSmoke);
			return;
		}
		
		var smoke = game.add.sprite(0, 0, 'smoke');
		smoke.x = player.x + (player.width*.5) - 10;
		smoke.y = player.y - 0;
		smoke.alpha = .8;
		
		var randX = ((Math.random() * 10) - 5);
		smoke.x += randX;
		
		var randS = (Math.random() * .5) + .5;
		smoke.scale.setTo(randS);
		
		backtiles.add( smoke );
		
		TweenMax.to( smoke, .7, {y:smoke.y-40, alpha:0, 
								 scale:smoke.scale*1.5, 
								 easing:Quad.easeOut, 
								 onComplete:removeImg, 
								 onCompleteParams:[smoke]});
		
		
		TweenMax.delayedCall(.05, showSmoke);
	}
	
	function fireWeapon()
	{
		if(player.bulletReady==false){ return; }
		
		/*
		bullet = bullets.getFirstExists(false);
        if(bullet)
        {
            //  And fire it
			player.bulletReady = false;
			var newX = (player.x + (player.width*.5)) + (20 * player.direction);
			var newY = (player.y + (player.height*.5));
			bullet.damage = PLAYER_DAMAGE;
            bullet.reset( newX, newY );
            bullet.body.velocity.x = BULLET_SPEED * player.direction;
			TweenMax.delayedCall( BULLET_DELAY, restoreBulletReady);
        }*/
		
		var newX = (player.x + (player.width*.5)) + (20 * player.direction);
		var newY = (player.y + (player.height*.5));
		
		var bullet = game.add.sprite(newX, newY, 'shot0' + (stats['weapons']+1) );
		bullet.anchor.setTo(.5,.5);		
		game.physics.arcade.enable(bullet);
		bullet.body.outOfBoundsKill = true;
		bullet.body.checkWorldBounds = true;
		
		bullet.damage = PLAYER_DAMAGE;
        bullet.body.velocity.x = BULLET_SPEED * player.direction;		
		bullets.add(bullet);
		
		player.bulletReady = false;
		TweenMax.delayedCall( BULLET_DELAY, restoreBulletReady);
		TweenMax.delayedCall( 2.0, removeImg, [bullet]);
		
		// audio
		var randA = Math.floor(Math.random()*3)+1;
		player.audio['shot'+randA].play('',0,sfxVolume);
	}
	
	function restoreBulletReady()
	{
		player.bulletReady = true;
	}
	
	function setStats(mode)
	{
		var level = stats[mode];
		
		if(mode=='drill')
		{
			DRILL_POWER = statSettings.drill[ level ];
		}
		if(mode=='hull')
		{
			PLAYER_HEALTH = statSettings.health[ level ];
		}
		if(mode=='fuel')
		{
			PLAYER_FUEL = statSettings.fuel[ level ];
		}
		if(mode=='weapons')
		{
			PLAYER_DAMAGE = statSettings.weapons[ level ];
			BULLET_DELAY= statSettings.fireRate[ level ];
		}
		if(mode=='storage')
		{
			PLAYER_STORAGE = statSettings.storage[ level ];
		}
		if(mode=='engine')
		{
			PLAYER_SPEED = statSettings.engine[ level ];
		}
		
		setGuiMeters();
	}
	
	function damagePlayer(dmg)
	{
		//testing:
		//if(1==1){return;}
		
		console.log('damage player', player.health);
		
		//if( player.health<=0 ){ killPlayer();return; }
		if( player.isDamaged ){ console.log('is damaged');return; }
		if( player.isDead ){ console.log('is dead'); return; }
		if( player.isWarping ){ console.log('is warping');return; }
		
		// check for powerups
		if( (gui.powerup1.isActive) )
		{
			if( gui.powerup1.info.name=='Quantum Shielding' )
			{
				dmg = Math.floor(dmg*.5);
				if(dmg==0){return;}
			}
		}
		if( (gui.powerup2.isActive) )
		{
			if( gui.powerup2.info.name=='Quantum Shielding' )
			{
				dmg = Math.floor(dmg*.5);
				if(dmg==0){return;}
			}
		}
		
		// damage player
		player.base.tint = 0xff00ff;
		TweenMax.delayedCall(.2, resetPlayerTint, [player.base] );

		if( player.health > 0 )
		{
			player.health-=dmg;
			
			// reset hearts
			var h,p,i;
			 
			for(i=0; i<8; i++)
			{
				h = gui.hearts['h'+i];
				TweenMax.to( h.heart1, 0, {alpha:1} );
				TweenMax.to( h.heart3, 0, {alpha:0} );
				TweenMax.to( h.heart5, 0, {alpha:0} );
			}
			
			// set hearts
			var pNum = 1;
			var hNum = 0;
			for(i=1; i<=player.health; i++)
			{
				h = gui.hearts['h'+hNum];
				
				if( pNum==1 )
				{
					TweenMax.to( h.heart1, 0, {alpha:0} );
					TweenMax.to( h.heart3, 0, {alpha:1} );
				}
				if( pNum==2 )
				{
					TweenMax.to( h.heart3, 0, {alpha:0} );
					TweenMax.to( h.heart5, 0, {alpha:1} );
				}
				
				pNum++;
				if(pNum==3)
				{
					hNum++;
					pNum=1;
				}
				
			}
			
			// audio
			player.audio.damage.play('',0,sfxVolume);
		}
		
		if( player.health <= 0 )
		{
			killPlayer();
		}
		
		// hold damage
		player.isDamaged = true;
	}
	
	function resetPlayerTint(body)
	{
		body.tint = 0xffffff;
		player.isDamaged = false;
	}
	
	function killPlayer()
	{
		console.log( 'kill player' );
		
		TweenMax.killTweensOf( killPlayer );
		
		player.isDead = true;
		player.locked = true;
		player.art.alpha=0;
		player.body.gravity.y = 0;
		
		titleMenu.txt.innerHTML = '';
		titleMenu.per.innerHTML = '';
		TweenMax.to( menus, .5, {delay:1.5, autoAlpha:1, ease:Quad.easeOut});
		
		TweenMax.delayedCall(2.0, resetEngine);
		
		musicTrack.stop();
		player.audio.death.play('',0,sfxVolume);
		
		// remove all boss room locks!
		var col,row;
		for(i=16; i<=18; i++)
		{
			col = i;
			
			// tank
			row = (tankStartRow)+7;
			tileMatrix[row][col] = 0;
			
			// gridnok
			console.log('gcheck: ' + row + ', ' + col );
			row = (gridnokStartRow)+7;
			tileMatrix[row][col] = 0;
			
			// blackfire
			row = (blackfireStartRow)+7;
			tileMatrix[row][col] = 0;
			
		}
	}
	
	function warpPlayer(row, col)
	{
		console.log('warp to: ' + row + ', ' + col );
		
		// set for transition
		player.body.velocity.y = 0;
		player.body.gravity.y = 0;
		player.isWarping = true;
		player.body.moves = false;
		
		var sprite;
		
		// move player: surface
		if( curWarp=='surface' )
		{
			console.log('shift');
			player.x = surface.portal.x-22;
			player.y = surface.portal.y-44;
			curWarp='';
			
			sprite = game.add.sprite(0, 0, 'portal_dig');
			sprite.animations.add('in', [24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0]);
			sprite.animations.play('in', 24, false);
		}
		else
		{
			if( curWarp )
			{
				curWarp.alpha = 0;
				player.x = curWarp.x - 24;
				player.y = curWarp.y - 24;
				tileMatrix[curWarp.row][curWarp.col] = 0;
			}
			
			sprite = game.add.sprite(0, 0, 'portal_dig');
			sprite.animations.add('in', [12,11,10,9,8,7,6,5,4,3,2,1,0]);
			sprite.animations.play('in', 24, false);
		}
				
		// add warp sprite
		sprite.x = player.x-26;
		sprite.y = player.y-24;
		backtiles.add( sprite );
		TweenMax.delayedCall( 1.2, removeImg, [sprite] );
		
		// hide player
		player.art.alpha = 0;
		
		// execute move
		TweenMax.delayedCall(1.5, executeWarp, [row, col] );
		
		// audio
		player.audio.enterPortal.play('',0,sfxVolume);
	
	}
	
	function executeWarp(row, col)
	{
		// get x/y
		var i,p;
		var rmark = (ROW_LIMIT*.5);
		var newx = (col * TILE_WIDTH)+7;
		var newy = (row * TILE_WIDTH) + HORIZON_Y;
		
		// get max/min
		var rmin = player.curRow - rmark - 4;
		var rmax = player.curRow + rmark + 4;
		if(rmin<0){rmin=0;}
		if(rmax>MAP_HEIGHT){rmax=MAP_HEIGHT;}
		
		// remove cur rows
		for(i=rmin; i<=rmax; i++)
		{
			if( allTiles[i] )
			{
				//console.log('row exists: ' + i );
				removeRow(i);
			}
			else
			{
				//console.log('row does not exist: ' + i );
			}
		}
		
		// remove portals
		for(i=(portals.children.length-1); i>=0; i--)
		{
			p = portals.children[i];	
			p.destroy();		
		}
		
		// set empty tile for warp
		if( row != -1 )
		{
			tileMatrix[row][col] = 0;
		}
		else
		{
			console.log('warp to surface');
			newy -= 10;
			surface.alpha = 0;
			player.exitTower = true;
		}
		
		// move player	
		player.curRow = row;
		player.x = newx;
		player.y = newy;
		
		// check zone audio
		var curZone = Math.floor(player.curRow/ZONE_MARK)+1;
		if( player.curRow<0 ){ curZone=0; }
		if( curZone>6 ){ curZone=6; }
		
		if( curZone != player.curZone )
		{
			console.log('entered new zone, swap music');
			musicTrack.stop();
			musicTrack = game.add.audio('m_zone' + curZone );
	   	 	musicTrack.play('',0,musicVolume);
			player.curZone = curZone;
		}

		// implant new rows
		rmin = row-rmark;
		rmax = row+rmark;
		
		for(i=rmin; i<=rmax; i++)
		{
			//console.log('implant row: ' + i);
			addRow(i);
		}
		
		// add warp sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'portal_dig');
		sprite.animations.add('out', [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,0]);
		sprite.animations.play('out', 24, false);
		sprite.x = player.x-26;
		sprite.y = player.y-24;
		backtiles.add( sprite );
		TweenMax.delayedCall( 1.2, removeImg, [sprite] );

		// resume player
		player.body.velocity.y = 0;
		player.body.gravity.y = 500;
		player.isWarping = true;
		TweenMax.delayedCall(1.0, showPlayerWarped);
		
		// call warp end
		TweenMax.delayedCall(1.0, onWarpEnd);
		
		// audio
		player.audio.exitPortal.play('',0,sfxVolume);
	}
	
	function showPlayerWarped()
	{
		player.art.alpha = 1;
	}
	
	function onWarpEnd()
	{
		player.isWarping = false;
		player.body.moves = true;
		
		if( curWarp!='surface' )
		{
			if( !settings.warpDialogue )
			{
				setDialogues('raven');
				
				settings.warpDialogue = 'true';
				localStorage.setItem( 'warpDialogue', settings.warpDialogue );
			}
		}
	}

	function onPlayerCollision(player, other)
	{
		// tile collision
		if( (other.row) )
		{
			var diff = ( other.y-player.y )
			if( ( diff<80 ) && ( diff>20 ) )
			{
				var thresh = 500 + ( stats['airbag'] * 200 )
				if( player.lastVY > thresh )
				{
					if( stats['airbag']<4 )
					{
						damagePlayer(1);
					}
				}
			}
		}
		
		if(other.id=='boulder')
		{
			breakBoulder(other);
		}
	}
	
	//--------------------------- DRONE METHODS:
	
	function hoverDroneX()
	{
		var newX = 0;
		if( player.drone.x > 0 )
		{
			newX = -28;
		}
		else
		{
			newX = 32;
		}
		TweenMax.to( player.drone, .8, {x:newX, ease:Quad.easeInOut, onComplete:hoverDroneX});
	}
	
	function hoverDroneY()
	{
		var newY = 0;
		if( player.drone.y > 0 )
		{
			newY = -6;
		}
		else
		{
			newY = 2;
		}
		TweenMax.to( player.drone, .5, {y:newY, ease:Quad.easeInOut, onComplete:hoverDroneY});
	}
	
	function checkDrone()
	{
		var i;
		var e;
		var erow;
		var prow;
		var dx,dy,dt;
		var drone = player.drone;
		
		for(i=(enemies.children.length-1); i>=0; i--)
		{
			e = enemies.children[i];
			dx = (drone.x+player.x)-e.x;
			dy = (drone.y+player.y)-e.y;
			dt = Math.floor( Math.sqrt( (dx*dx)+(dy*dy) ) );
			if( dt < 200 )
			{
				droneFire(e);
			}
		}
	}
	
	function droneFire(e)
	{
		console.log("drone fire!");
		
		var drone = player.drone;
		if(!drone.fireReady){return;}
		if( player.drone.alpha!=1 ){return;}
		
		var newX = player.x + drone.x + 6;
		var newY = player.y + drone.y + 6;
		var bullet = game.add.sprite(newX, newY, 'shot01');
		
		bullet.scale.setTo(.5,.5);
		bullet.anchor.setTo(.5,.5);		
		game.physics.arcade.enable(bullet);
		bullet.body.outOfBoundsKill = true;
		bullet.body.checkWorldBounds = true;
		
		// calc physics
		var dx,dy,dt,vx,vy,ang,deg;
		
		dx = (drone.x+player.x)-e.x;
		dy = (drone.y+player.y)-e.y;
		dt = Math.floor( Math.sqrt( (dx*dx)+(dy*dy) ) );
		ang = Math.atan2(dy,dx);
		deg = ang * (180/Math.PI);
		deg+=180;
		ang = deg * (Math.PI/180);
		
		vx = Math.cos(ang)*BULLET_SPEED;
		vy = Math.sin(ang)*BULLET_SPEED;
		
		bullet.damage = 1;
        bullet.body.velocity.x = vx;
		bullet.body.velocity.y = vy;
		bullets.add(bullet);
		
		drone.fireReady = false;
		TweenMax.delayedCall( .4, restoreDroneReady);
		TweenMax.delayedCall( 2.0, removeImg, [bullet]);
	}
	
	function restoreDroneReady()
	{
		player.drone.fireReady = true;
	}
	
	//--------------------------- BULLET METHODS:
	
	function onBulletCollision(bullet, other)
	{
		//console.log('collide');
		
		bullet.kill();
		if( other.id == 'enemy' )
		{
			damageEnemy(other, bullet.damage);
		}
		
		// tank
		if( (other.mode == 'boss') && (other.type=='tank') )
		{
			other.boss.main.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss.main] );
			
			// check shield
			other.shieldHealth-=bullet.damage;
			if( (other.shieldHealth/tankHealthShield)<=.66 )
			{
				if( other.boss['shieldA'].alpha == 1 )
				{
					tankBodies[0].audio.breakShield.play('',0,sfxVolume);
				}
				
				other.boss['shieldA'].alpha = 0;
				other.boss['shieldB'].alpha = 1;
			}
			if( (other.shieldHealth/tankHealthShield)<=.33 )
			{
				if( other.boss['shieldB'].alpha == 1 )
				{
					tankBodies[0].audio.breakShield.play('',0,sfxVolume);
				}
				
				other.boss['shieldB'].alpha = 0;
				other.boss['shieldC'].alpha = 1;
				
			}
			if( (other.shieldHealth/tankHealthShield)<=0 )
			{
				if( other.boss['shieldC'].alpha == 1 )
				{
					tankBodies[0].audio.breakShield.play('',0,sfxVolume);
				}
				
				other.boss['shieldC'].alpha = 0;
			}
			
			// incremenet health
			other.health-=bullet.damage;;
			if(other.health <= 0 )
			{
				console.log('boss dead');
				enemyMatrix[ other.row ][ other.col ] = 0;
				other.boss.active = false;
				other.destroy();
				other.boss.back.destroy();
				other.boss.destroy();
				TweenMax.killTweensOf(shootCanonBullet);
				TweenMax.killTweensOf(shootTurretBullet);
				
				TweenMax.delayedCall( 1.0, deactivateTankBattle);
			}
			
			// update bar
			var newS = (other.health/other.maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});
			
		}
		
		// tank: canons
		if( other.mode == 'tank-canon1' )
		{
			// incremenet health
			other.health-=bullet.damage;;
			
			// show damage
			other.boss.canon1.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss.canon1] );
			other.boss['canon1-b'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['canon1-b']] );
			other.boss['canon1-c'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['canon1-c']] );
			
			// check for swap
			if( other.health <= (tankHealthCanon*.5) )
			{
				if( other.boss['canon1'].alpha == 1 )
				{
					tankBodies[0].audio.breakCanon.play('',0,sfxVolume);
				}
				
				other.boss['canon1'].alpha = 0;
				other.boss['canon1-b'].alpha = 1;
			}
			if( other.health <= 0 )
			{
				other.boss['canon1-b'].alpha = 0;
				other.boss['canon1-c'].alpha = 1;
				other.alpha = 0;
				other.destroy();
				
				if( other.boss['canon1-b'].alpha == 1 )
				{
					tankBodies[0].audio.breakCanon.play('',0,sfxVolume);
				}
			}
			
			// hurt main
			tankBodies[0].health-=bullet.damage;;
			if( tankBodies[0].health <= 0 )
			{
				console.log('******* boss dead *******');
				enemyMatrix[ tankBodies[0].row ][ tankBodies[0].col ] = 0;
				tankBodies[0].boss.active = false;
				tankBodies[0].destroy();
				tankBodies[0].boss.back.destroy();
				tankBodies[0].boss.destroy();
				TweenMax.killTweensOf(shootCanonBullet);
				TweenMax.killTweensOf(shootTurretBullet);
				
				TweenMax.delayedCall( 1.0, deactivateTankBattle);
			}
			
			// update bar
			var newS = (tankBodies[0].health/tankBodies[0].maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});

		}
		
		if( other.mode == 'tank-canon2' )
		{
			// incremenet health
			other.health-=bullet.damage;;
			
			// show damage
			other.boss.canon2.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss.canon2] );
			other.boss['canon2-b'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['canon2-b']] );
			other.boss['canon2-c'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['canon2-c']] );
			
			// check for swap
			if( other.health <= (tankHealthCanon*.5) )
			{
				if( other.boss['canon2'].alpha == 1 )
				{
					tankBodies[0].audio.breakCanon.play('',0,sfxVolume);
				}
				
				other.boss['canon2'].alpha = 0;
				other.boss['canon2-b'].alpha = 1;
				
			}
			if( other.health <= 0 )
			{
				if( other.boss['canon2-b'].alpha == 1 )
				{
					tankBodies[0].audio.breakCanon.play('',0,sfxVolume);
				}
				
				other.boss['canon2-b'].alpha = 0;
				other.boss['canon2-c'].alpha = 1;
				other.alpha = 0;
				other.destroy();

			}
			
			// hurt main
			tankBodies[0].health-=bullet.damage;;
			if( tankBodies[0].health <= 0 )
			{
				console.log('******* boss dead *******');
				enemyMatrix[ tankBodies[0].row ][ tankBodies[0].col ] = 0;
				tankBodies[0].boss.active = false;
				tankBodies[0].destroy();
				tankBodies[0].boss.destroy();
				tankBodies[0].boss.back.destroy();
				TweenMax.killTweensOf(shootCanonBullet);
				TweenMax.killTweensOf(shootTurretBullet);
				
				TweenMax.delayedCall( 1.0, deactivateTankBattle);
			}
			
			// update bar
			var newS = (tankBodies[0].health/tankBodies[0].maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});
		}
		
		// tank: turrets
		if( other.mode == 'tank-turret1' )
		{
			// incremenet health
			other.health-=bullet.damage;;
			
			// show damage
			other.boss.turret1.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss.turret1] );
			other.boss['turret1-b'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['turret1-b']] );
			other.boss['turret1-c'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['turret1-c']] );
			
			// check for swap
			if( other.health <= (tankHealthCanon*.5) )
			{
				if( other.boss['turret1'].alpha == 1 )
				{
					tankBodies[0].audio.breakTurret.play('',0,sfxVolume);
				}
				
				other.boss['turret1'].alpha = 0;
				other.boss['turret1-b'].alpha = 1;

			}
			if( other.health <= 0 )
			{
				if( other.boss['turret1-b'].alpha == 1 )
				{
					tankBodies[0].audio.breakTurret.play('',0,sfxVolume);
				}
				
				other.boss['turret1-b'].alpha = 0;
				other.boss['turret1-c'].alpha = 1;
				other.alpha = 0;
				other.destroy();
			}
			
			// hurt main
			tankBodies[0].health-=bullet.damage;;
			if( tankBodies[0].health <= 0 )
			{
				console.log('******* boss dead *******');
				enemyMatrix[ tankBodies[0].row ][ tankBodies[0].col ] = 0;
				tankBodies[0].boss.active = false;
				tankBodies[0].destroy();
				tankBodies[0].boss.back.destroy();
				tankBodies[0].boss.destroy();
				TweenMax.killTweensOf(shootCanonBullet);
				TweenMax.killTweensOf(shootTurretBullet);
				
				TweenMax.delayedCall( 1.0, deactivateTankBattle);
			}
			
			// update bar
			var newS = (tankBodies[0].health/tankBodies[0].maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});

		}
		
		if( other.mode == 'tank-turret2' )
		{
			// incremenet health
			other.health-=bullet.damage;;
			
			// show damage
			other.boss.turret2.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss.turret2] );
			other.boss['turret2-b'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['turret2-b']] );
			other.boss['turret2-c'].tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [other.boss['turret2-c']] );
			
			// check for swap
			if( other.health <= (tankHealthCanon*.5) )
			{
				if( other.boss['turret2'].alpha == 1 )
				{
					tankBodies[0].audio.breakTurret.play('',0,sfxVolume);
				}
				
				other.boss['turret2'].alpha = 0;
				other.boss['turret2-b'].alpha = 1;

			}
			if( other.health <= 0 )
			{
				if( other.boss['turret2-b'].alpha == 1 )
				{
					tankBodies[0].audio.breakTurret.play('',0,sfxVolume);
				}
				
				other.boss['turret2-b'].alpha = 0;
				other.boss['turret2-c'].alpha = 1;
				other.alpha = 0;
				other.destroy();			
			}
			
			// hurt main
			tankBodies[0].health-=bullet.damage;;
			if( tankBodies[0].health <= 0 )
			{
				console.log('******* boss dead *******');
				enemyMatrix[ tankBodies[0].row ][ tankBodies[0].col ] = 0;
				tankBodies[0].boss.active = false;
				tankBodies[0].destroy();
				tankBodies[0].boss.back.destroy();
				tankBodies[0].boss.destroy();
				TweenMax.killTweensOf(shootCanonBullet);
				TweenMax.killTweensOf(shootTurretBullet);
				
				TweenMax.delayedCall( 1.0, deactivateTankBattle);
			}
			
			// update bar
			var newS = (tankBodies[0].health/tankBodies[0].maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});

		}
		
		// gridnok
		if( (other.mode == 'boss') && (other.type=='gridnok') )
		{
			gridnok.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [gridnok] );
			
			// incremenet health
			other.health-=bullet.damage;;
			if(other.health <= 0 )
			{
				console.log('gridnook dead');
				enemyMatrix[ other.row ][ other.col ] = 0;
				other.boss.active = false;
				other.destroy();
				other.boss.destroy();
				
				TweenMax.delayedCall( 1.0, deactivateGridnokBattle);
			}
			
			// update bar
			var newS = (other.health/other.maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});
			
		}
		
		// blackfire
		if( (other.mode == 'boss') && (other.type=='blackfire') )
		{
			blackfire.tint = 0xff00ff;
			TweenMax.delayedCall(.1, resetEnemyTint, [blackfire] );
			
			// incremenet health
			other.health-=bullet.damage;;
			if(other.health <= 0 )
			{
				console.log('blackfire dead');
				enemyMatrix[ other.row ][ other.col ] = 0;
				other.boss.active = false;
				other.destroy();
				
				TweenMax.delayedCall( 1.0, deactivateBlackfireBattle);
			}
			
			// update bar
			var newS = (other.health/other.maxHealth);
			if(newS<0){newS=0;}
			TweenMax.to( bossMenu.bar, .2, {scaleX:newS, ease:Quad.easeOut});
			
		}
		
	}
	
	function onEnemyBulletCollision(bullet, other)
	{
		//console.log('collide');
		
		bullet.kill();
		if( other.id == 'player' )
		{
			//console.log('shot player');
			damagePlayer(bullet.damage);
		}
		//console.log( other.id );
	}
		
	//--------------------------- enemy methods: build
	
	function buildEnemyCavern(row, col, num, forced)
	{
		//console.log( 'add cavern: ' + row + ', ' + col );
		
		// check matrix
		var val = tileMatrix[row][col];
		if( !forced )
		{
			if( val < .5 ){ return; }
		}
		
		
		// build matrix
		var i;
		var j;
		var cH = 3;
		var cW = 6;
		
		for(i=row; i<row+cH; i++)
		{
			for(j=col; j<col+cW; j++)
			{
				tileMatrix[i][j] = 0;
			}
		}
		
		// add spawn
		enemyMatrix[row+cH+1][col+3] = num;
		
	}
	
	function buildEnemy01(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				//e.reset( e.startX, e.startY );
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy01');
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.add('attack', [12,12,12,12,12,12,13,14,15,16,17]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.5);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 58, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 5;
		sprite.direction = 1;
		sprite.speed = 100;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 200;
		sprite.canAttack = true;
		sprite.shotDelay = .3;
		sprite.firesBullet = true;
		sprite.damage = 1;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.active = [game.add.audio('e_go_active1' ), game.add.audio('e_go_active2' )];
		sprite.audio.attack = [game.add.audio('e_go_attack1' ), game.add.audio('e_go_attack1' )];
		sprite.audio.death = [game.add.audio('e_go_death1' ), game.add.audio('e_go_death2' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy02(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				//e.reset( e.startX, e.startY );
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy02');
		
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.add('attack', [12,12,12,12,12,12,13,14,15,16,17]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.5);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 62, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 150;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 200;
		sprite.canAttack = true;
		sprite.shotDelay = .3;
		sprite.firesBullet = true;
		sprite.damage = 2;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.active = [game.add.audio('e_gx_active1' ), game.add.audio('e_gx_active2' )];
		sprite.audio.attack = [game.add.audio('e_gx_attack1' ), game.add.audio('e_gx_attack1' )];
		sprite.audio.death = [game.add.audio('e_gx_death1' ), game.add.audio('e_gx_death2' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy03(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				//e.reset( e.startX, e.startY );
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy03');
		
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.add('attack', [12,13,14,15,16,17,18,19]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.5);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 62, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 50;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 200;
		sprite.canAttack = true;
		sprite.shotDelay = .0;
		sprite.firesBullet = true;
		sprite.damage = 1;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.active = [game.add.audio('e_gl_active1' ), game.add.audio('e_gl_active2' )];
		sprite.audio.attack = [game.add.audio('e_gl_attack1' ), game.add.audio('e_gl_attack1' )];
		sprite.audio.death = [game.add.audio('e_gl_death1' ), game.add.audio('e_gl_death2' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy04(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy04');
		
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.add('attack', [12,13,14,15,16,17,18,19]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.7);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 58, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 50;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 100;
		sprite.canAttack = true;
		sprite.damage = 1;
		//sprite.shotDelay = .0;
		//sprite.firesBullet = true;
		sprite.groundBlast = true;
		sprite.blastMin = 0;
		sprite.blastMax = 120;
		sprite.blastDelay = .2;
		sprite.blastDamage = 1;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.active = [game.add.audio('e_ch_active1' ), game.add.audio('e_ch_active2' )];
		sprite.audio.attack = [game.add.audio('e_ch_attack1' ), game.add.audio('e_ch_attack1' )];
		sprite.audio.death = [game.add.audio('e_ch_death1' ), game.add.audio('e_ch_death2' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy05(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy05');
		
		sprite.animations.add('walk', [0,1,2,3,4,5]);
		sprite.animations.add('attack', [6,7,8,9,10,11,12,13,14,15]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.75);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 58, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 30;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 120;
		sprite.canAttack = true;
		sprite.damage = 1;
		//sprite.shotDelay = .0;
		//sprite.firesBullet = true;
		sprite.groundBlast = true;
		sprite.blastMin = 0;
		sprite.blastMax = 150;
		sprite.blastDelay = .2;
		sprite.blastDamage = 8;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.attack = [game.add.audio('e_fl_attack1' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy06(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy05');
		
		sprite.animations.add('walk', [0,1,2,3,4,5]);
		sprite.animations.add('attack', [6,7,8,9,10,11,12,13,14,15]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,.75);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 58, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 30;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 120;
		sprite.canAttack = true;
		sprite.damage = 1;
		//sprite.shotDelay = .0;
		//sprite.firesBullet = true;
		sprite.groundBlast = true;
		sprite.blastMin = 0;
		sprite.blastMax = 150;
		sprite.blastDelay = .2;
		sprite.blastDamage = 8;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		//sprite.audio.attack = [game.add.audio('e_fl_attack1' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy07(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy07');
		
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.add('attack', [12,13,14,15,16,17,18,19,20,21,22,23]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,1);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2) + 0;
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(50, 86, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.type = 'plant';
		sprite.health = 10;
		sprite.direction = 1;
		sprite.speed = 0;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 240;
		sprite.canAttack = true;
		sprite.damage = 1;
		sprite.shotDelay = .4;
		sprite.firesBullet = true;
		
		/*
		sprite.groundBlast = true;
		sprite.blastMin = 0;
		sprite.blastMax = 150;
		sprite.blastDelay = .2;
		sprite.blastDamage = 8;
		*/
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.attack = [game.add.audio('e_pl_attack1' ), game.add.audio('e_pl_attack2' )];
		sprite.audio.death = [game.add.audio('e_pl_death1' ) ];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	function buildEnemy08(box)
	{
		console.log('build enemy');
		
		// check if already exists
		for(i=0; i<enemies.children.length; i++)
		{
			e = enemies.children[i];
			if( (e.row==box.row) && (e.col==box.col) )
			{
				console.log('enemy already exisits');
				return;
			}
		}
		
		// build sprite
		var sprite;
		sprite = game.add.sprite(0, 0, 'enemy08');
		
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
		sprite.animations.play('walk', 24, true);
		enemies.add( sprite );
		
		sprite.anchor.setTo(.5,1);
		sprite.x = box.x;
		sprite.y = box.y - (TILE_WIDTH*2);
		sprite.play();
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
	    sprite.body.gravity.y = 500;
		sprite.body.setSize(200, 60, 0, 0);
		
		// init
		sprite.id = 'enemy';
		sprite.type = 'worm';
		sprite.health = 25;
		sprite.direction = 1;
		sprite.speed = 160;
		sprite.attackReady = true;
		sprite.attackDelay = 1;
		sprite.attackRadius = 120;
		sprite.canAttack = true;
		sprite.damage = 1;
		
		//sprite.shotDelay = .0;
		//sprite.firesBullet = true;
		sprite.groundBlast = true;
		sprite.blastMin = 0;
		sprite.blastMax = 150;
		sprite.blastDelay = 0;
		sprite.blastDamage = 2;
		
		sprite.startX = sprite.x;
		sprite.startY = sprite.y;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// audio
		sprite.audio = [];
		sprite.audio.attack = [game.add.audio('e_wo_chomp1' ), game.add.audio('e_wo_chomp1' )];
		sprite.audio.eat = [game.add.audio('e_wo_eat1' ), game.add.audio('e_wo_eat2' ), game.add.audio('e_wo_eat3' )];
		
		// save first for testing
		if(!testEnemy){
			testEnemy = sprite;
		}		
	}
	
	//--------------------------- enemy methods: behaviors
	
	function onEnemyCollision(enemy, other)
	{
		if(other.row)
		{
			//console.log('collsion?');
			
			var erow = Math.floor ( (enemy.y-HORIZON_Y)/64 );
			
			if(enemy.type=='gridnok')
			{
				erow-=2;
			}
			
			if(enemy.type=='blackfire')
			{
				//console.log(erow, other.row);
				erow-=3;
			}
			
			if(enemy.type=='plant')
			{
				return;
			}
			
			if(enemy.type=='worm')
			{
				erow-=1;
			}
			
			if( erow == other.row )
			{
				console.log('wall');
				
				if( (enemy.type=='worm') && (!other.isStone) )
				{
					var rnum = Math.floor(Math.random() * enemy.audio.eat.length);
					enemy.audio.eat[ rnum ].play('',0,sfxVolume);
					breakTile(other);
				}
				else
				{
					enemy.direction *= -1;
					enemy.scale.x *= -1;
				}
			}
		}
		else
		{
			if(other.id=='boulder')
			{
				var dy = other.y - enemy.y;
				var dmg = 0;
				console.log('enemy dy: ' + dy);
				
				if( (dy<-60)&&(dy>-140) )
				{
					dmg=10;
				}
				else
				{
					dmg=1;
				}
				
				TweenMax.delayedCall( .01, damageEnemy, [enemy, dmg] );
				TweenMax.delayedCall( .01, breakBoulder, [other] );
				
			}
		}
	}

	function checkEnemies()
	{
		var i;
		var e;
		var erow;
		var prow;
		var dx;
		
		for(i=(enemies.children.length-1); i>=0; i--)
		{
			e = enemies.children[i];
			e.body.velocity.x = e.direction * e.speed;
			
			erow = Math.floor ( (e.y-HORIZON_Y)/64 );
			prow = Math.floor ( (player.y-HORIZON_Y)/64 );
			
			// row exceptions
			if( e.type=='plant' ){ erow-=1; }
			if( e.type=='worm' ){ erow-=1; }
			
			// remove
			if( Math.abs(erow-prow) >= 15 )
			{
				//console.log( 'way out of range, remove' );
				e.destroy();
			}
			// pause
			else if( Math.abs(erow-prow) >= 5 )
			{
				if(e.direction != 0)
				{
					//console.log( 'out of range, grav freeze' );
					e.body.gravity.y = 0;
					e.body.velocity.y = 0;
					e.pastDir = e.direction + 0;
					e.direction = 0;
				}
			}
			// resume
			else
			{
				//console.log('in range, unfreeze');
				if( (e.direction==0 ) && (!e.isAttacking) )
				{
					//console.log( 'redirect ');
					e.body.gravity.y = 500;
					e.direction = e.pastDir;
					e.scale.x = e.direction;
				}
			}
			
			// attack
			if( e.canAttack )
			{
				if( (erow==prow) )
				{
					dx = e.x - player.x;
					if( (Math.abs(dx) < e.attackRadius) && (e.attackReady) )
					{
						onEnemyAttack(e);
					}
				
				}
			}
			
		}
	}
	
	function onEnemyAttack(enemy)
	{
		console.log('attack!');
		
		// check for active 
		var rnum;
		if( enemy.audio.active )
		{
			rnum = Math.floor(Math.random() * enemy.audio.active.length);
			enemy.audio.active[ rnum ].play('',0,sfxVolume);
		}
		
		// face player
		if(enemy.x>player.x)
		{
			enemy.scale.x = -1
			enemy.direction = -1;
		}
		else
		{
			enemy.scale.x = 1
			enemy.direction = 1;
		}
		
		// set vars
		enemy.isAttacking = true;
		enemy.attackReady = false;
		enemy.pastDir = enemy.direction + 0;
		enemy.direction = 0;
		
		// change animation
		enemy.animations.play('attack', 24, false);
		
		// fire shot
		if(enemy.firesBullet)
		{
			TweenMax.delayedCall( enemy.shotDelay, fireEnemyShot, [enemy] );
		}
		
		// fire blast
		if(enemy.groundBlast)
		{
			TweenMax.delayedCall( enemy.blastDelay, checkEnemyBlast, [enemy] );
		}
		
		// reset attack
		TweenMax.delayedCall( enemy.attackDelay, resetEnemyAttack, [enemy] );
	}
	
	function fireEnemyShot(enemy)
	{
		if( enemy.type=='plant' )
		{
			firePlantShot(enemy);
			return;
		}
		
		var bullet = ebullets.getFirstExists(false);
        if(bullet)
        {
			var newX = (enemy.x + (enemy.width*.5)) + (-2 * enemy.scale.x);
			var newY = (enemy.y - 1);
            bullet.reset( newX, newY );
			bullet.alpha = 1;
			bullet.damage = enemy.damage;
            bullet.body.velocity.x = EBULLET_SPEED * enemy.scale.x;
        }
		
		// check for attack 
		var rnum;
		if( enemy.audio.attack )
		{
			rnum = Math.floor(Math.random() * enemy.audio.attack.length);
			enemy.audio.attack[ rnum ].play('',0,sfxVolume);
		}
	}
	
	function firePlantShot(enemy)
	{
		var newX = (enemy.x + (enemy.width*.5)) + (-18 * enemy.scale.x);
		var newY = (enemy.y - 46);
		var bullet = game.add.sprite(newX, newY, 'perry');
		
		bullet.anchor.setTo(.5,.5);		
		game.physics.arcade.enable(bullet);
		bullet.body.outOfBoundsKill = true;
		bullet.body.checkWorldBounds = true;
		
		bullet.damage = enemy.damage;
        bullet.body.velocity.x = EBULLET_SPEED * enemy.scale.x;
		
		ebullets.add(bullet);
		TweenMax.delayedCall( 2.0, removeImg, [bullet]);
		
		// check for attack 
		var rnum;
		if( enemy.audio.attack )
		{
			rnum = Math.floor(Math.random() * enemy.audio.attack.length);
			enemy.audio.attack[ rnum ].play('',0,sfxVolume);
		}
	}
	
	function resetEnemyDirection(enemy)
	{
		enemy.direction = enemey.pastDir;
		enemy.scale.x = enemy.direction;
	}
	
	function resetEnemyTint(enemy)
	{
		enemy.tint = 0xffffff;
	}
	
	function resetEnemyAttack(enemy)
	{
		enemy.isAttacking = false;
		enemy.attackReady = true;
		enemy.animations.play('walk', 24, true);
	}
	
	function checkEnemyBlast(enemy)
	{
		var bmin = (enemy.blastMin * enemy.pastDir) + enemy.x;
		var bmax = (enemy.blastMax * enemy.pastDir) + enemy.x;
		
		// if in ground range
		if( Math.abs( player.y-enemy.y ) < 64 )
		{
			if(bmin<bmax)
			{
				if( (player.x>bmin) && (player.x<bmax) )
				{
					console.log('hit by blast');
					damagePlayer(enemy.damage);
				}
			}
		
			if(bmax<bmin)
			{
				if( (player.x>bmax) && (player.x<bmin) )
				{
					console.log('hit by blast');
					damagePlayer(enemy.damage);
				}
			}
		}
		
		// check for attack 
		var rnum;
		if( enemy.audio.attack )
		{
			rnum = Math.floor(Math.random() * enemy.audio.attack.length);
			enemy.audio.attack[ rnum ].play('',0,sfxVolume);
		}

	}
	
	function damageEnemy(other, dmg)
	{
		other.tint = 0xff00ff;
		TweenMax.delayedCall(.1, resetEnemyTint, [other] );
		
		var dmg = dmg;
		
		// check for powerups
		if( (gui.powerup1.isActive) )
		{
			if( gui.powerup1.info.name=='Beam Amplifier' )
			{
				dmg*=2;
			}
		}
		if( (gui.powerup2.isActive) )
		{
			if( gui.powerup2.info.name=='Beam Amplifier' )
			{
				dmg*=2;
			}
		}
		
		// damage enemy
		other.health-=dmg;
		if(other.health <= 0 )
		{
			// add poof
			var sprite = game.add.sprite(other.x, other.y, 'poof');
			sprite.anchor.setTo(.5,.5);
			sprite.animations.add('poof', [0,1,2,3,4,5,6,7]);
			sprite.animations.play('poof', 24, false);
			TweenMax.delayedCall( .5, removeImg, [sprite]);
			
			enemyMatrix[ other.row ][ other.col ] = 0;
			other.destroy();
			
			// check for death 
			var rnum;
			if( other.audio.death )
			{
				rnum = Math.floor(Math.random() * other.audio.death.length);
				other.audio.death[ rnum ].play('',0,sfxVolume);
			}
		}
	}
	
	//--------------------------- BOSS METHODS: GENERAL
	
	function buildBossCavern()
	{
		var bossCavern = [];
		var cH = 16;
		var cW = 12;
		var midW = Math.floor(MAP_WIDTH/2);
		
		for(i=0; i<(cH+4); i++)
		{
			var tileRow = [];
			for(j=0; j<MAP_WIDTH; j++)
			{
				// top row, rock entry
				if( i==0 )
				{
					if( (j>=(midW-1)) && (j<=(midW+1)) )
					{
						tileRow[j] = 0;
					}
					else
					{
						tileRow[j] = 1000;
					}	
				}
				// falling zone
				else if( i<=6 )
				{
					if( (j>=(midW-1)) && (j<=(midW+1)) )
					{
						tileRow[j] = 0;
					}
					else if( (j==(midW-2)) || (j==(midW+2)) )
					{
						tileRow[j] = 1000;
					}
					else
					{
						tileRow[j] = 1;
					}
				}
				// boss roof
				else if( i==7 )
				{
					if( (j<=(midW-cW)) || (j>=(midW+cW)) )
					{
						tileRow[j] = 1;
					}
					else if( (j>=(midW-1)) && (j<=(midW+1)) )
					{
						tileRow[j] = 0;
					}
					else
					{
						tileRow[j] = 1000;
					}
				}
				// room
				else if( i <= (cH-2) )
				{
					if( (j==(midW-(cW-1))) || (j==(midW+(cW-1))) )
					{
						tileRow[j] = 1000;
					}
					else if( (j<=(midW-cW)) || (j>=(midW+cW)) )
					{
						tileRow[j] = 1;
					}
					else
					{
						tileRow[j] = 0;
					}
				}
				// floor
				else if( i==(cH-1) )
				{
					if( (j<=(midW-cW)) || (j>=(midW+cW)) )
					{
						tileRow[j] = 1;
					}
					else
					{
						tileRow[j] = 1000;
					}
				}
				// exit tunnel
				else if( i<(cH+4) )
				{
					if( (j>=(midW-1)) && (j<=(midW+1)) )
					{
						tileRow[j] = 0;
					}
					else if( (j==(midW-2)) || (j==(midW+2)) )
					{
						tileRow[j] = 1000;
					}
					else
					{
						tileRow[j] = 1;
					}
				}
				// exit layer
				else if( i==(cH+4) )
				{
					if( (j>=(midW-1)) && (j<=(midW+1)) )
					{
						tileRow[j] = 0;
					}
					else
					{
						tileRow[j] = 1000;
					}	
				}
				else
				{
					tileRow[j] = 0;
				}
				
			}
			bossCavern[i] = tileRow;
		}
		
		return bossCavern;
	}
	
	function checkBosses()
	{
		var i,j;
		var e,t,c;
		var dx,dy,dt,ang;
		var prow,erow;
		
		for(i=(bosses.children.length-1); i>=0; i--)
		{
			e = bosses.children[i];
			if( e.id != 'boss' ){ continue; }
			
			if( e.type == 'tank' )
			{
				//console.log('tank: ' + e.active);
					
				// activate
				if( e.active==false )
				{
					if( player.curRow == (tankStartRow+10) )
					{
						TweenMax.delayedCall(0.5, activateTankIntro);
					}
					continue; 
				}
				
				// move left
				if( (e.active) && (e.boss.x>=500) )
				{
					e.boss.x-=tankSpeed;
					e.boss.back.x-=tankSpeed;
					e.boss.xDiff = e.boss.x - e.boss.startX;
					
					for(j=0; j<tankBodies.length; j++)
					{
						tankBodies[j].body.x -= tankSpeed;
					}
				}
			
				// rotate turrets
				for(j=1; j<=2; j++)
				{
					if( e['turret'+j+'-c'].alpha != 1 )
					{
						t = e['turret'+j];
						dx = (t.x + 0 + e.art.x) - player.x;
						dy = (t.y + e.art.y) - player.y;
						ang = Math.atan2(dy,dx);
						ang = ang * (180/Math.PI);
						t.angle = ang;
					
						e['turret'+j+'-b'].angle = ang;
						e['turret'+j+'-c'].angle = ang;
					}
				}
			
				// check turrent fire
				if( e.fireReady01 )
				{
					e.fireReady01 = false;
					fireBoss01Turrets(e);
					TweenMax.delayedCall( 5.0, resetBossAttack01, [e] );
				}
			
				// check beam fire
				if( e.fireReady02 )
				{
					e.fireReady02 = false;
					fireBoss01Canon(e);
					TweenMax.delayedCall( 6.0, resetBossAttack02, [e] );
				}
			}
			
			if( e.type == 'gridnok' )
			{
				// activate
				if( e.active==false )
				{
					if( player.curRow == (gridnokStartRow+10) )
					{
						TweenMax.delayedCall(0.5, activateGridnokIntro);
					}
					continue; 
				}
				
				// set speed
				if( e.status=='hold')
				{
					e.body.velocity.x = 0
				}
				if( e.status=='walking')
				{
					e.body.velocity.x = e.direction * e.speed;
					e.moveCount--;
					
					//console.log( e.frame );
				}
				if( e.status=='charging')
				{
					e.body.velocity.x = e.direction * e.speed * 5;
				}
				
				// check move
				if(e.moveCount<=0)
				{
					e.moveCount=e.moveDelay;

					if(e.nextMove==1)
					{
						onGridnokCharge();
						e.nextMove = 2;
					}
					else if(e.nextMove==2)
					{
						onGridnokThrow();
						e.nextMove = 1;
					}
				}
				
				// check row distance
				erow = Math.floor ( (e.y-HORIZON_Y)/64 );
				prow = Math.floor ( (player.y-HORIZON_Y)/64 );
			
				// pause
				if( Math.abs(erow-prow) >= 5 )
				{
					if(e.direction != 0)
					{
						console.log( 'out of range, gridnok grav freeze' );
						e.body.gravity.y = 0;
						e.body.velocity.y = 0;
						e.pastDir = e.direction + 0;
						e.direction = 0;
					}
				}
				// resume
				else
				{
					if( (e.direction==0 ) && (!e.isAttacking) )
					{
						console.log('gridnok in range, unfreeze');
						e.body.gravity.y = 500;
						e.direction = e.pastDir;
						e.scale.x = e.direction;
					}
				}
			}
			
			if( e.type == 'blackfire' )
			{
				// activate
				if( e.active==false )
				{
					if( player.curRow == (blackfireStartRow+10) )
					{
						TweenMax.delayedCall(0.5, activateBlackfireIntro);
					}
					continue; 
				}
				
				// set speed
				if( e.status=='hold')
				{
					e.body.velocity.x = 0
				}
				if( e.status=='walking')
				{
					e.body.velocity.x = e.direction * e.speed;
					e.moveCount--;
				}
				
				// check moves
				if(e.moveCount<=0)
				{
					e.moveCount=e.moveDelay;

					if(e.nextMove==1)
					{
						chargeBlackfire();
						TweenMax.delayedCall(.5, clapBlackfire);
						e.nextMove = 2;
					}
					else if(e.nextMove==2)
					{
						beamBlackfire();
						TweenMax.delayedCall(.5, beamBlackfire);
						e.nextMove = 3;
					}
					else if(e.nextMove==3)
					{
						stompBlackfire();
						TweenMax.delayedCall(.5, chargeBlackfire);
						e.nextMove = 1;
					}
				}
				
				// check row distance
				erow = Math.floor ( (e.y-HORIZON_Y)/64 );
				prow = Math.floor ( (player.y-HORIZON_Y)/64 );
			
				// pause
				if( Math.abs(erow-prow) >= 6 )
				{
					if(e.direction != 0)
					{
						console.log( 'out of range, blackfire grav freeze' );
						e.body.gravity.y = 0;
						e.body.velocity.y = 0;
						e.pastDir = e.direction + 0;
						e.direction = 0;
					}
				}
				// resume
				else
				{
					if( (e.direction==0 ) && (!e.isAttacking) )
					{
						console.log('blackfire in range, unfreeze');
						e.body.gravity.y = 500;
						e.direction = e.pastDir;
						e.scale.x = e.direction;
					}
				}
			}

		}
	}
	
	function onBossOverlap( player, other )
	{
		//console.log('other');
		TweenMax.delayedCall( .05, damagePlayer, [1] );
	}
	
	function setDialogueReady(dia)
	{
		console.log("???");
		dia.ready = true;
	}
	
	function setDialogues(mode)
	{
		console.log('set to: ' + mode);
		
		// clear txt
		pDialogue.txt.innerHTML = '';
		bDialogue.txt.innerHTML = '';
		
		// reset bubbles
		TweenMax.to( pDialogue.bubble, 0, {scaleX:0, scaleY:0, transformOrigin:"0% 50%"} );
		TweenMax.to( bDialogue.bubble, 0, {scaleX:0, scaleY:0, transformOrigin:"100% 50%"} );
				
		// reset bgs
		TweenMax.to( pDialogue['p1'], 0, {autoAlpha:0});
		TweenMax.to( pDialogue['p2'], 0, {autoAlpha:0});
		TweenMax.to( pDialogue['p3'], 0, {autoAlpha:0});
		TweenMax.to( bDialogue['b1'], 0, {autoAlpha:0});
		TweenMax.to( bDialogue['b2'], 0, {autoAlpha:0});
		TweenMax.to( bDialogue['b3'], 0, {autoAlpha:0});
		TweenMax.to( bDialogue['b4'], 0, {autoAlpha:0});
		
		// build dia
		var dia = [];
		
		if( mode == 'raven' )
		{
			dia[1] = [];
			dia[1].target = pDialogue;
			dia[1].txt = "Wow, that worked surprisingly well.";
			
			dia[2] = [];
			dia[2].target = bDialogue;
			dia[2].txt = "Yeah, baby!";
			
			dia[3] = [];
			dia[3].target = pDialogue;
			dia[3].txt = "You can use my portals to zap back to the surface anytime.";
			
			TweenMax.to( pDialogue['p3'], 0, {autoAlpha:1});
			TweenMax.to( bDialogue['b4'], 0, {autoAlpha:1});
		}	
		
		if( mode == 'tank' )
		{
			dia[1] = [];
			dia[1].target = pDialogue;
			dia[1].txt = "Hey! What are you guys doing down here?";
			
			dia[2] = [];
			dia[2].target = bDialogue;
			dia[2].txt = "Quick, stop him before he finds the boss!";
			
			dia[3] = [];
			dia[3].target = pDialogue;
			dia[3].txt = "Oh, it's on now!";
			
			TweenMax.to( pDialogue['p1'], 0, {autoAlpha:1});
			TweenMax.to( bDialogue['b1'], 0, {autoAlpha:1});
		}	
		
		if( mode == 'gridnok' )
		{
			dia[1] = [];
			dia[1].target = bDialogue;
			dia[1].txt = "Groaaaaarrrrr!!!!";
			
			dia[2] = [];
			dia[2].target = pDialogue;
			dia[2].txt = "Aw, man! It's Gridnock the Skull Crusher!";
			
			TweenMax.to( pDialogue['p1'], 0, {autoAlpha:1});
			TweenMax.to( bDialogue['b2'], 0, {autoAlpha:1});
		}
		
		if( mode == 'blackfire' )
		{
			dia[1] = [];
			dia[1].target = pDialogue;
			dia[1].txt = "Blackfire! I should have known.";
			
			dia[2] = [];
			dia[2].target = bDialogue;
			dia[2].txt = "Ha! You really think your puny drill can stop me?";
			
			dia[3] = [];
			dia[3].target = pDialogue;
			dia[3].txt = "That is one mean looking robot!";
			
			TweenMax.to( pDialogue['p1'], 0, {autoAlpha:1});
			TweenMax.to( bDialogue['b3'], 0, {autoAlpha:1});
		}	
		
		// cur dia
		curDia = [];
		curDia.num = 1;
		curDia.script = dia;
		
		showDialogues();
	}
	
	function showDialogues()
	{
		// reset bubbles
		
		// show dialogue
		TweenMax.to( pDialogue, .5, {delay:0.0, x:0, ease:Quad.easeOut});
		TweenMax.to( bDialogue, .5, {delay:0.0, x:600-472, ease:Quad.easeOut});
		
		// audio
		shopMenu.audio.popup.play('',0,sfxVolume);
		
		// play
		TweenMax.delayedCall( 0.5, playDialogue );
		
		// set dialogue out
		// TweenMax.delayedCall( 1.0, setDialogueReady, [ pDialogue ] );
		// TweenMax.delayedCall( 1.0, setDialogueReady, [ bDialogue ] );
	}
	
	function playDialogue()
	{
		if( curDia.num >= curDia.script.length )
		{
			hideDialogues();
			return;
		}
		
		var line = curDia.script[ curDia.num ];
		TweenMax.to( line.target.bubble, .2, {scaleX:1, scaleY:1, ease:Back.easeOut} );
		
		var i;
		var txt;
		var delayer = 0.2;
		
		for(i=0; i<line.txt.length+1; i++)
		{
			txt = line.txt.substring(0, i);
			TweenMax.delayedCall( delayer, setDialogueText, [line.target.txt, txt]);
			delayer+=.01;
		}
		
		TweenMax.delayedCall( delayer+0.5, setDialogueReady, [ pDialogue ] );
		TweenMax.delayedCall( delayer+0.5, setDialogueReady, [ bDialogue ] );
	}
	
	function setDialogueText(targ, txt)
	{
		targ.innerHTML = txt;
	}
	
	function hideDialogues()
	{
		TweenMax.to( pDialogue, .2, {delay:0.0, x:0-600, ease:Quad.easeOut});
		TweenMax.to( bDialogue, .2, {delay:0.0, x:600-472+600, ease:Quad.easeOut});
		
		if( tankBodies[0] )
		{
			activateTankBattle();
		}
		if( gridnok )
		{
			activateGridnokBattle();
		}
		if( blackfire )
		{
			activateBlackfireBattle();
		}
		
		pDialogue.ready = false;
		bDialogue.ready = false;
	}
	
	function setBossActive(boss)
	{
		boss.active = true;
		
		if( boss == gridnok )
		{
			gridnok.animations.play('walk', 24, true);
		}
		if( boss == blackfire )
		{
			blackfire.animations.play('walk', 24, true);
		}
	}
	
	//--------------------------- BOSS METHODS: TANK

	function buildBoss01(box)
	{
		console.log('build boss: 1');
		
		// check for bosses
		if(bosses.children.length>0)
		{
			console.log('boss active already');
			return;
		}
		
		// build
		var boss = game.add.group();
		boss.x = box.x;
		boss.y = box.y;
		boss.startX = boss.x;
		map.add(boss);
				
		var sprite;
		var i;
		var j;
		
		// build backpart
		var back = game.add.group();
		boss.back = back;
		backart.add(back);
		
		sprite = game.add.sprite(0, 0, 'boss01body-long');
		sprite.x = box.x+112;
		sprite.y = box.y-10;
		back.add(sprite);
		
		sprite = game.add.sprite(0, 0, 'boss01body-ext');
		sprite.x = box.x+112+338;
		sprite.y = box.y-10;
		sprite.width = 2000;
		back.add(sprite);
		
		// array for targets
		tankBodies = [];
		
		// body
		sprite = game.add.sprite(0, 0, 'boss01body');
		sprite.x = 6;
		sprite.y = 10;
		boss.add(sprite);
		boss['main'] = sprite;
		
		// canons
		for(i=1; i<=2; i++)
		{
			sprite = game.add.sprite(0, 0, 'boss01canon-beam');
			sprite.anchor.setTo(1,.5);
			sprite.x = 66;
			sprite.y = 28 + ((i-1)*262);
			sprite.width = 400;
			boss.add(sprite);
			var beam = sprite;
			
			sprite = game.add.sprite(0, 0, 'boss01canon-cap');
			sprite.anchor.setTo(1,.5);
			sprite.x = 66;
			sprite.y = 28 + ((i-1)*262);
			boss.add(sprite);
			var cap = sprite;
			cap.endHeight = cap.height;
			cap.endWidth = cap.width;
			
			// canon-good
			sprite = game.add.sprite(0, 0, 'boss01canon');
			sprite.x = 58;
			sprite.y = -24 + ((i-1)*262);
			boss.add(sprite);
			
			sprite.cap = cap;
			sprite.beam = beam;
			boss['canon'+i] = sprite;
			
			// canon-ok
			sprite = game.add.sprite(0, 0, 'boss01canonB');
			sprite.x = 58;
			sprite.y = -24 + ((i-1)*262);
			boss.add(sprite);
			boss['canon'+i+'-b'] = sprite;
			sprite.alpha = 0;
			
			// canon-dead
			sprite = game.add.sprite(0, 0, 'boss01canonC');
			sprite.x = 58;
			sprite.y = -24 + ((i-1)*262);
			boss.add(sprite);
			boss['canon'+i+'-c'] = sprite;
			sprite.alpha = 0;
			
			// set beam/cap
			TweenMax.to(beam, 0, {width:0});
			TweenMax.to(cap, 0, {width:0, height:0, alpha:0});
		}
		
		// turrets
		for(i=1; i<=2; i++)
		{
			sprite = game.add.sprite(0, 0, 'boss01turret');
			sprite.x = 4 + 36;
			sprite.y = 52 + ((i-1)*136) + 36;
			sprite.anchor.setTo(.5,.5);
			boss.add(sprite);
			boss['turret'+i] = sprite;
			
			// turret-ok
			sprite = game.add.sprite(0, 0, 'boss01turretB');
			sprite.x = 4 + 36;
			sprite.y = 52 + ((i-1)*136) + 36;
			sprite.anchor.setTo(.5,.5);
			boss.add(sprite);
			boss['turret'+i+'-b'] = sprite;
			sprite.alpha = 0;
			
			// canon-dead
			sprite = game.add.sprite(0, 0, 'boss01turretC');
			sprite.x = 4 + 36;
			sprite.y = 52 + ((i-1)*136) + 36;
			sprite.anchor.setTo(.5,.5);
			boss.add(sprite);
			boss['turret'+i+'-c'] = sprite;
			sprite.alpha = 0;
		}
		
		// shields
		sprite = game.add.sprite(0, 0, 'boss01shieldA');
		sprite.x = 0;
		sprite.y = 108;
		boss.add(sprite);
		boss['shieldA'] = sprite;
		
		sprite = game.add.sprite(0, 0, 'boss01shieldB');
		sprite.x = 0;
		sprite.y = 108;
		boss.add(sprite);
		boss['shieldB'] = sprite;
		sprite.alpha = 0;
		
		sprite = game.add.sprite(0, 0, 'boss01shieldC');
		sprite.x = 0;
		sprite.y = 108;
		boss.add(sprite);
		boss['shieldC'] = sprite;
		sprite.alpha = 0;
		
		// drills
		sprite = game.add.sprite(0, 0, 'boss01drill');
		sprite.x = 0;
		sprite.y = 0;
		back.add(sprite);
		
		// targets-main:
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(.5,.5);
		sprite.x = box.x + 54;
		sprite.y = box.y + 156;
		sprite.shieldHealth = tankHealthShield;
		tankBodies[0] = sprite;
				
		// init values
		sprite.health = tankHealth;//100;
		sprite.maxHealth = sprite.health;
		sprite.row = box.row;
		sprite.col = box.col;
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
		sprite.id = 'boss';
		sprite.mode = 'boss';
		sprite.type = 'tank';
		sprite.boss = boss;
		sprite.alpha = 0;
		
		// add hooks
		sprite['canon1'] = boss['canon1'];
		sprite['canon1-b'] = boss['canon1-b'];
		sprite['canon1-c'] = boss['canon1-c'];
		sprite['canon2'] = boss['canon2'];
		sprite['canon2-b'] = boss['canon2-b'];
		sprite['canon2-c'] = boss['canon2-c'];
		sprite['turret1'] = boss['turret1'];
		sprite['turret1-b'] = boss['turret1-b'];
		sprite['turret1-c'] = boss['turret1-c'];
		sprite['turret2'] = boss['turret2'];
		sprite['turret2-b'] = boss['turret2-b'];
		sprite['turret2-c'] = boss['turret2-c'];
		sprite.active = false;
		sprite.art = boss;
					
		// settings
		sprite.fireReady01 = true;
		sprite.fireReady02 = true;
		sprite.fireReady03 = true;
		
		// add boss
		bosses.add( sprite );
		
		// targets: canon1
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(.5,.5);
		sprite.boss = boss;
		sprite.x = box.x + 80;
		sprite.y = box.y + 20;
		sprite.mode = 'tank-canon1';
		sprite.health = Math.floor(tankHealthCanon);
		tankBodies[1] = sprite;
		bosses.add( sprite );
		sprite.alpha = 0;
		
		// targets: canon2
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(.5,.5);
		sprite.boss = boss;
		sprite.x = box.x + 80;
		sprite.y = box.y + 290;
		sprite.mode = 'tank-canon2';
		sprite.health = Math.floor(tankHealthCanon);
		tankBodies[2] = sprite;
		bosses.add( sprite );
		sprite.alpha = 0;
		
		// targets: turret1
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(.5,.5);
		sprite.boss = boss;
		sprite.x = box.x + 40;
		sprite.y = box.y + 90;
		sprite.mode = 'tank-turret1';
		sprite.health = Math.floor(tankHealthTurret);
		tankBodies[3] = sprite;
		bosses.add( sprite );
		sprite.alpha = 0;
		
		// targets: turret2
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(.5,.5);
		sprite.boss = boss;
		sprite.x = box.x + 40;
		sprite.y = box.y + 224;
		sprite.mode = 'tank-turret2';
		sprite.health = Math.floor(tankHealthTurret);
		tankBodies[4] = sprite;
		bosses.add( sprite );
		sprite.alpha = 0;
		
		// targets: body
		sprite = game.add.sprite(0, 0, 'player_body');
		sprite.anchor.setTo(0,0);
		sprite.x = box.x + 120;
		sprite.y = box.y - 10;
		sprite.height = 338;
		sprite.width = 3000;
		tankBodies[5] = sprite;
		bosses.add( sprite );
		sprite.alpha = 0;
		
		// audio
		var s = tankBodies[0];
		s.audio = [];
		s.audio.shot1 = game.add.audio('t_shot1');
		s.audio.shot2 = game.add.audio('t_shot2');
		s.audio.laser = game.add.audio('t_laser');
		s.audio.breakCanon = game.add.audio('t_breakCanon');
		s.audio.breakShield = game.add.audio('t_breakSheild');
		s.audio.breakTurret = game.add.audio('t_breakTurret');
	}
	
	function fireBoss01Turrets(boss)
	{
		if(boss.active==false){ return; }
		
		//console.log('fire turret');
		
		var i,j,t;
		var vx,vy;	
		var nx,ny;
		var ang;	
		var delayer;

		for(i=1; i<=2; i++)
		{
			
			console.log(  ( boss['turret'+i+'-c'].alpha!=1) );
			
			if( ( boss['turret'+i+'-c'].alpha!=1) )
			{
				t = boss['turret'+i];
				var ang = (t.angle-180) * (Math.PI/180);
				vx = Math.cos(ang) * EBULLET_SPEED;
				vy = Math.sin(ang) * EBULLET_SPEED;
			
				var realXDiff = 0;//tankBodies[0].boss.xDiff;
				nx = (Math.cos(ang) * 26) + (t.x+boss.x+realXDiff) - 60;
				ny = (Math.sin(ang) * 26) + (t.y+boss.y) - 150;
			
				delayer = 0.0;
				for(j=1; j<=3; j++)
				{
					TweenMax.delayedCall(delayer, shootTurretBullet, [nx,ny,vx,vy] );
					delayer+=.3;
				}
			}
			
			
		}
	}
		
	function shootTurretBullet(nx,ny,vx,vy)
	{
		//if(boss.active==false){ return; }
		
		var bullet = ebullets.getFirstExists(false);
        if(bullet)
        {
            bullet.reset( nx, ny );
			bullet.alpha = 1;
			bullet.damage = 1;
            bullet.body.velocity.x = vx;
			bullet.body.velocity.y = vy;
        }
		
		// audio
		var rnum = Math.floor(Math.random()*2)+1;
		tankBodies[0].audio['shot'+rnum].play('',0,sfxVolume);
	}
	
	function resetBossAttack01(boss)
	{
		boss.fireReady01 = true;
	}
	
	function fireBoss01Canon(boss)
	{
		if(boss.active==false){ return; }
		
		var i,j,c;
		var vx,vy;	
		var nx,ny;
		
		var rC = Math.floor(Math.random()*2) + 1;
		c = boss['canon'+rC];
		if( rC==1 )
		{
			if( boss['canon1-c'].alpha==1 )
			{
				return;
			}
		}
		if( rC==2 )
		{
			if( boss['canon2-c'].alpha==1 )
			{
				return;
			}
		}
		
		// grow cap & beam
		TweenMax.to( c.cap,		 2.0, {delay:0.0, width:c.cap.endWidth, height:c.cap.endHeight, alpha:1, ease:Quad.easeIn});
		TweenMax.to( c.beam, 	  .2, {delay:2.2, width:2000, ease:Quad.easeOut});
		
		// hide cap & beam
		TweenMax.to( c.cap,		  .2, {delay:5.1, width:0, height:0, alpha:0, ease:Quad.easeOut});
		TweenMax.to( c.beam, 	  .1, {delay:5.0, width:0, ease:Quad.easeOut});
		
		// shots fired
		var delayer = 2.0;
		for(i=0; i<=24; i++)
		{
			TweenMax.delayedCall( delayer, shootCanonBullet, [boss,rC] );
	
			if( i%8==0 )
			{
				TweenMax.delayedCall( delayer, playTankLaser );
			}
			
			delayer+=.1;
		}
		
		
	} 
	
	function playTankLaser()
	{
		tankBodies[0].audio.laser.play('',0,sfxVolume);
	}
	
	function shootCanonBullet(boss, num)
	{
		//if(boss.active==false){ return; }
		
		var c = boss['canon'+num];
		var realXDiff = 0;//tankBodies[0].boss.xDiff;
		var nx = c.x + boss.x - 60 + realXDiff;
		var ny = c.y + boss.y - 106;
		
		var bullet = ebullets.getFirstExists(false);
        if(bullet)
        {
            bullet.reset( nx, ny );
			bullet.damage = 1;
			bullet.alpha = .4;
            bullet.body.velocity.x = -1000;
        }
	}
	
	function resetBossAttack02(boss)
	{
		boss.fireReady02 = true;
	}
	
	function activateTankIntro()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		player.locked = true;
		TweenMax.delayedCall( 1.0, moveToTank );
		
		// set audio
		musicTrack.stop();
		musicTrack = game.add.audio('m_boss1');
   	 	musicTrack.play('',0,musicVolume);
		background.audio.bossStart.play('',0,sfxVolume);
	}
	
	function moveToTank()
	{
		player.body.moves = false;
		TweenMax.to( player, 1.5, {delay:0.0, x:1500, ease:Quad.easeInOut});
		
		// set dialogue
		TweenMax.delayedCall(1.5, setDialogues, ['tank'] );
	}
	
	function activateTankBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		console.log('activate tank');
		
		// set text
		bossMenu.txtb.innerHTML = 'Tamaranian Tank';
		bossMenu.txt.innerHTML = 'Tamaranian Tank';
		player.locked = false;
		player.body.moves = true;
		
		// set boss to active
		TweenMax.delayedCall( 1.0, setBossActive, [ tankBodies[0] ] );
			
		// add top lock
		for(i=16; i<=18; i++)
		{
			row = (tankStartRow)+7;
			col = i;
			newY = (row*64) + HORIZON_Y;
			newX = (col*64);
			
			tileMatrix[row][col] = 1000;
			
			box = platforms.create(newX, newY, 'edge_stone');
			box.isStone = true;
			box.body.immovable = true;
			
			if( allTiles[row] )
			{
				allTiles[row][col] = box;
			}
		}
		
		// show boss bar
		TweenMax.to(bossMenu.bar, 0, {scaleX:0, ease:Quad.easeOut});
		TweenMax.to(bossMenu.bar, .3, {delay:1.0, scaleX:1, ease:Quad.easeOut});
		TweenMax.to(bossMenu, 1.0, {y:bossMenu.endY, ease:Quad.easeOut});
	}
	
	function deactivateTankBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		var dirt;
		
		console.log('deactivate tank');
		
		// remove top lock
		for(i=16; i<=18; i++)
		{
			row = (tankStartRow)+7;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
			
		// remove bottom lock
		for(i=16; i<=18; i++)
		{
			row = (tankStartRow)+7+8;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
		
		// remove tank bodies
		for(i=tankBodies.length-1; i>=0; i--)
		{
			tankBodies[i].destroy();
		}
		
		TweenMax.to( bossMenu, 1.0, {y:bossMenu.startY, ease:Quad.easeIn});
		
		// set audio
		musicTrack.stop();
		musicTrack = game.add.audio('m_zone'+player.curZone);
   	 	musicTrack.play('',0,musicVolume);
		background.audio.bossEnd.play('',0,sfxVolume);
	}
	
	//--------------------------- BOSS METHODS: GRIDNOK
	
	function buildBoss02(box)
	{
		console.log('build boss: 2');
		
		// check for bosses
		if(bosses.children.length>0)
		{
			console.log('boss active already');
			return;
		}
		
		// build
		var boss;
		var sprite;
		var i;
		var j;
		
		var sprite;
		boss = sprite;
		
		// sprite data
		sprite = game.add.sprite(0, 0, 'gridnok');
		
		sprite.animations.add('charge-ready', [12,13]);
		sprite.animations.add('charge', [14,15]);
		sprite.animations.add('charge-out', [16,17,18,19]);
		sprite.animations.add('boulder-hold', [20,21]);
		sprite.animations.add('boulder-throw', [22,23]);
		sprite.animations.add('eat-ready', [24]);
		sprite.animations.add('eat-in', [25,26,27]);
		sprite.animations.add('eat-out', [28,29,30,31,32,33]);
		sprite.animations.add('death', [34,35,36,37,37,37,37,37,37,38,39,40,41,42,43]);
		sprite.animations.add('walk', [0,1,2,3,4,5,6,7,8,9,10,11]);
				
		//sprite.animations.play('walk', 24, true);
		//sprite.play();
		
		sprite.anchor.setTo(.5,.9);
		sprite.x = box.x-800;
		sprite.y = box.y+110;
		
		// init values
		sprite.health = gridnokHealth;
		sprite.maxHealth = sprite.health;
		sprite.direction = 1;
		sprite.speed = GRIDNOK_SPEED;
		
		sprite.row = box.row;
		sprite.col = box.col;
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
		sprite.body.gravity.y = 500;
		sprite.body.setSize(120, 130, 0, 0);
		
		// debugging
		testEnemy = sprite;
		gridnok = sprite;
		
		// set strings
		sprite.id = 'boss';
		sprite.mode = 'boss';
		sprite.type = 'gridnok';
		sprite.boss = sprite;
		sprite.status = 'walking';
		sprite.active = false;
		
		// set next move
		sprite.moveDelay = 100;
		sprite.moveCount = 100;
		sprite.nextMove = 1;
		
		// add boss
		bosses.add( sprite );
		
		// audio
		sprite.audio = [];
		sprite.audio.active = [ game.add.audio('g_shot1'), game.add.audio('g_shot2') ];
		sprite.audio.step = [ game.add.audio('g_step1'), game.add.audio('g_step2'), game.add.audio('g_step3'), game.add.audio('g_step4') ];
		sprite.audio.hurt = [ game.add.audio('g_hurt1'), game.add.audio('g_hurt2'), game.add.audio('g_hurt3') ];
		sprite.audio.throw = [ game.add.audio('g_throw1'), game.add.audio('g_throw2')];
		sprite.audio.boulder = game.add.audio('g_boulderhit');
		sprite.audio.charge = game.add.audio('g_charge');
		sprite.audio.death = game.add.audio('g_death');
		sprite.audio.eat = game.add.audio('g_eat');
		
		// settings
		//boss.fireReady01 = true;
		//boss.fireReady02 = true;
		//boss.fireReady03 = true;
	}
	
	function onGridnokCharge()
	{
		console.log('charge!');
		gridnok.status = 'hold';
		gridnok.animations.play('charge-ready', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(0.5, chargeGridnok);
	}
	
	function chargeGridnok()
	{
		gridnok.status = 'charging';
		gridnok.animations.play('charge', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(1.0, endChargeGridnok);
		
		gridnok.audio.charge.play('',0,sfxVolume);
	}
	
	function endChargeGridnok()
	{
		gridnok.status = 'hold';
		gridnok.animations.play('charge-out', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(0.3, onGridnokAttackEnd);
	}
	
	function onGridnokThrow()
	{
		console.log('throw!');
		gridnok.status = 'hold';
		gridnok.animations.play('boulder-hold', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(0.5, gridnoKThrow);
	}
	
	function gridnoKThrow()
	{
		gridnok.status = 'hold';
		gridnok.animations.play('boulder-throw', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(1.0, onGridnokAttackEnd);
		
		// audio
		var rnum = Math.floor(Math.random()*2)+1;
		gridnok.audio.throw[rnum].play();
	}
		
	function onGridnokEat()
	{
		console.log('eat!');
		gridnok.status = 'hold';
		gridnok.animations.play('eat-ready', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(1.0, gridnokEat);
	}
	
	function gridnokEat()
	{
		gridnok.status = 'hold';
		gridnok.animations.play('eat-in', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(1.5, endGridnokEat);
		
		gridnok.audio.eat.play('',0,sfxVolume);
	}
	
	function endGridnokEat()
	{
		gridnok.status = 'hold';
		gridnok.animations.play('eat-out', 24, false);
		gridnok.play();
		
		TweenMax.delayedCall(1.0, onGridnokAttackEnd);
	}
	
	function onGridnokAttackEnd()
	{
		gridnok.status = 'walking';
		gridnok.animations.play('walk', 24, true);
		gridnok.play();
	}
	
	function onGridnokDeath()
	{
		console.log('death!');
		gridnok.status = 'hold';
		gridnok.animations.play('death', 24, false);
		gridnok.play();
		
		gridnok.audio.death.play('',0,sfxVolume);
	}
	
	function activateGridnokIntro()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		player.locked = true;
		TweenMax.delayedCall( 1.0, moveToGridnok );
		
		// set audio
		musicTrack.stop();
		musicTrack = game.add.audio('m_boss2');
   	 	musicTrack.play('',0,musicVolume);
		background.audio.bossStart.play('',0,sfxVolume);
	}
	
	function moveToGridnok()
	{
		player.body.moves = false;
		TweenMax.to( player, 1.5, {delay:0.0, x:1000, ease:Quad.easeInOut});
		
		// set dialogue
		TweenMax.delayedCall(1.5, setDialogues, ['gridnok'] );
	}
	
	function activateGridnokBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		console.log('activate gridnok');
		
		// set text
		bossMenu.txtb.innerHTML = 'The Gridnok';
		bossMenu.txt.innerHTML = 'The Gridnok';
		player.locked = false;
		player.body.moves = true;
		
		// set boss to active
		TweenMax.delayedCall( 1.0, setBossActive, [ gridnok ] );
			
		// add top lock
		for(i=16; i<=18; i++)
		{
			row = (gridnokStartRow)+7;
			col = i;
			newY = (row*64) + HORIZON_Y;
			newX = (col*64);
			
			tileMatrix[row][col] = 1000;
			
			box = platforms.create(newX, newY, 'edge_stone');
			box.isStone = true;
			box.body.immovable = true;
			
			if( allTiles[row] )
			{
				allTiles[row][col] = box;
			}
		}
		
		// show boss bar
		TweenMax.to(bossMenu.bar, 0, {scaleX:0, ease:Quad.easeOut});
		TweenMax.to(bossMenu.bar, 1.0, {delay:1.0, scaleX:1, ease:Quad.easeOut});
		TweenMax.to(bossMenu, 1.0, {y:bossMenu.endY, ease:Quad.easeOut});
	}
	
	function deactivateGridnokBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		var dirt;
		
		console.log('deactivate gridnok');
		
		// remove top lock
		for(i=16; i<=18; i++)
		{
			row = (gridnokStartRow)+7;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
			
		// remove bottom lock
		for(i=16; i<=18; i++)
		{
			row = (gridnokStartRow)+7+8;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
		
		TweenMax.to( bossMenu, 1.0, {y:bossMenu.startY, ease:Quad.easeIn});
		
		// set audio
		musicTrack.stop();
		musicTrack = game.add.audio('m_zone'+player.curZone);
   	 	musicTrack.play('',0,musicVolume);
		background.audio.bossEnd.play('',0,sfxVolume);
	}
	
	//--------------------------- BOSS METHODS: BLACKFIRE
	
	function buildBoss03(box)
	{
		console.log('build boss: 3');
		
		// check for bosses
		if(bosses.children.length>0)
		{
			console.log('boss active already');
			return;
		}
		
		// build
		var boss;
		var sprite;
		var i;
		var j;
		
		var sprite;
		boss = sprite;
		
		// sprite data
		sprite = game.add.sprite(0, 0, 'blackfire');
		
		// animations
		sprite.animations.add('stand', [0]);
		sprite.animations.add('walk', [1,2,3,4,5,6,7,8,9,10,11,12]);
		sprite.animations.add('charge', [13,14,15,16,17,18,19,16,17,18,19]);
		sprite.animations.add('clap', [20,21]);
		sprite.animations.add('beam', [23,24]);
		sprite.animations.add('stomp', [25,26,27,28,27,28,27,28,27,28,27,28]);
		sprite.animations.add('throw', [29,30,31,32,33,34]);
		sprite.animations.add('death', [35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52]);
		sprite.animations.add('dead', [53]);
		
		// set to stand	
		sprite.animations.play('stand', 24, false);
		sprite.play();
		
		sprite.anchor.setTo(.5,.85);
		sprite.x = box.x+0;
		sprite.y = box.y+110;
		
		// init values
		sprite.health = blackfireHealth;//100;
		sprite.maxHealth = sprite.health;
		sprite.direction = 1;
		sprite.speed = BLACKFIRE_SPEED;
		
		sprite.row = box.row;
		sprite.col = box.col;
		
		// set physics
		game.physics.arcade.enable(sprite);
		sprite.enableBody = true;
		sprite.body.gravity.y = 500;
		sprite.body.setSize(80, 210, 0, 0);
		
		// debugging
		testEnemy = sprite;
		blackfire = sprite;
		
		// set strings
		sprite.id = 'boss';
		sprite.mode = 'boss';
		sprite.type = 'blackfire';
		sprite.boss = sprite;
		sprite.status = 'walking';
		sprite.active = false;
		
		// set next move
		sprite.moveDelay = 100;
		sprite.moveCount = 100;
		sprite.nextMove = 1;
		
		// audio
		sprite.audio = [];
		sprite.audio.beam = [ game.add.audio('b_beam1'), game.add.audio('b_beam2') ];
		sprite.audio.step = [ game.add.audio('b_step1'), game.add.audio('b_step2'), game.add.audio('b_step3'), game.add.audio('b_step4') ];
		sprite.audio.wave = game.add.audio('b_wave');
		sprite.audio.rain = game.add.audio('b_rain');
		sprite.audio.rocks = game.add.audio('b_rocks');
		sprite.audio.bomb = game.add.audio('b_bomb');
		sprite.audio.death = game.add.audio('b_death');
		
		// add boss
		bosses.add( sprite );
	}
	
	function activateBlackfireIntro()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		player.locked = true;
		TweenMax.delayedCall( 1.0, moveToBlackfire );
		
		// set audio
		musicTrack.stop();
		musicTrack = game.add.audio('m_boss3');
   	 	musicTrack.play('',0,musicVolume);
		background.audio.bossStart.play('',0,sfxVolume);
	}
	
	function moveToBlackfire()
	{
		player.body.moves = false;
		TweenMax.to( player, 1.5, {delay:0.0, x:1460, ease:Quad.easeInOut});
		
		// flip blackfire
		blackfire.scale.x = -1;
		blackfire.direction = -1;
		
		// set dialogue
		TweenMax.delayedCall(1.5, setDialogues, ['blackfire'] );
	}
	
	function activateBlackfireBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		
		console.log('activate blackfire');
		
		// set text
		bossMenu.txtb.innerHTML = 'Blackfire';
		bossMenu.txt.innerHTML = 'Blackfire';
		player.locked = false;
		player.body.moves = true;
		
		// set boss to active
		TweenMax.delayedCall( 1.0, setBossActive, [ blackfire ] );
			
		// add top lock
		for(i=16; i<=18; i++)
		{
			row = (blackfireStartRow)+7;
			col = i;
			newY = (row*64) + HORIZON_Y;
			newX = (col*64);
			
			tileMatrix[row][col] = 1000;
			
			box = platforms.create(newX, newY, 'edge_stone');
			box.isStone = true;
			box.body.immovable = true;
			
			if( allTiles[row] )
			{
				allTiles[row][col] = box;
			}
		}
		
		// show boss bar
		TweenMax.to(bossMenu.bar, 0, {scaleX:0, ease:Quad.easeOut});
		TweenMax.to(bossMenu.bar, 1.0, {delay:1.0, scaleX:1, ease:Quad.easeOut});
		TweenMax.to(bossMenu, 1.0, {y:bossMenu.endY, ease:Quad.easeOut});
	}
	
	function chargeBlackfire()
	{
		if( player.x > blackfire.x )
		{
			blackfire.scale.x = 1;
			blackfire.direction = 1;
		}
		else
		{
			blackfire.scale.x = -1;
			blackfire.direction = -1;
		}
		
		blackfire.status = 'hold';
		blackfire.play('charge',24,false);
	}
	
	function clapBlackfire()
	{
		blackfire.status = 'hold';
		blackfire.play('clap',24,false);
		
		var i;
		var delayer = 0.1;
		var beamLimit = 3;
		
		for(i=0; i<beamLimit; i++)
		{
			TweenMax.delayedCall( delayer, blackfireWave );
			delayer+=.2;
		}
		
		TweenMax.delayedCall(1.5, resumeBlackfireWalk);
	}
	
	function blackfireWave()
	{
		//console.log("blackfire laser fire!");
		
		var newX = blackfire.x;
		var newY = blackfire.y - 110;
		
		if(blackfire.direction==-1)
		{
			newX = blackfire.x - 90;
		}
		else
		{
			newX = blackfire.x + 100;
		}
			
		// calc physics
		var dx,dy,dt,vx,vy,ang,deg;
		var degs, i, bullet;
		
		if(blackfire.direction==-1)
		{
			degs = [-180,-135,-215];
		}
		else
		{
			degs = [0,45,-45];
		}
		
		for(i=0; i<degs.length; i++)
		{
			bullet = game.add.sprite(newX, newY, 'blackfire_wave');
			bullet.anchor.setTo(.5,.5);		
			game.physics.arcade.enable(bullet);
			bullet.body.outOfBoundsKill = true;
			bullet.body.checkWorldBounds = true;
			
			deg = degs[i];
			ang = deg * (Math.PI/180);
		
			vx = Math.cos(ang)*blackfireLaserSpeed;
			vy = Math.sin(ang)*blackfireLaserSpeed;
		
			bullet.damage = 1;
			bullet.body.moves = false;
			bullet.angle = deg;
			bullet.body.moves = true;
		
	        bullet.body.velocity.x = vx;
			bullet.body.velocity.y = vy;
			ebullets.add(bullet);
		
			TweenMax.delayedCall( 2.0, removeImg, [bullet]);
		}
		
		blackfire.audio.wave.play('',0,sfxVolume);
	}
	
	function beamBlackfire()
	{
		blackfire.status = 'hold';
		blackfire.play('beam',24,true);
		
		var i;
		var delayer = 0.0;
		var beamLimit = 16;
		
		for(i=0; i<beamLimit; i++)
		{
			TweenMax.delayedCall( delayer, blackfireLaser );
			delayer+=.1;
		}
		
		TweenMax.delayedCall(2.0, resumeBlackfireWalk);
	}
	
	function blackfireLaser()
	{
		//console.log("blackfire laser fire!");
		
		var newX = blackfire.x;
		var newY = blackfire.y - blackfire.height + 110;
		
		if(blackfire.direction==-1)
		{
			newX = blackfire.x - 30;
		}
		else
		{
			newX = blackfire.x + 50;
		}
		
		var bullet = game.add.sprite(newX, newY, 'blackfire_laser');
		
		bullet.anchor.setTo(.5,.5);		
		game.physics.arcade.enable(bullet);
		bullet.body.outOfBoundsKill = true;
		bullet.body.checkWorldBounds = true;
		
		// calc physics
		var dx,dy,dt,vx,vy,ang,deg;
		
		if(blackfire.direction==-1)
		{
			deg = 180-20;
		}
		else
		{
			deg = -20;
		}
		
		deg += Math.random() * 45;
		ang = deg * (Math.PI/180);
		
		vx = Math.cos(ang)*blackfireLaserSpeed;
		vy = Math.sin(ang)*blackfireLaserSpeed;
		
		bullet.damage = 1;
		bullet.body.moves = false;
		bullet.angle = deg;
		//bullet.body.rotation = deg;
		bullet.body.moves = true;
		
        bullet.body.velocity.x = vx;
		bullet.body.velocity.y = vy;
		ebullets.add(bullet);
		
		//TweenMax.delayedCall( .4, restoreDroneReady);
		TweenMax.delayedCall( 2.0, removeImg, [bullet]);
		
		// audio
		var rnum = Math.floor(Math.random()*2)+0;
		blackfire.audio.beam[rnum].play('',0,sfxVolume);
	}
	
	function stompBlackfire()
	{
		blackfire.status = 'hold';
		blackfire.play('stomp',24,false);
		
		var i;
		var delayer = 0.1;
		var beamLimit = 3;
		
		for(i=0; i<beamLimit; i++)
		{
			TweenMax.delayedCall( delayer, blackfireBlast );
			delayer+=.1;
		}
		
		TweenMax.delayedCall(1.5, resumeBlackfireWalk);
	}
	
	function blackfireBlast()
	{
		//console.log("blackfire blast fire!");
		
		var newX = blackfire.x;
		var newY = blackfire.y-60;
		
		if(blackfire.direction==-1)
		{
			newX = blackfire.x - 10;
		}
		else
		{
			newX = blackfire.x + 10;
		}
		
		var bullet = game.add.sprite(newX, newY, 'blackfire_blast');		
		bullet.anchor.setTo(.5,.5);		
		effectsLayer.add(bullet);
		
		TweenMax.to( bullet.scale, 	.5, {x:3, ease:Quad.easeOut});
		TweenMax.to( bullet.scale,	.5, {y:3, ease:Quad.easeOut});
		TweenMax.to( bullet, 		.2, {delay:.3, alpha:0, ease:Quad.easeOut});
		
		TweenMax.delayedCall( 1.0, removeImg, [bullet]);
		
		// check damage
		var dx,dy,dt;
		dx = player.x - newX;
		dy = player.y - newY;
		dt = Math.sqrt( (dx*dx) + (dy*dy) );
		console.log( dt );
		if( dt < 250 )
		{
			damagePlayer(1);
		}
		
		// audio
		blackfire.audio.bomb.play('',0,sfxVolume);
	}
	
	function throwBlackfire()
	{
		blackfire.status = 'hold';
		blackfire.play('throw',24,false);
		
		TweenMax.delayedCall(1.5, resumeBlackfireWalk);
	}
	
	function deathBlackfire()
	{
		blackfire.status = 'hold';
		blackfire.play('death',24,false);
	}
	
	function resumeBlackfireWalk()
	{
		blackfire.status = 'walking';
		blackfire.play('walk',24,true);
	}
	
	function deactivateBlackfireBattle()
	{
		var box;
		var col;
		var row;
		var newX;
		var newY;
		var i;
		var dirt;
		
		console.log('deactivate blackfire');
		
		// remove top lock
		for(i=16; i<=18; i++)
		{
			row = (gridnokStartRow)+7;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
			
		// remove bottom lock
		/*
		for(i=16; i<=18; i++)
		{
			row = (gridnokStartRow)+7+8;
			col = i;
			tileMatrix[row][col] = 0;
			
			if( allTiles[row] )
			{
				box = allTiles[row][col];
				
				// add back dirt
				dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
				dirt.x = box.x;
				dirt.y = box.y;
				dirt.isDirt = true;
				backtiles.add(dirt);
				allTiles[box.row][box.col] = dirt;
				
				// remove tiles
				box.destroy();
			}
			else
			{
				console.log('no tiles at: ' + row );
			}
			
		}
		*/
		
		TweenMax.to( bossMenu, 1.0, {y:bossMenu.startY, ease:Quad.easeIn});
		
		// set audio
		musicTrack.stop();
		background.audio.bossEnd.play('',0,sfxVolume);
		
		// move to ending
		player.isDead = true;
		player.locked = true;
		TweenMax.delayedCall(3.0, moveToEnding);
	}
		
	function showEnding()
	{
		storeTileMatrix();
		cont.removeChild( holder );
		cont.removeChild( gui );
		TweenMax.killAll();
		
		Title.setEnding();
		TweenMax.delayedCall( 0.4 , Title.init );
	}
	
	function moveToEnding()
	{
		game.paused = true;
		titleMenu.txt.innerHTML = '';
		titleMenu.per.innerHTML = '';
		TweenMax.to( menus, .5, {delay:0.0, autoAlpha:1, ease:Quad.easeOut});
		
		//TweenMax.delayedCall(2.0, resetEngine);
		TweenMax.delayedCall(0.6, showEnding);
	}
	
	//--------------------------- MENU METHODS:

	function buildTitle()
	{
		var div;
		var img;
		var bar;

		// add menu dom
		menus = document.createElement("div");
		menus.className = "menuHolder";
		TweenMax.to( menus, 0, {y:-400, alpha:1});
		cont.appendChild( menus );
		
		// add title menu
		titleMenu = document.createElement("div");
		titleMenu.className = "menuHolder";
		titleMenu.style.background = "#000";
		TweenMax.to( titleMenu, 0, {autoAlpha:1});
		menus.appendChild( titleMenu );
		
		// add loading text
		div = document.createElement("div");
		div.style.width = '300px';
		div.style.height = '60px';
		div.style.position = "absolute"
		div.style.background = "#000";
		div.style.color = "#fff";
		div.style.fontSize = '50px';
		div.style.textAlign = 'center';
		div.style.fontFamily = 'Bangers';
		div.style.letterSpacing = '1.0px';
		div.innerHTML = 'building map';
		TweenMax.to( div, 0, {x:150, y:170, autoAlpha:0});
		TweenMax.to( div, .3, {delay:0.0, autoAlpha:1, ease:Quad.easeOut});
		titleMenu.appendChild( div );
		titleMenu.txt = div;
		
		// add % text
		div = document.createElement("div");
		div.style.width = '300px';
		div.style.height = '60px';
		div.style.position = "absolute"
		div.style.color = "#fff";
		div.style.fontSize = '26px';
		div.style.textAlign = 'center';
		div.style.fontFamily = 'Bangers';
		div.style.letterSpacing = '1.0px';
		div.innerHTML = '0%';
		TweenMax.to( div, 0, {x:150, y:224, autoAlpha:0});
		TweenMax.to( div, .3, {delay:0.0, autoAlpha:1, ease:Quad.easeOut});
		titleMenu.appendChild( div );
		titleMenu.per = div;
		
	}

	//--------------------------- GUI VIEW:

	function buildGui()
	{
		var div;
		var img;
		var bar;
		var i;
		var j;
		var newx, newy;
		
		// add key listener
		$( window ).keydown( onKeyPress );
		
		// add pause to gui
		var pause = document.createElement("div");
		pause.style.position = "absolute";
		pause.style.background = "#f5f";
		TweenMax.to(pause, 0, {x:12,y:14});
		gui.appendChild( pause );
		$( pause ).bind( "click", onPauseClick);
		
		img = document.createElement("img");
		img.style.position = "absolute";
		img.src = 'img/gui/gui_pause.png';
		pause.appendChild(img);
		
		// add hearts
		var hearts = document.createElement("div");
		hearts.style.position = "absolute";
		TweenMax.to(hearts, 0, {x:56,y:14});
		gui.appendChild( hearts );
		gui.hearts = hearts;
		
		var col=0;
		var row=0;
		for(i=0; i<8; i++)
		{
			div = document.createElement("div");
			hearts.style.position = "absolute";
			newx = col*29;
			newy = row*26;
			TweenMax.to(div, 0, {x:newx,y:newy});
			hearts.appendChild( div );
			hearts['h'+i] = div;
			
			for(j=1;j<=5;j++)
			{
				img = document.createElement("img");
				img.style.position = "absolute";
				img.src = 'img/gui/heart0'+j+'.png';
				div.appendChild(img);
				div['heart'+j] = img;
				
				if(j<5){ TweenMax.to(img,0,{alpha:0}); }
			}
			
			col++;
			if(col==4)
			{
				col=0;
				row++;
			}
		}
		
		// add meters to gui
		var meters = document.createElement("div");
		meters.style.position = "absolute";
		meters.style.background = "#f5f";
		TweenMax.to(meters, 0, {x:190,y:16+0});
		gui.appendChild( meters );
		gui.meters = meters;
		
		// new meters
		var i;
		var mnames = ['energy','storage'];
		for(i=0; i<mnames.length; i++)
		{
			var newX = (84*i) + 0;
			
			var m = document.createElement("div");
			m.style.position = "absolute";
			m.style.width = "60px";
			m.style.height = "24px";
			m.style.background = '#000000';
			m.style.border = '2px solid black';
			TweenMax.to( m, 0, {x:newX,y:0});
			meters.appendChild(m);
			meters[ mnames[i] ] = m;
			m.startX = newX;
			
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = "58px";
			div.style.height = "22px";
			div.style.background = 'url("img/gui/bg.png")';
			TweenMax.to( div, 0, {x:(2),y:1});
			m.appendChild(div);
			m.black = div;
			
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = "58px";
			div.style.height = "22px";
			div.style.background = '#5fede9';
			TweenMax.to( div, 0, {x:(2),y:1,scaleX:1,transformOrigin:'0% 50%'});
			m.appendChild(div);
			m.bar = div;
			
			img = document.createElement("img");
			img.style.position = "absolute";
			img.src = 'img/gui/icon_' + mnames[i] + '.png';
			if(i==0){ TweenMax.to( img, 0, {x:(-21),y:-2}); }
			if(i==1){ TweenMax.to( img, 0, {x:(-21),y:-4}); }
			m.appendChild(img);
		}
		
		// set meters
		setGuiMeters();
		
		// add powerups
		for(i=1; i<=2; i++)
		{
			var powerup = document.createElement("div");
			powerup.style.position = "absolute";
			powerup.style.width = "68px";
			powerup.style.height = "68px";
			TweenMax.to(powerup, 0, {x:10+((i-1)*76),y:312});
			gui.appendChild( powerup );
			gui['powerup'+i] = powerup;
			powerup.num = i;
			powerup.endX = 10+((i-1)*76);
			powerup.startX = powerup.endX - 300;
			TweenMax.to(powerup, 0, {x:powerup.startX});
		
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = "60px";
			div.style.height = "10px";
			div.style.background = '#000'
			div.style.border = '1px black solid'
			TweenMax.to(div, 0, {x:2,y:68});
			powerup.appendChild( div );
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = "54px";
			div.style.height = "4px";
			div.style.background = 'url("img/gui/bg.png")';
			div.style.border = '0px black solid'
			TweenMax.to(div, 0, {x:6,y:72});
			powerup.appendChild( div );
		
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = "54px";
			div.style.height = "4px";
			div.style.background = '#5fede9'
			div.style.border = '0px black solid'
			TweenMax.to(div, 0, {x:6,y:72});
			powerup.appendChild( div );
			powerup.bar = div;
		
			img = document.createElement("img");
			img.style.position = "absolute";
			img.src = 'img/gui/powerup_bg.png';
			powerup.appendChild(img);
		}
		
		// build tower upgrades
		TweenMax.delayedCall(2.0, buildTowerGui);
		
		// build boss gui
		TweenMax.delayedCall(2.0, buildBossGui);
		
		// build pause menu
		buildPauseMenu();
		
	}
	
	function buildTowerGui()
	{
		var div;
		var img;
		var bar;
		var i;
		var j;
		var newx, newy;
		
		// add key listener
		$( window ).keydown( onKeyPress );
		
		// add pause menu
		towerMenu = document.createElement("div");
		TweenMax.to( towerMenu, 0, {autoAlpha:0});
		gui.appendChild( towerMenu );
		
		div = document.createElement("div");
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.position = "absolute";
		div.style.background = "#000";
		TweenMax.to( div, 0, {alpha:.7});
		towerMenu.appendChild(div);
		towerMenu.black = div;
		
		div = document.createElement("div");
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.position = "absolute";
		div.style.background = "url('img/upgrade/bg.png')";
		towerMenu.appendChild(div);
		towerMenu.win = div;
		
		div = document.createElement("div");
		div.style.width = "162px";
		div.style.height = "44px";
		div.style.position = "absolute";
		div.style.cursor = 'pointer';
		div.style.background = "url('img/upgrade/continue.png')";
		TweenMax.to( div, 0, {x:376, y:170+30});
		towerMenu.appendChild(div);
		div.id = 'continue'
		$( div ).bind( "click", onTowerBtnClick);
		
		div = document.createElement("div");
		div.style.width = "162px";
		div.style.height = "44px";
		div.style.position = "absolute";
		div.style.cursor = 'pointer';
		div.style.background = "url('img/upgrade/portal.png')";
		TweenMax.to( div, 0, {x:376, y:220+30});
		towerMenu.appendChild(div);
		div.id = 'portal'
		$( div ).bind( "click", onTowerBtnClick);
		
		// text
		div = document.createElement("div");
		div.style.width = "200px";
		div.style.height = "60px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '42px';
		div.style.textAlign = "center";
		div.style.letterSpacing = '1.0px'
		div.style.color = "#ffffff";
		div.innerHTML = 'TOWER<br>UPGRADED!';
		TweenMax.to( div, 0, {x:354, y:90, autoAlpha:1});
		towerMenu.appendChild(div);
		
		// towers
		div = document.createElement("div");
		div.style.width = "485px";
		div.style.height = "506px";
		div.style.position = "absolute";
		div.style.border = '0px solid red';
		TweenMax.to( div, 0, {x:-30, y:-60, scaleX:.4, scaleY:.4});
		towerMenu.appendChild(div);
		towerMenu.towers = div;
		
		for(i=1; i<=15; i++)
		{
			div = document.createElement("div");
			div.style.width = "485px";
			div.style.height = "506px";
			div.style.position = "absolute";
			div.style.background = "url('img/tower/thumbs/t" +i+ ".png')";
			TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
			towerMenu.towers.appendChild(div);
			towerMenu.towers['t'+i] = div;
		}
		
		
	}
	
	function buildBossGui()
	{
		var div;
		var img;
		var bar;
		
		// add gui menu
		bossMenu = document.createElement("div");
		bossMenu.id = "bossMenu";
		TweenMax.to( bossMenu, 0, {x:340, y:360, autoAlpha:1});
		gui.appendChild( bossMenu );
		bossMenu.endY = 340;
		bossMenu.startY = 600;
		TweenMax.to(bossMenu, 0, {y:600});
		
		// bar
		div = document.createElement("div");
		div.style.width = "244px";
		div.style.height = "24px";
		div.style.position = "absolute";
		div.style.background = "#f00";
		TweenMax.set(div,{transformOrigin: "0% 50% 0"});
		TweenMax.to( div, 0, {x:2, y:2, scaleX:1, autoAlpha:1});
		bossMenu.appendChild(div);
		bossMenu.bar = div;
		
		// label
		div = document.createElement("div");
		div.style.width = "200px";
		div.style.height = "20px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '18px';
		div.style.fontWeight = '100';
		div.style.letterSpacing = "1.0px";
		div.innerHTML = 'Tamaranian Tank';
		TweenMax.to( div, 0, {x:10, y:7, scaleX:1, autoAlpha:1});
		bossMenu.appendChild(div);
		bossMenu.txtb = div;
		
		// label
		div = document.createElement("div");
		div.style.width = "200px";
		div.style.height = "20px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '18px';
		div.style.fontWeight = '100';
		div.style.letterSpacing = "1.0px";
		div.style.color = "#ffffff";
		div.innerHTML = 'Tamaranian Tank';
		TweenMax.to( div, 0, {x:8, y:5, scaleX:1, autoAlpha:1});
		bossMenu.appendChild(div);
		bossMenu.txt = div;
		
		/// DIALOGUES: Player ///
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		TweenMax.to( div, 0, {x:0-600, y:10, autoAlpha:1});
		gui.appendChild( div );
		pDialogue = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_player1.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:1});
		pDialogue.appendChild( div );
		pDialogue['p1'] = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_player2.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		pDialogue.appendChild( div );
		pDialogue['p2'] = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_player3.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		pDialogue.appendChild( div );
		pDialogue['p3'] = div;
		
		// bubble
		div = document.createElement("div");
		div.style.width = "286px";
		div.style.height = "84px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_player_bubble.png')";
		TweenMax.to( div, 0, {x:116, y:9, autoAlpha:1});
		pDialogue.appendChild( div );
		pDialogue.bubble = div;
		
		// txt
		div = document.createElement("div");
		div.style.width = "196px";
		div.style.height = "56px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '18px';
		div.style.fontWeight = '100';
		div.style.letterSpacing = "0.3px";
		div.style.border = '0px solid red';
		div.style.color = "#000";
		div.innerHTML = "";
		TweenMax.to( div, 0, {x:178, y:24, autoAlpha:1});
		pDialogue.appendChild( div );
		pDialogue.txt = div;
		
		/// DIALOGUES: Boss ///
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		TweenMax.to( div, 0, {x:600-472+600, y:300-22, autoAlpha:1});
		gui.appendChild( div );
		bDialogue = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_boss1.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:1});
		bDialogue.appendChild( div );
		bDialogue['b1'] = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_boss2.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		bDialogue.appendChild( div );
		bDialogue['b2'] = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_boss3.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		bDialogue.appendChild( div );
		bDialogue['b3'] = div;
		
		div = document.createElement("div");
		div.style.width = "472px";
		div.style.height = "102px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_boss4.png')";
		TweenMax.to( div, 0, {x:0, y:0, autoAlpha:0});
		bDialogue.appendChild( div );
		bDialogue['b4'] = div;
		
		// bubble
		div = document.createElement("div");
		div.style.width = "286px";
		div.style.height = "84px";
		div.style.position = "absolute";
		div.style.background = "url('img/gui/d_boss_bubble.png')";
		TweenMax.to( div, 0, {x:70, y:9, autoAlpha:1});
		bDialogue.appendChild( div );
		bDialogue.bubble = div;
		
		// txt
		div = document.createElement("div");
		div.style.width = "200px";
		div.style.height = "56px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '18px';
		div.style.fontWeight = '100';
		div.style.letterSpacing = "0.3px";
		div.style.border = '0px solid red';
		div.style.color = "#000";
		div.innerHTML = "";
		TweenMax.to( div, 0, {x:98, y:24, autoAlpha:1});
		bDialogue.appendChild( div );
		bDialogue.txt = div;
		
		
	}
	
	function buildShop()
	{
		var div;
		var img;
		var bar;
		var txt;
		var hit;
		var grp;
		
		var btnNames;
		var upgrades;
		
		// add pause menu
		shopMenu = document.createElement("div");
		shopMenu.className = "menuHolder";
		TweenMax.to( shopMenu, 0, {autoAlpha:0});
		gui.appendChild( shopMenu );
		
		// bg
		div = document.createElement("div");
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.position = "absolute";
		div.style.backgroundImage = "url('img/menus/shop/bg.png')";
		shopMenu.appendChild(div);
		
		// close
		img = document.createElement("img");
		img.style.position = "absolute";
		img.src = 'img/menus/shop/close.png';
		TweenMax.to( img, 0, {x:524, y:84});
		shopMenu.appendChild(img);
		img.style.cursor = 'pointer';
		$( img ).bind( "click", onShopCloseClick);
		
		// cash
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '162px';
		div.style.height = '32px';
		div.style.backgroundImage = 'url("img/menus/shop/cash_bg.png")';
		TweenMax.to( div, 0, {x:297, y:84});
		shopMenu.appendChild(div);
		//shopMenu.cash = div;
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '162px';
		txt.style.height = '32px';
		txt.style.textAlign = 'center';
		txt.style.color = '#000000';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '20px';
		txt.style.letterSpacing = '0.0px';
		txt.innerHTML = '$' + addCommas(curCash);
		TweenMax.to( txt, 0, {x:0, y:6});
		div.appendChild(txt);
		shopMenu.cash = txt;
		
		////////////////////////////////////////
		////////// upgrades ////////////////////
		////////////////////////////////////////
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '162px';
		TweenMax.to( div, 0, {x:188, y:142});
		shopMenu.appendChild(div);
		shopMenu.upgrades = div;
		upgrades = div;
		
		// set vars
		var i;
		var j;
		var list = ['drill','hull','fuel','storage','weapons','engine','airbag','lantern'];
		
		// nav
		btnNames = ['ENGINE','AIR BAGS','LANTERNS'];
		for(i=0; i<btnNames.length; i++)
		{
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '68px';
			div.style.height = '24px';
			div.style.background = '#74004b';
			div.style.border = '2px solid';
			div.style.borderColor = '#f800e8';
			TweenMax.to( div, 0, {x:(i*68)+81, y:-22});
			upgrades.appendChild(div);
			
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '68px';
			txt.style.height = '24px';
			txt.style.textAlign = 'center';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontWeight = '100';
			txt.style.fontSize = '14px';
			txt.style.letterSpacing = '0.8px';
			txt.innerHTML = btnNames[i];
			TweenMax.to( txt, 0, {x:-1, y:5});
			div.appendChild(txt);
			
			hit = document.createElement("div");
			hit.style.position = "absolute";
			hit.style.width = '68px';
			hit.style.height = '24px';
			hit.style.cursor = 'pointer';
			div.appendChild(hit);
			hit.div = div;
			
			hit.mode = list[i+5];
			hit.id = btnNames[i];
			$( hit ).bind( "mouseover", onShopBtnOver);
			$( hit ).bind( "mouseout", onShopBtnOut);
			$( hit ).bind( "click", onShopBtnClick);
		}

		var i;
		btnNames = ['DRILLS','HULLS','FUEL','STORAGE','WEAPONS'];
		for(i=0; i<btnNames.length; i++)
		{
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '68px';
			div.style.height = '24px';
			div.style.background = '#74004b';
			div.style.border = '2px solid';
			div.style.borderColor = '#f800e8';
			TweenMax.to( div, 0, {x:(i*68)+14, y:4});
			upgrades.appendChild(div);
			
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '68px';
			txt.style.height = '24px';
			txt.style.textAlign = 'center';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontWeight = '100';
			txt.style.fontSize = '14px';
			txt.style.letterSpacing = '0.8px';
			txt.innerHTML = btnNames[i];
			TweenMax.to( txt, 0, {x:-1, y:5});
			div.appendChild(txt);
			
			hit = document.createElement("div");
			hit.style.position = "absolute";
			hit.style.width = '68px';
			hit.style.height = '24px';
			hit.style.cursor = 'pointer';
			div.appendChild(hit);
			hit.div = div;
			
			hit.mode = list[i];
			hit.id = btnNames[i];
			$( hit ).bind( "mouseover", onShopBtnOver);
			$( hit ).bind( "mouseout", onShopBtnOut);
			$( hit ).bind( "click", onShopBtnClick);
			
			if(i==0)
			{
				shopMenu.upgrades.startTab = hit;
			}
		}
		
		// items bg
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '150px';
		div.style.background = '#74004b';
		div.style.border = '2px solid';
		div.style.borderColor = '#f800e8';
		TweenMax.to( div, 0, {x:0, y:30});
		upgrades.appendChild(div);
		
		// item title
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '368';
		txt.style.height = '32px';
		txt.style.textAlign = 'left';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '20px';
		txt.style.letterSpacing = '0.6px';
		txt.innerHTML = 'Diamond Drill';
		TweenMax.to( txt, 0, {x:16, y:38});
		upgrades.appendChild(txt);
		upgrades.itemName = txt;
		
		// item icons
		var iOrder = [5,4,3,2,1];
		for(i=1; i<=5; i++)
		{
			grp = document.createElement("div");
			grp.style.position = "absolute";
			grp.style.width = '128px';
			grp.style.height = '64px';
			TweenMax.to( grp, 0, {x:358-(i*70), y:52});
			upgrades.appendChild(grp);
			upgrades['icon'+iOrder[i-1]] = grp;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_off.png")';
			grp.appendChild( div );
			grp.off = div;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_select.png")';
			grp.appendChild( div );
			grp.select = div;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_on.png")';
			grp.appendChild( div );
			grp.on = div;
			
			if(i>1)
			{
				div = document.createElement("div");
				div.style.position = "absolute";
				div.style.width = '32px';
				div.style.height = '32px';
				TweenMax.to( div, 0, {x:48, y:16});
				grp.appendChild( div );
				grp.arrow = div;
				
				img = document.createElement("img");
				img.style.position = "absolute";
				img.src = 'img/menus/shop/arrow_off.png';
				div.appendChild(img);
				div.off = img;
				
				img = document.createElement("img");
				img.style.position = "absolute";
				img.src = 'img/menus/shop/arrow_select.png';
				div.appendChild(img);
				div.select = img;
				
				img = document.createElement("img");
				img.style.position = "absolute";
				img.src = 'img/menus/shop/arrow_on.png';
				div.appendChild(img);
				div.on = img;
				
			}
			
			// icons
			for(j=0; j<list.length; j++)
			{
				div = document.createElement("div");
				div.style.position = "absolute";
				div.style.width = '64px';
				div.style.height = '64px';
				var iconURL = 'img/icons/' + list[j] + '0' + (iOrder[i-1]) + '.png';
				div.style.backgroundImage = 'url(' + iconURL + ')';
				grp.appendChild( div );
				grp[ list[j] ] = div;
				TweenMax.to(div, 0, {autoAlpha:0});
			}
		}
		
		// info
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '240px';
		div.style.height = '70px';
		div.style.backgroundImage = 'url("img/menus/shop/info_bg.png")';
		TweenMax.to( div, 0, {x:14, y:110});
		upgrades.appendChild(div);
		upgrades.info = div;
		
		var inf = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam efficitur, orci at venenatis iaculis, tellus elit maximus nulla, ac facilisis lacus est id mauris.';
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '220px';
		txt.style.height = '60px';
		txt.style.textAlign = 'left';
		txt.style.color = '#000000';
		txt.style.fontFamily = 'Arial';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '12px';
		txt.style.lineHeight = '13px';
		txt.innerHTML = inf;
		TweenMax.to( txt, 0, {x:11, y:9});
		div.appendChild(txt);
		upgrades.info.txt = txt;
		
		// buy
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '96px';
		div.style.height = '70px';
		div.style.backgroundImage = 'url("img/menus/shop/buy_bg.png")';
		TweenMax.to( div, 0, {x:260, y:110});
		upgrades.appendChild(div);
		upgrades.buy = div;
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '96px';
		txt.style.height = '32px';
		txt.style.textAlign = 'center';
		txt.style.color = '#000000';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '20px';
		txt.style.letterSpacing = '0.0px';
		txt.innerHTML = '$100,000';
		TweenMax.to( txt, 0, {x:-1, y:10});
		div.appendChild(txt);
		upgrades.buyAmount = txt;
		
		// buy button
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '72px';
		div.style.height = '28px';
		div.style.background = '#f09429'
		TweenMax.to( div, 0, {x:12, y:34});
		upgrades.buy.appendChild(div);
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '72px';
		txt.style.height = '28px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '22px';
		txt.style.letterSpacing = '1.0px';
		txt.innerHTML = 'Buy!';
		TweenMax.to( txt, 0, {x:0, y:3});
		div.appendChild(txt);
		
		hit = document.createElement("div");
		hit.style.position = "absolute";
		hit.style.width = '72px';
		hit.style.height = '28px';
		hit.style.cursor = 'pointer';
		div.appendChild(hit);
		hit.div = div;
		upgrades.buyButton = hit;
		
		$( hit ).bind( "mouseover", onShopBuyOver);
		$( hit ).bind( "mouseout", onShopBuyOut);
		$( hit ).bind( "click", onShopBuyClick);
		
		// set first tab
		setShop( shopMenu.upgrades.startTab );
		shopMenu.upgrades.startTab.div.style.background = '#c2a7ff';
				
		// powerups
		buildPowerups();
		
		// mineral report
		buildMineralReport();
		
		// guard
		img = document.createElement("img");
		img.style.position = "absolute";
		img.src = 'img/menus/shop/guardb.png';
		TweenMax.to( img, 0, {x:-300, y:26});
		shopMenu.appendChild(img);
		
		img.endX = -30;
		img.startX = -300;
		shopMenu.guard = img;
		
		// starfire
		img = document.createElement("img");
		img.style.position = "absolute";
		img.src = 'img/menus/shop/starfire.png';
		TweenMax.to( img, 0, {x:-300, y:96});
		shopMenu.appendChild(img);
		
		img.endX = -16;
		img.startX = -300;
		shopMenu.starfire = img;
		
		// bubble
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '234px';
		div.style.height = '152px';
		div.style.background = 'url("img/menus/shop/bubble.png")';
		TweenMax.to( div, 0, {x:30, y:6, scaleX:0, scaleY:0, transformOrigin:'50% 100%'});
		shopMenu.appendChild(div);
		shopMenu.bubble = div;
		
		// txt
		div = document.createElement("div");
		div.style.width = "190px";
		div.style.height = "100px";
		div.style.position = "absolute";
		div.style.fontFamily = "Bangers";
		div.style.fontSize = '20px';
		div.style.fontWeight = '100';
		div.style.letterSpacing = "0.3px";
		div.style.border = '0px solid red';
		div.style.color = "#000";
		div.innerHTML = "BLAH BLAH LAH BLAH BLHAB ABLH.";
		TweenMax.to( div, 0, {x:16, y:14, autoAlpha:1});
		shopMenu.bubble.appendChild( div );
		shopMenu.bubble.txt = div;
		
		// audio
		shopMenu.audio = [];
		shopMenu.audio.button = game.add.audio('u_button' );
		shopMenu.audio.buy = game.add.audio('u_buy' );
		shopMenu.audio.close = game.add.audio('u_close' );
		shopMenu.audio.tab = game.add.audio('u_tab' );
		shopMenu.audio.upgrade = game.add.audio('u_upgrade' );
		shopMenu.audio.nomoney = game.add.audio('u_nomoney' );
		shopMenu.audio.popup = game.add.audio('u_popup' );
		
	}
	
	function buildInstructions()
	{
		var div;
		var img;
		var bar;
		var txt;
		var hit;
		var grp;
		
		var btnNames;
		var upgrades;
		
		// black 
		div = document.createElement("div");
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.position = "absolute";
		div.style.background = "#000";
		TweenMax.to( div, 0, {autoAlpha:0});
		gui.appendChild(div);
		gui.black = div;
		
		// add inst menu
		instMenu = document.createElement("div");
		instMenu.style.position = "absolute";
		instMenu.style.width = '592px';
		instMenu.style.height = '328px';
		TweenMax.to( instMenu, 0, {x:4, y:36, autoAlpha:0, scaleX:0, scaleY:0});
		gui.appendChild( instMenu );
		instMenu.page = 1;
			
		// bg
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '592px';
		div.style.height = '328px';
		div.style.background = 'url("img/instructions/bg.png")';
		instMenu.appendChild( div );

		// panels
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '493px';
		div.style.height = '180px';
		div.style.overflow = 'hidden';
		div.style.background = 'none';
		TweenMax.to(div, 0, {x:50, y:90, alpha:1});
		instMenu.appendChild( div );
		instMenu.panels = div;
		
		// insts
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '446px';
		div.style.height = '168px';
		div.style.background = 'url("img/instructions/panel02.png")';
		TweenMax.to(div, 0, {x:23, y:4, alpha:1});
		instMenu.panels.appendChild( div );
		instMenu.p1 = div;
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '446px';
		div.style.height = '168px';
		div.style.background = 'url("img/instructions/panel01.png")';
		TweenMax.to(div, 0, {x:23+600, y:4, alpha:1});
		instMenu.panels.appendChild( div );
		instMenu.p2 = div;
		
		// arrows
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '23px';
		div.style.height = '77px';
		div.style.background = 'url("img/instructions/arrow.png")';
		div.style.cursor = 'pointer';
		TweenMax.to(div, 0, {x:40, y:128, alpha:0});
		instMenu.appendChild( div );
		div.id = 'prev';
		$( div ).bind( "click", onInstArrowClick);
		instMenu.prev = div;
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '23px';
		div.style.height = '77px';
		div.style.background = 'url("img/instructions/arrow.png")';
		div.style.cursor = 'pointer';
		TweenMax.to(div, 0, {x:527, y:128, scaleX:-1, alpha:1});
		instMenu.appendChild( div );
		div.id = 'next';
		$( div ).bind( "click", onInstArrowClick);
		instMenu.next = div;
		
		// close
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '32px';
		div.style.height = '32px';
		div.style.background = 'url("img/instructions/close.png")';
		div.style.cursor = 'pointer';
		TweenMax.to(div, 0, {x:506, y:50, alpha:1});
		instMenu.appendChild( div );
		$( div ).bind( "click", onInstCloseClick);
	}
	
	function buildMineralReport()
	{
		var div;
		var img;
		var bar;
		var txt;
		var hit;
		var grp;
		
		var i;
		var j;
		
		var btnNames;
		var minerals;
		
		////////////////////////////////////////
		////////// minerals ////////////////////
		////////////////////////////////////////
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '162px';
		TweenMax.to( div, 0, {x:188, y:142});
		shopMenu.appendChild(div);
		shopMenu.minerals = div;
		minerals = div;
		
		// items bg
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '200px';
		div.style.background = '#74004b';
		div.style.border = '2px solid';
		div.style.borderColor = '#f800e8';
		TweenMax.to( div, 0, {x:0, y:-20});
		minerals.appendChild(div);
		
		// item title
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '368px';
		txt.style.height = '60px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '30px';
		txt.style.letterSpacing = '0.6px';
		txt.innerHTML = 'MINERAL REPORT';
		TweenMax.to( txt, 0, {x:0, y:-8-3});
		minerals.appendChild(txt);
		minerals.name = txt;
		
		// line
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '340px';
		div.style.height = '2px';
		div.style.background = "#f800e8";
		minerals.appendChild(div);
		TweenMax.to(div, 0, {x:16,y:24-4,alpha:1});
		
		// line
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '340px';
		div.style.height = '2px';
		div.style.background = "#f800e8";
		minerals.appendChild(div);
		TweenMax.to(div, 0, {x:16,y:24+122-4,alpha:1});
		
		// list div
		var list = document.createElement("div");
		list.style.position = "absolute";
		list.style.width = '340px';
		list.style.height = '120px';
		//list.style.border = '1px solid black';
		list.style.background = '#3e0028';
		list.style.overflow = 'hidden';
		minerals.appendChild(list);
		TweenMax.to(list, 0, {x:16,y:26-4});
		minerals.list = list;
		
		// next button 
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '80px';
		div.style.height = '22px';
		div.style.background = "#f800e8";
		minerals.appendChild(div);
		TweenMax.to(div, 0, {x:276,y:151});
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '80px';
		txt.style.height = '22px';
		txt.style.fontFamily = "Bangers";
		txt.style.color = '#fff';
		txt.style.textAlign = 'center';
		txt.style.letterSpacing = '2px';
		txt.innerHTML = 'NEXT';
		div.appendChild(txt);
		TweenMax.to(txt, 0, {x:1,y:3});
		
		hit = document.createElement("div");
		hit.style.position = "absolute";
		hit.style.width = '80px';
		hit.style.height = '22px';
		hit.style.cursor = 'pointer';
		hit.div = div;
		div.appendChild(hit);
		
		$( hit ).bind( "mouseover", onMineralNextOver);
		$( hit ).bind( "mouseout", onMineralNextOut);
		$( hit ).bind( "click", onMineralNextClick);
		
		// fake entries
		//player.collected = ['iron','diamond','iron','ruby','sapphire','lead','gold','titanium'];
		//setMinerals();
		
		// testing
		TweenMax.to( shopMenu.powerups, 0, {autoAlpha:0});
		TweenMax.to( shopMenu.upgrades, 0, {autoAlpha:0});
		//TweenMax.to( shopMenu, 0, {autoAlpha:1});
	}
	
	function buildPowerups()
	{
		var div;
		var img;
		var bar;
		var txt;
		var hit;
		var grp;
		
		var i;
		var j;
		
		var btnNames;
		var powerups;
		
		////////////////////////////////////////
		////////// powerups ////////////////////
		////////////////////////////////////////
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '162px';
		TweenMax.to( div, 0, {x:188, y:142});
		shopMenu.appendChild(div);
		shopMenu.powerups = div;
		powerups = div;
				
		// items bg
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '368px';
		div.style.height = '200px';
		div.style.background = '#74004b';
		div.style.border = '2px solid';
		div.style.borderColor = '#f800e8';
		TweenMax.to( div, 0, {x:0, y:-20});
		powerups.appendChild(div);
		
		// item title
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '368px';
		txt.style.height = '60px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '30px';
		txt.style.letterSpacing = '0.6px';
		txt.innerHTML = 'Powerup Shop';
		TweenMax.to( txt, 0, {x:0, y:-2});
		powerups.appendChild(txt);
		powerups.name = txt;
		
		// item icons
		var iOrder = [1,2,3,4,5,6];
		for(i=1; i<=5; i++)
		{
			grp = document.createElement("div");
			grp.style.position = "absolute";
			grp.style.width = '128px';
			grp.style.height = '64px';
			TweenMax.to( grp, 0, {x:-48+(i*58)+26, y:30});
			powerups.appendChild(grp);
			powerups['icon'+i] = grp;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_off.png")';
			grp.appendChild( div );
			grp.off = div;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_select.png")';
			grp.appendChild( div );
			grp.select = div;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_on.png")';
			grp.appendChild( div );
			grp.on = div;
			
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/menus/shop/box_ready.png")';
			grp.appendChild( div );
			grp.ready = div;
							
			// icon
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '64px';
			div.style.height = '64px';
			div.style.backgroundImage = 'url("img/icons/item0' + iOrder[i-1] + '.png")';
			grp.appendChild( div );
			
			// icon title
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '128px';
			txt.style.height = '64px';
			txt.style.textAlign = 'center';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontWeight = '100';
			txt.style.fontSize = '12px';
			txt.style.letterSpacing = '0.6px';
			txt.innerHTML = 'READY';
			TweenMax.to( txt, 0, {x:-33, y:58});
			grp.appendChild(txt);
			grp.name = txt;
			
			// hit
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '40px';
			div.style.height = '40px';
			div.style.background = "#ff0";
			div.style.cursor = 'pointer';
			TweenMax.to(div, 0, {x:12,y:12,alpha:0});
			grp.appendChild( div );
			grp.hit = div;
			div.grp = grp;
			
			TweenMax.to(grp.on, 0, {autoAlpha:0});
			TweenMax.to(grp.off, 0, {autoAlpha:0});
			TweenMax.to(grp.select, 0, {autoAlpha:0});
			TweenMax.to(grp.ready, 0, {autoAlpha:1});
			
			grp.status = 'READY';
			grp.hit.info = Data.getPowerupData(i);
			
			$( grp.hit ).bind( "mouseover", onPowerupOver);
			$( grp.hit ).bind( "mouseout", onPowerupOut);
			$( grp.hit ).bind( "click", onPowerupClick);
		}
		
		// info
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '240px';
		div.style.height = '70px';
		div.style.backgroundImage = 'url("img/menus/shop/info_bg.png")';
		TweenMax.to( div, 0, {x:14, y:110});
		powerups.appendChild(div);
		powerups.info = div;
		
		var inf = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam efficitur, orci at venenatis iaculis, tellus elit maximus nulla, ac facilisis lacus est id mauris.';
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '220px';
		txt.style.height = '60px';
		txt.style.textAlign = 'left';
		txt.style.color = '#000000';
		txt.style.fontFamily = 'Arial';
		txt.style.fontWeight = '100';
		txt.style.fontSize = '12px';
		txt.style.lineHeight = '13px';
		txt.innerHTML = inf;
		TweenMax.to( txt, 0, {x:11, y:9});
		div.appendChild(txt);
		powerups.info.txt = txt;
		
		// buy
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '96px';
		div.style.height = '70px';
		div.style.backgroundImage = 'url("img/menus/shop/buy_bg.png")';
		TweenMax.to( div, 0, {x:260, y:110});
		powerups.appendChild(div);
		powerups.buy = div;
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '96px';
		txt.style.height = '32px';
		txt.style.textAlign = 'center';
		txt.style.color = '#000000';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '20px';
		txt.style.letterSpacing = '0.0px';
		txt.innerHTML = '$100,000';
		TweenMax.to( txt, 0, {x:-1, y:10});
		div.appendChild(txt);
		shopMenu.powerups.buyAmount = txt;
		
		// buy button
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '72px';
		div.style.height = '28px';
		div.style.background = '#f09429'
		TweenMax.to( div, 0, {x:12, y:34});
		powerups.buy.appendChild(div);
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '72px';
		txt.style.height = '28px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '22px';
		txt.style.letterSpacing = '1.0px';
		txt.innerHTML = 'Buy!';
		TweenMax.to( txt, 0, {x:0, y:3});
		div.appendChild(txt);
		
		hit = document.createElement("div");
		hit.style.position = "absolute";
		hit.style.width = '72px';
		hit.style.height = '28px';
		hit.style.cursor = 'pointer';
		div.appendChild(hit);
		hit.div = div;
		
		$( hit ).bind( "mouseover", onShopBuyOver);
		$( hit ).bind( "mouseout", onShopBuyOut);
		$( hit ).bind( "click", onPowerupBuyClick);
		
		shopMenu.powerups.buyButton = hit;
		
		// testing:
		TweenMax.to( shopMenu.powerups.buy, 0, {autoAlpha:0});
		//TweenMax.to( shopMenu.upgrades, 0, {autoAlpha:0});
		//TweenMax.to( shopMenu, 0, {autoAlpha:1});
		
	}
	
	//--------------------------- PAUSE MENU METHODS:
	
	function buildPauseMenu()
	{
		console.log('pause menu!');
		
		var div;
		var img;
		var bar;
		var txt;
		var hit;
		var grp;
		
		var i;
		var j;
		
		var btnNames;
		var powerups;
		
		////////////////////////////////////////
		////////// pause menu ////////////////////
		////////////////////////////////////////
		
		// add pause menu
		pauseMenu = document.createElement("div");
		pauseMenu.id = "pause";
		TweenMax.to( pauseMenu, 0, {autoAlpha:0});
		gui.appendChild( pauseMenu );
		
		div = document.createElement("div");
		div.style.width = "600px";
		div.style.height = "400px";
		div.style.position = "absolute";
		div.style.background = "#000";
		TweenMax.to( div, 0, {alpha:.7});
		pauseMenu.appendChild(div);
		
		// window
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '566px';
		div.style.height = '374px';
		div.style.background = "url('img/pause/bg.png')";
		TweenMax.to( div, 0, {x:17, y:13});
		pauseMenu.appendChild(div);
		pauseMenu.window = div;
		
		// title
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '566px';
		txt.style.height = '40px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '48px';
		txt.style.letterSpacing = '1.0px';
		txt.innerHTML = 'PAUSED';
		TweenMax.to( txt, 0, {x:0, y:50});
		pauseMenu.window.appendChild(txt);
		
		// buttons
		var ids = ['SFX','MUSIC'];
		var select;
		for(i=0; i<ids.length; i++)
		{
			div = document.createElement("div");
			div.style.position = "absolute";
			div.style.width = '400px';
			div.style.height = '50px';
			div.style.border = '0px solid red'
			TweenMax.to( div, 0, {x:110, y:(i*52)+130 });
			pauseMenu.window.appendChild(div);
			
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '100px';
			txt.style.height = '50px';
			txt.style.textAlign = 'left';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontSize = '30px';
			txt.style.letterSpacing = '1.0px';
			txt.innerHTML = ids[i]+':';
			TweenMax.to( txt, 0, {x:10, y:10});
			div.appendChild(txt);
			
			img = document.createElement("div");
			img.style.position = "absolute";
			img.style.width = '172px';
			img.style.height = '34px';
			img.style.background = "url('img/pause/bar.png')";
			TweenMax.to( img, 0, {x:160, y:8 });
			div.appendChild(img);
			
			img = document.createElement("div");
			img.style.position = "absolute";
			img.style.width = '92px';
			img.style.height = '40px';
			img.style.background = "url('img/pause/select.png')";
			TweenMax.to( img, 0, {x:160, y:4, alpha:1 });
			div.appendChild(img);
			select = img;
			
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '100px';
			txt.style.height = '50px';
			txt.style.textAlign = 'left';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontSize = '30px';
			txt.style.letterSpacing = '1.0px';
			txt.innerHTML = 'ON';
			TweenMax.to( txt, 0, {x:190, y:10});
			div.appendChild(txt);
			
			txt = document.createElement("div");
			txt.style.position = "absolute";
			txt.style.width = '100px';
			txt.style.height = '50px';
			txt.style.textAlign = 'left';
			txt.style.color = '#ffffff';
			txt.style.fontFamily = 'Bangers';
			txt.style.fontSize = '30px';
			txt.style.letterSpacing = '1.0px';
			txt.innerHTML = 'OFF';
			TweenMax.to( txt, 0, {x:264, y:10});
			div.appendChild(txt);
			
			img = document.createElement("div");
			img.style.position = "absolute";
			img.style.width = '172px';
			img.style.height = '34px';
			img.style.background = "url('img/pause/bar.png')";
			img.style.cursor = 'pointer';
			TweenMax.to( img, 0, {x:160, y:8, alpha:.01 });
			div.appendChild(img);
			hit = img;
			
			hit.id = ids[i];
			hit.mode = 'on';
			hit.select = select;
			$( hit ).bind( "click", onPauseBtnClick);
			
			// check for off
			if( (i==0) && (sfxVolume==0) )
			{
				TweenMax.to( hit.select, .1, {x:240, ease:Quad.easeOut});
				hit.mode = 'off';
			}
			if( (i==1) && (musicVolume==0) )
			{
				TweenMax.to( hit.select, .1, {x:240, ease:Quad.easeOut});
				hit.mode = 'off';
			}
			
		}
		
		// close button
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '192px';
		div.style.height = '44px';
		div.style.background = "url('img/pause/button.png')";
		TweenMax.to( div, 0, {x:190, y:266});
		pauseMenu.window.appendChild(div);
		
		txt = document.createElement("div");
		txt.style.position = "absolute";
		txt.style.width = '566px';
		txt.style.height = '40px';
		txt.style.textAlign = 'center';
		txt.style.color = '#ffffff';
		txt.style.fontFamily = 'Bangers';
		txt.style.fontSize = '30px';
		txt.style.letterSpacing = '1.0px';
		txt.innerHTML = 'RESUME GAME';
		TweenMax.to( txt, 0, {x:0, y:273});
		pauseMenu.window.appendChild(txt);
		
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '192px';
		div.style.height = '44px';
		div.style.background = "url('img/pause/button.png')";
		div.style.cursor = 'pointer';
		TweenMax.to( div, 0, {x:190, y:266, alpha:0});
		pauseMenu.window.appendChild(div);
		$( div ).bind( "click", onPauseCloseClick);
	
		TweenMax.to( pauseMenu, 0, {autoAlpha:0});
		
	}
	
	function onPauseBtnClick(e)
	{
		// move select
		if( e.currentTarget.mode == 'on' )
		{
			TweenMax.to( e.currentTarget.select, .1, {x:240, ease:Quad.easeOut});
			e.currentTarget.mode = 'off';
			
			if( e.currentTarget.id == 'MUSIC' )
			{
				musicVolume = 0;
				musicTrack.volume = 0;
			}
			if( e.currentTarget.id == 'SFX' )
			{
				sfxVolume = 0;
			}
		}
		else
		{
			TweenMax.to( e.currentTarget.select, .1, {x:160, ease:Quad.easeOut});
			e.currentTarget.mode = 'on';
			
			if( e.currentTarget.id == 'MUSIC' )
			{
				musicVolume = 1;
				musicTrack.volume = 1;
			}
			if( e.currentTarget.id == 'SFX' )
			{
				sfxVolume = 1;
			}
		}
		
		// audio
		shopMenu.audio.button.play('',0,sfxVolume);
		
		// save volume settings
		localStorage.setItem( 'musicVolume', musicVolume );
		localStorage.setItem( 'sfxVolume', sfxVolume );
	}
	
	function onPauseCloseClick(e)
	{
		onPauseClick(null);
	}
	
	//--------------------------- GUI METHODS:

	function showGemBonus(box)
	{
		var str = " +1 " + box.gem.id.toUpperCase() + " ";
		player.collected.push( box.gem.id );
		
		// update gem collected
		settings.gemsCollected++;
		localStorage.setItem( 'gemsCollected' , settings.gemsCollected );
		checkTowerUpgrade();
		
		// grp
		var grp = game.add.group();
		
		// text 
		var txt = game.add.text(0, 0, str, { font: "20px Bangers", fill:'#ffffff'} );
		txt.anchor.set(0.5);
	    txt.stroke = '#000000';
	    txt.strokeThickness = 2;
		txt.setShadow(2, 2, 'rgba(0,0,0,0.8)', 5);
		grp.add( txt );
		
		// position
		grp.x = box.x + 32 - 4;
		grp.y = box.y;
		
		// add to layer
		bonusLayer.add( grp );
		
		// animate
		TweenMax.to( grp, .5, {delay:0.0, y:box.y-50, ease:Quad.easeOut});
		TweenMax.to( grp, .3, {delay:0.5, alpha:0, ease:Quad.easeOut, onComplete:removeGrp, onCompleteParams:[grp]});
	
		// audio
		background.audio['pickup'+player.curZone].play('',0,sfxVolume);
	}
	
	function showFuelWarning()
	{
		if(fuelWarning){return;}
		
		var str = " OUT OF FUEL ";
		
		// grp
		var grp = game.add.group();
		
		// text 
		var txt = game.add.text(0, 0, str, { font: "20px Bangers", fill:'#ff0000'} );
		txt.anchor.set(0.5);
	    txt.stroke = '#000000';
	    txt.strokeThickness = 2;
		txt.setShadow(2, 2, 'rgba(0,0,0,0.8)', 5);
		grp.add( txt );
		fuelWarning = grp;
		
		// position
		grp.x = player.x + (player.width*.5);
		grp.y = player.y;
		
		// add to layer
		bonusLayer.add( grp );
		
		// animate
		TweenMax.to( grp, .5, {delay:0.0, y:player.y-50, ease:Quad.easeOut});
		TweenMax.to( grp, .3, {delay:0.5, alpha:0, ease:Quad.easeOut, onComplete:removeFuelWarning, onCompleteParams:[grp]});
	
		// audio
		player.audio.empty.play('',0,sfxVolume);
	}
	
	function showStorageWarning(box)
	{
		var str = " FULL ";
		
		// grp
		var grp = game.add.group();
		
		// text 
		var txt = game.add.text(0, 0, str, { font: "20px Bangers", fill:'#ffff00'} );
		txt.anchor.set(0.5);
	    txt.stroke = '#000000';
	    txt.strokeThickness = 2;
		txt.setShadow(2, 2, 'rgba(0,0,0,0.8)', 5);
		grp.add( txt );
		storageWarning = grp;
		
		// position
		grp.x = box.x + 32 - 4;
		grp.y = box.y;
		
		// add to layer
		bonusLayer.add( grp );
		
		// animate
		TweenMax.to( grp, .5, {delay:0.0, y:box.y-50, ease:Quad.easeOut});
		TweenMax.to( grp, .3, {delay:0.5, alpha:0, ease:Quad.easeOut, onComplete:removeGrp, onCompleteParams:[grp]});
	
		// audio
		player.audio.full.play('',0,sfxVolume);
	}
	
	function onPauseClick(e)
	{
		if(game.paused)
		{
			TweenMax.resumeAll();
			TweenMax.to( pauseMenu, .2, {autoAlpha:0, ease:Quad.easeOut});
			game.paused = false;
		}
		else
		{
			TweenMax.pauseAll();
			TweenMax.to( pauseMenu, .2, {autoAlpha:1, ease:Quad.easeOut});
			game.paused = true;
		}
		
		// audio
		shopMenu.audio.button.play('',0,sfxVolume);
	}
	
	function onKeyPress(e)
	{
		//console.log(e);
		//console.log(e.which);
		
		// any key on dialogue
		if( pDialogue.ready && bDialogue.ready )
		{
			pDialogue.ready = false
			bDialogue.ready = false
			
			curDia.num++;
			playDialogue();
		}
		
		// "P": pause
		if( e.which == 80 )
		{
			//onPauseClick(null);
		}
		
		/*
		// "X": clear
		if( e.which == 88 )
		{
			// clear stats
			stats = [];
			var i;
			var stat;
			var list = ['drill','hull','fuel','storage','weapons','engine','airbag','lantern'];
			for(i=0; i<list.length; i++)
			{
				stats[ list[i] ] = startLevel;
				localStorage.setItem( ('stat-'+list[i]) , stats[ list[i] ] );
			}
			
			
			localStorage.setItem( 'gemsCollected', 0 );
			localStorage.setItem( 'towerLevel', 0 );
			localStorage.setItem( 'curCash', 0 );
			
			// reset last date
			localStorage.setItem('last-date', 'clear');
			resetEngine();
		}
		*/
		/*
		// "R": reset
		if( e.which == 82 )
		{
			//onPauseClick(null);
			resetEngine();
		}
		
		// "X": clear
		if( e.which == 88 )
		{
			// clear stats
			stats = [];
			var i;
			var stat;
			var list = ['drill','hull','fuel','storage','weapons','engine','airbag','lantern'];
			for(i=0; i<list.length; i++)
			{
				stats[ list[i] ] = startLevel;
				localStorage.setItem( ('stat-'+list[i]) , stats[ list[i] ] );
			}
			
			
			localStorage.setItem( 'gemsCollected', 0 );
			localStorage.setItem( 'towerLevel', 0 );
			localStorage.setItem( 'curCash', 0 );
			
			// reset last date
			localStorage.setItem('last-date', 'clear');
			resetEngine();
		}
		
		// "Y": warp to tank
		if( e.which == 89 )
		{
			curWarp = 'surface';
			if(player.isWarping){return;}
			warpPlayer(176,16);
		}
		
		// "U": warp to gridnok
		if( e.which == 85 )
		{
			curWarp = 'surface';
			if(player.isWarping){return;}
			warpPlayer(376,16);
		}
		
		// "I": warp to blackfire
		if( e.which == 73 )
		{
			curWarp = 'surface';
			if(player.isWarping){return;}
			warpPlayer(576,16);
		}
		/*
		// "U": warp
		if( e.which == 85 )
		{
			if(player.isWarping){return;}
			warpPlayer(-1,6);
		}
		
		// "M": mute
		if( e.which == 77 )
		{
			if(game.sound.mute)
			{
				game.sound.mute = false;
			}
			else
			{
				game.sound.mute = true;
			}
		}
		
		// gridnok testing: num keys
		/*
		if( testEnemy )
		{
			if(testEnemy.type=='gridnok')
			{
				if(e.which==49)
				{
					onGridnokCharge();
				}
				if(e.which==50)
				{
					onGridnokThrow();
				}
				if(e.which==51)
				{
					onGridnokEat();
				}
				if(e.which==52)
				{
					onGridnokDeath();
				}
			}
		}
		*/
		/*
		// blackfire testing: num keys
		if( blackfire )
		{
			if(e.which==49)
			{
				resumeBlackfireWalk();
			}
			if(e.which==50)
			{
				chargeBlackfire();
			}
			if(e.which==51)
			{
				clapBlackfire();
			}
			if(e.which==52)
			{
				beamBlackfire();
			}
			if(e.which==53)
			{
				stompBlackfire();
			}
			if(e.which==54)
			{
				throwBlackfire();
			}
			if(e.which==55)
			{
				deathBlackfire();
			}
		}
		*/
	}
	
	function setGuiMeters()
	{
		var level;
		var m;
		var w;
		var h;
		var newx;
		var i;
		var j;
		var img;
		
		// health
		l = stats['hull'];
		m = gui.hearts;
		var hMax = 3+l;
		for(i=0;i<8;i++)
		{
			// set hearts by level
			h = m['h'+i];
			if( i>hMax )
			{
				TweenMax.to(h,0,{alpha:0});
			}
			else
			{
				TweenMax.to(h,0,{alpha:1});
			}
			
			// reset hearts imgs
			for(j=1;j<=5;j++)
			{
				img = h['heart'+j];
				if(j<5){ TweenMax.to(img,0,{alpha:0}); }else{ TweenMax.to(img,0,{alpha:1}); }
			}
		}
		
		// energy
		l = stats['fuel'];
		w = (l*16) + 60;
		m = gui.meters.energy;
		TweenMax.to( m, .2, {width:w});
		TweenMax.to( m.black, .2, {width:w-4});
		TweenMax.to( m.bar, .2, {width:w-4});
		TweenMax.to( gui.meters.storage, .2, {x:m.startX+w+24});
		
		// storage
		l = stats['storage'];
		w = (l*16) + 60;
		m = gui.meters.storage;
		TweenMax.to( m, .2, {width:w});
		TweenMax.to( m.black, .2, {width:w-4});
		TweenMax.to( m.bar, .2, {width:w-4, scaleX:0, transformOrigin:'0% 0%'});
		
		// reset stats
		player.health = PLAYER_HEALTH;
		player.fuel = PLAYER_FUEL;
		player.storage = 0;
	}
	
	function setGuiFuel()
	{
		var per = player.fuel/PLAYER_FUEL;
		TweenMax.to( gui.meters.energy.bar, 0, {scaleX:per});
	}
	
	function setGuiStorage()
	{
		console.log('set storage');
		var per = (player.storage/PLAYER_STORAGE);
		TweenMax.to( gui.meters.storage.bar, 0, {scaleX:per});
	}
	
	function onInstArrowClick(e)
	{
		if( e.target.id == 'next' )
		{
			if( instMenu.page == 1 )
			{
				TweenMax.to( instMenu.p1, 		.2, {x:23-600, ease:Quad.easeOut});
				TweenMax.to( instMenu.p2, 		.2, {x:23-000, ease:Quad.easeOut});
				TweenMax.to( instMenu.prev, 	.2, {alpha:1, ease:Quad.easeOut});
				instMenu.page=2;
			}
			else if( instMenu.page == 2 )
			{
				hideInstructions();
			}
		}
		
		if( e.target.id == 'prev' )
		{
			if( instMenu.page == 2 )
			{
				TweenMax.to( instMenu.p1, 		.2, {x:23-000, ease:Quad.easeOut});
				TweenMax.to( instMenu.p2, 		.2, {x:23+600, ease:Quad.easeOut});
				TweenMax.to( instMenu.prev, 	.2, {alpha:0, ease:Quad.easeOut});
				instMenu.page=1;
			}
		}
	}
	
	function onInstCloseClick(e)
	{
		hideInstructions();
	}
	
	function showInstructions()
	{
		console.log('show instructions');
		
		TweenMax.to( gui.black, 	.3, {delay:.0, autoAlpha:.7, ease:Quad.easeOut});
		TweenMax.to( instMenu,	 	.3, {delay:.1, scaleX:1, scaleY:1, autoAlpha:1, ease:Quad.easeOut});
	}
	
	function hideInstructions()
	{
		TweenMax.to( gui.black, .3, {delay:.0, autoAlpha:0, ease:Quad.easeOut});
		TweenMax.to( instMenu, 	.3, {delay:.0, scaleX:0, scaleY:0, autoAlpha:0, ease:Back.easeOut, onComplete:resumePlayer});
	}
	
	//--------------------------- SHOP METHODS:
	
	function onShopCloseClick(e)
	{
		TweenMax.to( shopMenu, .2, {autoAlpha:0, ease:Quad.easeOut} );
		TweenMax.delayedCall( 0.2, exitPlayer );
		shopMenu.audio.close.play('',0,sfxVolume);
	}
	
	function showShopMenu()
	{
		TweenMax.to( shopMenu.powerups, 0, {autoAlpha:0});
		TweenMax.to( shopMenu.upgrades, 0, {autoAlpha:0});
		TweenMax.to( shopMenu.minerals, 0, {autoAlpha:0});
		TweenMax.to( shopMenu.guard, 0, {x:shopMenu.guard.startX});
		TweenMax.to( shopMenu.starfire, 0, {x:shopMenu.starfire.startX});
		TweenMax.to( shopMenu.bubble, 0, {scaleX:0, scaleY:0, transformOrigin:'50% 100%'});
		shopMenu.bubble.txt.innerHTML = '';
		
		if( curShop=='shop' )
		{
			setMinerals()
			setShop( shopMenu.upgrades.startTab );
			TweenMax.to( shopMenu.minerals, 0, {autoAlpha:1});
			
			TweenMax.to( shopMenu, 			.2, {delay:0.0, autoAlpha:1, ease:Quad.easeOut} );
			TweenMax.to( shopMenu.guard, 	.2, {delay:0.2, x:shopMenu.guard.endX, ease:Quad.easeOut});
			
			setShopText('shop');
		}
		else
		{
			shopMenu.powerups.info.txt.innerHTML = 'Select a power to view details.';
			
			TweenMax.to( shopMenu.powerups, 0, {autoAlpha:1});
			TweenMax.to( shopMenu, 			.2, {delay:0.0, autoAlpha:1, ease:Quad.easeOut} );
			TweenMax.to( shopMenu.starfire, 	.2, {delay:0.2, x:shopMenu.starfire.endX, ease:Quad.easeOut});
			
			setShopText('powerups');
		}
		
	}
	
	function setShopText(mode)
	{
		var line;
		
		if( mode == 'shop' )
		{
			line = "Let's see what you've dug up for me this time.";
		} 
		
		if( mode == 'shop_upgrades' )
		{
			line = "How would you like us to improve your vehicle?";
		}
		
		if( mode == 'shop_purchase1' )
		{
			line = "A fine choice!";
		}
		
		if( mode == 'shop_purchase2' )
		{
			line = "We'll get that changed out right away!";
		}
		
		if( mode == 'shop_purchase3' )
		{
			line = "Looking good sir!";
		}
		
		if( mode == 'powerups_purchase1' )
		{
			line = 'Good luck digging!';
		}
		
		if( mode == 'powerups_purchase2' )
		{
			line = 'That should help, good luck!';
		}
		
		if( mode == 'powerups_purchase3' )
		{
			line = 'That looks great!';
		}
		
		if( mode == 'powerups_toomany' )
		{
			line = 'Sorry, you can only have 2 Power Ups at a time!';
		}
		
		if( mode == 'powerups' )
		{
			line = "Welcome to the Power Up Store!";
		} 
		
		if( mode == 'no_cash' )
		{
			line = "Sorry, you don't have enough cash for that!";
		}
		
		TweenMax.to( shopMenu.bubble, .2, {scaleX:1, scaleY:1, ease:Back.easeOut} );
		
		var i;
		var txt;
		var delayer = 0.2;
		
		for(i=0; i<line.length+1; i++)
		{
			txt = line.substring(0, i);
			TweenMax.delayedCall( delayer, setDialogueText, [shopMenu.bubble.txt, txt]);
			delayer+=.01;
		}
	}

	function onShopBtnOver(e)
	{
		if(e.target==curShopNav){return;}
		e.target.div.style.background = '#c2a7ff';
	}
	
	function onShopBtnOut(e)
	{
		if(e.target==curShopNav){return;}
		e.target.div.style.background = '#74004b';
	}
	
	function onShopBtnClick(e)
	{
		if(e.target==curShopNav){return;}
		//if(e.target.id=='WEAPONS'){return;}
		setShop(e.target);
		shopMenu.audio.tab.play('',0,sfxVolume);
	}
	
	function setShop(target)
	{
		var i;
		var item;
		var targ;
		var level = stats[target.mode]+1;
		var data;
		
		if(curShopNav)
		{
			if(curShopNav!=target)
			{
				curShopNav.div.style.background = '#74004b';
			}
		}
		
		for(i=1; i<=5; i++)
		{
			item = shopMenu.upgrades['icon'+i];
			targ = item[ target.mode ];
			TweenMax.to(targ, 0, {autoAlpha:1});
				
			// set icon colors
			TweenMax.to(item.off, 0, {autoAlpha:0});
			TweenMax.to(item.select, 0, {autoAlpha:0});
			TweenMax.to(item.on, 0, {autoAlpha:0});
			
			if(i<5)
			{
				TweenMax.to(item.arrow.off, 0, {autoAlpha:0});
				TweenMax.to(item.arrow.select, 0, {autoAlpha:0});
				TweenMax.to(item.arrow.on, 0, {autoAlpha:0});
			}
			
			// set on
			if( i<(level+1) )
			{
				TweenMax.to(item.on, 0, {autoAlpha:1});
				if(i<5)
				{
					TweenMax.to(item.arrow.on, 0, {autoAlpha:1});
				}
			}
			
			// set select
			if( i==(level+1) )
			{
				TweenMax.to(item.select, 0, {autoAlpha:1});
				if(i<5)
				{
					TweenMax.to(item.arrow.select, 0, {autoAlpha:1});
				}
			}
			
			// set off
			if( i>(level+1) )
			{
				TweenMax.to(item.off, 0, {autoAlpha:1});
				if(i<5)
				{
					TweenMax.to(item.arrow.off, 0, {autoAlpha:1});
				}
				
				TweenMax.to(targ, 0, {autoAlpha:.5});
			}	
			
			// shut off
			if( (curShopNav) )
			{
				if(curShopNav!=target)
				{
					targ = item[ curShopNav.mode ];
					TweenMax.to(targ, 0, {autoAlpha:0});
				}
			}		
		}
		
		// toggle buy button visible
		if(level==5)
		{
			data = Data.getShopData(target.mode, 4);
			TweenMax.to(shopMenu.upgrades.buy, 0, {autoAlpha:0});
		}
		else
		{
			data = Data.getShopData(target.mode, level);
			TweenMax.to(shopMenu.upgrades.buy, 0, {autoAlpha:1});
		}
		
		// set shop text
		shopMenu.upgrades.info.txt.innerHTML = data.info;
		shopMenu.upgrades.itemName.innerHTML = data.id;
		shopMenu.upgrades.buyAmount.innerHTML = "$" + addCommas(data.value);
		shopMenu.upgrades.buyButton.value = data.value;
		
		// save cur nav
		curShopNav = target;
	}
	
	function onShopBuyOver(e)
	{
		e.target.div.style.background = '#c2a7ff';
	}
	
	function onShopBuyOut(e)
	{
		e.target.div.style.background = '#f09429';
	}
	
	function onShopBuyClick(e)
	{
		// check for cash
		if( e.target.value > curCash )
		{
			console.log('not enough cash');
			setShopText('no_cash');
			shopMenu.audio.nomoney.play('',0,sfxVolume);
			return;
		}
		
		// update cash
		updateCash(e.target.value*-1);
		
		// update shop
		var mode = curShopNav.mode;
		stats[mode]++;
		setShop(curShopNav);
		
		// output
		console.log( 'level up: ' + mode + ' > ' + stats[mode] + ', ' + e.target.value );
		
		// save stat
		localStorage.setItem( ('stat-'+mode) , stats[ mode ] );
		
		setStats(mode);
		shopMenu.audio.buy.play('',0,sfxVolume);
		
		// set text
		var rnum = Math.floor( Math.random()*3 )+1;
		setShopText( 'shop_purchase' + rnum );
	}
	
	function onPowerupOver(e)
	{
		if(e.currentTarget.grp==curPowerupShopNav){return;}
		if(e.currentTarget.grp.status=='ARMED'){return;}
		TweenMax.to(e.currentTarget.grp.ready, 0, {autoAlpha:0});
		TweenMax.to(e.currentTarget.grp.select, 0, {autoAlpha:1});
	}
	
	function onPowerupOut(e)
	{
		if(e.currentTarget.grp==curPowerupShopNav){return;}
		if(e.currentTarget.grp.status=='ARMED'){return;}
		TweenMax.to(e.currentTarget.grp.ready, 0, {autoAlpha:1});
		TweenMax.to(e.currentTarget.grp.select, 0, {autoAlpha:0});
	}
	
	function onPowerupClick(e)
	{
		if(e.currentTarget.grp==curPowerupShopNav){return;}
		if(e.currentTarget.grp.status=='ARMED'){return;}
		setPowerupShop(e.currentTarget.grp);
		shopMenu.audio.tab.play('',0,sfxVolume);
	}
	
	function setPowerupShop(target)
	{
		var i;
		var item;
		var targ;
		
		var data = target.hit.info;

		if(curPowerupShopNav)
		{
			if(curPowerupShopNav!=target)
			{
				TweenMax.to(curPowerupShopNav.ready, 0, {autoAlpha:1});
				TweenMax.to(curPowerupShopNav.select, 0, {autoAlpha:0});
			}
		}
			
		// set info
		shopMenu.powerups.info.txt.innerHTML = target.hit.info.info;
		shopMenu.powerups.name.innerHTML = target.hit.info.name;
		TweenMax.to( shopMenu.powerups.buy, 0, {autoAlpha:1});

		shopMenu.powerups.buyAmount.innerHTML = "$" + addCommas(data.value);
		shopMenu.powerups.buyButton.value = data.value;
		
		// save item		
		curPowerupShopNav = target;
	}
	
	function onPowerupBuyClick(e)
	{
		if(!curPowerupShopNav){return;}
			
		// check for cash
		console.log(e.target.value);
		if( e.target.value > curCash )
		{
			console.log('not enough cash');
			setShopText('no_cash');
			return;
		}
			
		// add powerup to nav
		var powerup = null;
		var info = curPowerupShopNav.hit.info;
		if( !gui.powerup1.isActive )
		{
			powerup = gui.powerup1;
		}
		else if( !gui.powerup2.isActive )
		{
			powerup = gui.powerup2;
		}
		else
		{
			console.log('full powerups');
			setShopText('powerups_toomany');
			return;
		}
		
		// remove old image
		if(powerup.icon)
		{
			powerup.removeChild( powerup.icon );
			powerup.icon = null;
		}
		
		// add image
		var div;
		div = document.createElement("div");
		div.style.position = "absolute";
		div.style.width = '64px';
		div.style.height = '64px';
		div.style.backgroundImage = 'url("img/icons/' + info.icon + '.png")';
		TweenMax.to( div, 0, {x:2, y:2});
		powerup.appendChild(div);
		powerup.icon = div;
		
		// reset powerup
		TweenMax.to( powerup.bar, 0, {scaleX:1, transformOrigin:"0%, 50%"});
		TweenMax.to( powerup.bar, POWERUP_DELAY, {scaleX:0, transformOrigin:"0% 50%", 
												  onComplete:onPowerupComplete, onCompleteParams:[powerup]});
		
		// set powerup
		powerup.nav = curPowerupShopNav;
		powerup.info = info;
		powerup.isActive = true;
		positionPowerups();
		
		// check for drone
		if( powerup.info.name=='Hover Drone')
		{
			console.log('show drone');
			player.drone.alpha = 1;
		}
		
		// toggle nav
		TweenMax.to(curPowerupShopNav.select, 0, {autoAlpha:0});
		TweenMax.to(curPowerupShopNav.on, 0, {autoAlpha:1});
		curPowerupShopNav.name.innerHTML = 'ARMED';
		curPowerupShopNav.status = 'ARMED';
		
		// remove selected
		curPowerupShopNav = null;
		
		// update cash
		updateCash(e.target.value*-1);
		
		// set text
		var rnum = Math.floor( Math.random()*3 )+1;
		setShopText( 'powerups_purchase' + rnum );
		
		// audio
		shopMenu.audio.buy.play('',0,sfxVolume);
		
	}
	
	function positionPowerups()
	{
		if(gui.powerup1.isActive)
		{
			TweenMax.to( gui.powerup1, .3, {x:gui.powerup1.endX, ease:Quad.easeOut});
		}
		else
		{
			TweenMax.to( gui.powerup1, .3, {x:gui.powerup1.startX, ease:Quad.easeOut});
		}
		
		if(gui.powerup2.isActive)
		{
			if( gui.powerup1.isActive )
			{
				TweenMax.to( gui.powerup2, .3, {x:gui.powerup2.endX, ease:Quad.easeOut});
			}
			else
			{
				TweenMax.to( gui.powerup2, .3, {x:gui.powerup1.endX, ease:Quad.easeOut});
			}
		}
		else
		{
			TweenMax.to( gui.powerup2, .3, {x:gui.powerup2.startX, ease:Quad.easeOut});
		}
	}
	
	function onPowerupComplete(powerup)
	{
		console.log('powerup done!');
		powerup.nav.name.innerHTML = 'READY';
		powerup.nav.status = 'READY';
		TweenMax.to(powerup.nav.on, 0, {autoAlpha:0});
		TweenMax.to(powerup.nav.ready, 0, {autoAlpha:1});
		
		powerup.isActive = false;
		positionPowerups();
		
		// check drone
		if( powerup.info.name=='Hover Drone')
		{
			console.log('hide drone');
			player.drone.alpha = 0;
		}
	}
	
	function setMinerals()
	{
		var i;
		var j;
		var k;
		var gemList = [];
		var info;
		var minerals = shopMenu.minerals;
		var div;
		var txt;
		var cashTotal = 0;
		var endY = 0;
		
		// gather gem list
		for(i=1; i<=6; i++)
		{
			for(j=1; j<=3; j++)
			{
				info = Data.getGemData( '0'+i, 'm'+j );
				
				var isNew = true;
				for(k=0; k<gemList.length; k++)
				{
					if( info.id == gemList[k].id )
					{
						isNew = false;
					}
				}
				
				if( isNew )
				{
					gemList.push( info );
				}
				
			}
		}
		
		// add gem count to list
		for(i=0; i<gemList.length; i++)
		{
			gemList[i].count = 0;
			for(j=0; j<player.collected.length; j++)
			{
				if( gemList[i].id == player.collected[j] )
				{
					gemList[i].count++;
				}
			}
		}
		
		// drop empty gems 
		var newList = [];
		for(i=0; i<gemList.length; i++)
		{
			if(gemList[i].count!=0)
			{
				newList.push( gemList[i] );
			}
		}
		gemList = newList;
		
		// remove old scroll
		if( minerals.scroller )
		{
			shopMenu.minerals.list.removeChild( minerals.scroller );
		}
		
		// scroll div
		var scroller = document.createElement("div");
		scroller.style.position = "absolute";
		scroller.style.width = '340px';
		scroller.style.height = '100px';
		scroller.style.background = "none";
		minerals.list.appendChild(scroller);
		TweenMax.to(scroller, 0, {x:0,y:0});
		minerals.scroller = scroller;
		
		// add gem entries
		for(i=0; i<gemList.length+1; i++)
		{
			if( i<gemList.length )
			{
				div = document.createElement("div");
				div.style.position = "absolute";
				div.style.width = '340px';
				div.style.height = '20px';
				scroller.appendChild(div);
				TweenMax.to(div, 0, {x:0,y:22*i});
				
				txt = document.createElement("div");
				txt.style.position = "absolute";
				txt.style.width = '100px';
				txt.style.height = '20px';
				txt.style.color = '#ffffff';
				txt.style.fontFamily = 'Bangers';
				txt.style.fontWeight = '100';
				txt.style.fontSize = '20px';
				txt.innerHTML = gemList[i].id;
				div.appendChild(txt);
				TweenMax.to(txt, 0, {x:8,y:2});
				
				txt = document.createElement("div");
				txt.style.position = "absolute";
				txt.style.width = '100px';
				txt.style.height = '20px';
				txt.style.color = '#ffffff';
				txt.style.fontFamily = 'Bangers';
				txt.style.fontWeight = '100';
				txt.style.fontSize = '20px';
				txt.innerHTML = gemList[i].count + ' x ' + '$' + addCommas(gemList[i].value);
				div.appendChild(txt);
				TweenMax.to(txt, 0, {x:114,y:2});
				
				txt = document.createElement("div");
				txt.style.position = "absolute";
				txt.style.width = '100px';
				txt.style.height = '20px';
				txt.style.color = '#ffffff';
				txt.style.fontFamily = 'Bangers';
				txt.style.fontWeight = '100';
				txt.style.fontSize = '20px';
				txt.innerHTML = '= $' + addCommas(gemList[i].count * gemList[i].value);
				div.appendChild(txt);
				TweenMax.to(txt, 0, {x:234,y:2});
				
				cashTotal += (gemList[i].count * gemList[i].value);
			}
			else
			{
				div = document.createElement("div");
				div.style.position = "absolute";
				div.style.width = '340px';
				div.style.height = '2px';
				div.style.background = "#f800e8";
				scroller.appendChild(div);
				TweenMax.to(div, 0, {x:0,y:(22*i)+2});
				
				div = document.createElement("div");
				div.style.position = "absolute";
				div.style.width = '340px';
				div.style.height = '20px';
				scroller.appendChild(div);
				TweenMax.to(div, 0, {x:0,y:(22*i)+4});
				
				txt = document.createElement("div");
				txt.style.position = "absolute";
				txt.style.width = '100px';
				txt.style.height = '20px';
				txt.style.color = '#f800e8';
				txt.style.fontFamily = 'Bangers';
				txt.style.fontWeight = '100';
				txt.style.fontSize = '20px';
				txt.innerHTML = 'TOTAL';
				div.appendChild(txt);
				TweenMax.to(txt, 0, {x:8,y:2});
				
				if( cashTotal==0 )
				{
					txt.innerHTML = 'NO MINERALS';
				}
				
				txt = document.createElement("div");
				txt.style.position = "absolute";
				txt.style.width = '100px';
				txt.style.height = '20px';
				txt.style.color = '#f800e8';
				txt.style.fontFamily = 'Bangers';
				txt.style.fontWeight = '100';
				txt.style.fontSize = '20px';
				txt.innerHTML = '= $' + addCommas(cashTotal);
				div.appendChild(txt);
				TweenMax.to(txt, 0, {x:234,y:2});
				
				endY = ((i*22)+24+6);
			}
		}
		
		// update cash
		TweenMax.delayedCall(.5, updateCash, [ cashTotal ] );
		
		// check for scroll
		if( endY > 120 )
		{
			console.log('spill over');
			console.log( endY );
			TweenMax.to( scroller, 3.0, {delay:1.5, y:(endY-120)*-1, ease:Linear.easeNone});
		}
		
	}
	
	function onMineralNextOver(e)
	{
		e.target.div.style.background = '#ff95f9';
	}
	
	function onMineralNextOut(e)
	{
		e.target.div.style.background = '#f800e8';
	}
	
	function onMineralNextClick(e)
	{
		TweenMax.to( shopMenu.minerals, .3, {autoAlpha:0, ease:Quad.easeOut});
		TweenMax.to( shopMenu.upgrades, .3, {autoAlpha:1, ease:Quad.easeOut});
		shopMenu.audio.button.play('',0,sfxVolume);
		
		setShopText('shop_upgrades');
	}
	
	function updateCash(amt)
	{
		if(amt==0){return;}
		
		var i;
		var loop = 30;
		var inc = Math.floor(amt/loop);
		if(inc==0){inc=1;}
		
		var delayer = 0;
		var dinc = .02;
		
		for(i=0; i<loop; i++)
		{
			if(i==loop-1)
			{
				TweenMax.delayedCall( delayer, setCashDisplay, [curCash+amt] );
			}
			else
			{
				TweenMax.delayedCall( delayer, setCashDisplay, [curCash+(inc*i)] );
			}
			
			delayer+=dinc;
		}
		
		curCash+=amt;
		localStorage.setItem( 'curCash', curCash );
		
	}
	
	function setCashDisplay(amt)
	{
		//console.log(amt);
		shopMenu.cash.innerHTML = '$' + addCommas(amt);
	}
	
	//--------------------------------------------------- TOWER METHODS:
	
	function checkTowerUpgrade()
	{
		if( (settings.gemsCollected == 25) && (settings.towerLevel==0) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 50) && (settings.towerLevel==1) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 100) && (settings.towerLevel==2) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 200) && (settings.towerLevel==3) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 300) && (settings.towerLevel==4) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 500) && (settings.towerLevel==5) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 700) && (settings.towerLevel==6) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 1000) && (settings.towerLevel==7) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 2000) && (settings.towerLevel==8) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
		if( (settings.gemsCollected == 5000) && (settings.towerLevel==9) )
		{
			TweenMax.delayedCall( 0.5, showTowerUpgrade );
		}
	}
	
	function showTowerUpgrade()
	{
		settings.towerLevel++;
		localStorage.setItem( 'towerLevel', settings.towerLevel );
		
		var i;
		for(i=1; i<=15; i++)
		{
			TweenMax.to( towerMenu.towers['t'+i], 0, {autoAlpha:0});
		}
		
		var level = settings.towerLevel + 5;
		TweenMax.to( towerMenu.towers['t'+level], 0, {autoAlpha:1});
		
		TweenMax.pauseAll();
		game.paused = true;
		TweenMax.to( towerMenu, .3, {delay:0.0, autoAlpha:1, ease:Quad.easeOut});
		
		// swap background art
		background.tower.img.destroy();
		img = game.add.sprite(0, 0, 'towerup' + (settings.towerLevel+5) );
		img.x = (TILE_WIDTH*MAP_WIDTH*.5)-(img.width*.5) + 6;
		img.y = HORIZON_Y - img.height + 6;
		background.tower.add( img );
		background.tower.img = img;
		
		// audio
		shopMenu.audio.upgrade.play('',0,sfxVolume);
	}
	
	function onTowerBtnClick(e)
	{
		if( e.target.id == 'continue' )
		{
			TweenMax.to( towerMenu, .3, {delay:0.0, autoAlpha:0, ease:Quad.easeOut});
			TweenMax.resumeAll();
			game.paused = false;
		}
		
		if( e.target.id == 'portal' )
		{
			TweenMax.to( towerMenu, .3, {delay:0.0, autoAlpha:0, ease:Quad.easeOut});
			TweenMax.resumeAll();
			game.paused = false;
			warpPlayer(-1,6);
		}
	}
	
	//--------------------------------------------------- ROW METHODS:
	
	function addRow(num)
	{
		//console.log('add row: ' + num );
		
		if(num <= -1){return}
		
		// set : zone, depth
		var zoneNum = Math.floor( (num)/ZONE_MARK )+1;
		var zoneStr = '' + zoneNum;
		if( zoneNum < 10 ){ zoneStr = '0' + zoneNum; }
		
		var depthNum = Math.floor( ( num-((zoneNum-1)*ZONE_MARK) )/DEPTH_MARK )+1;
		var depthStr = '' + depthNum;
		if( depthNum < 10 ){ depthStr = '0' + depthNum; }
		
		// testing: endless zone 6
		if(zoneNum>6)
		{
			zoneStr = '06';
			depthStr = '05';
		}
			
		// add row
		var i;
		var path;
		var sprite;
		var rowTiles = [];
		allTiles[num] = rowTiles;
		for(i=0; i<MAP_WIDTH; i++)
		{
			var newY = (num*64) + HORIZON_Y;
			var newX = (i*64);
			var box;
						
			// set edge to stone
			if( (i==0) || (i==(MAP_WIDTH-1)) )
			{
				box = platforms.create(newX, newY, 'edge_stone');
				box.isStone = true;
				box.body.immovable = true;
			}
			// matrix stone
			else if( tileMatrix[num][i] == 1000 )
			{
				box = platforms.create(newX, newY, 'edge_stone');
				box.isStone = true;
				box.body.immovable = true;
			}
			// set to empty
			else if( tileMatrix[num][i] == 0 )
			{
				box = game.add.sprite(newX, newY, 'back0' + backMatrix[num][i]);
				box.isDirt = true;
				backtiles.add(box);
			}
			// set to gem: A
			else if( tileMatrix[num][i] < .10 )
			{
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_m1_' + depthStr);
			    box.body.immovable = true;
				box.gem = Data.getGemData(zoneStr,'m1');
			}
			// set to gem: B
			else if( tileMatrix[num][i] < .20 )
			{
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_m2_' + depthStr);
			    box.body.immovable = true;
				box.gem = Data.getGemData(zoneStr,'m2');
			}
			// set to gem: C
			else if( tileMatrix[num][i] < .25 )
			{
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_m3_' + depthStr);
			    box.body.immovable = true;
				box.gem = Data.getGemData(zoneStr,'m3');
			}
			// set to boulder
			else if( (tileMatrix[num][i] <= .27) )
			{
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_boulder_' + depthStr);
				box.isStone = true;
				box.isBoulder = zoneStr;
				box.body.immovable = true;
			}
			// set to portal
			else if( (tileMatrix[num][i] <= .28) && (num>10) )
			{
				box = game.add.sprite(newX, newY, 'back0' + backMatrix[num][i]);
				box.isDirt = true;
				backtiles.add(box);
				
				sprite = game.add.sprite(0, 0, 'portal_ug');
				sprite.animations.add('walk', [0,1,2,3]);
				sprite.play('walk',24,true);
				sprite.x = box.x-4+36;
				sprite.y = box.y-4+36;
				sprite.id = 'portal';
				sprite.row = num;
				sprite.col = i;
				
				game.physics.arcade.enable(sprite);
				sprite.enableBody = true;
				sprite.anchor.setTo(.5,.5);
				sprite.body.setSize(2, 2, 0, 0);
				portals.add( sprite );
			}
			// set to hotspot
			else if( (tileMatrix[num][i] <= .29) && ( (zoneStr=='03') || (zoneStr=='06') ) )
			{
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_hotspot_' + depthStr);
				box.isStone = true;
				box.isHotspot = true;
				box.body.immovable = true;
				
				// add glow, play
				sprite = game.add.sprite(0, 0, 'radiation');
				sprite.animations.add('glow', [0,1,2,3,4,5,6,7,8]);
				sprite.play('glow',24,true);
				sprite.anchor.setTo(.5,.5);
				sprite.x = box.x+32;
				sprite.y = box.y+32;
				effectsLayer.add(sprite);
				box.glow = sprite;
				
			}
			// set to normal/blank
			else
			{
			   	//box = platforms.create(newX, newY, 'dirt_plain');
				box = platforms.create(newX, newY, 'zone' + zoneStr + '_plain_' + depthStr);
			    box.body.immovable = true;
			}
			
			// override top layer
			if( (num==0) && (!box.isStone) && (!box.isDirt) )
			{
				box.destroy();
				
				var topID = ''
				if(i%3==0)
				{
					topID = 'zone00_plain_01'
				}
				if(i%3==1)
				{
					topID = 'zone00_plain_02'
				}
				if(i%3==2)
				{
					topID = 'zone00_plain_03'
				}
				
				box = platforms.create(newX, newY, topID);
				box.row = num;
				box.col = i;
			    box.body.immovable = true;
			}
			
			// store box in array
			rowTiles[i] = box;
			
			// set box values
			box.row = num;
			box.col = i;
			box.health = TILE_HEALTH;
			box.zoneStr = zoneStr;
			box.depthStr = depthStr;
			
			// check enemy matrix
			if( enemyMatrix[num] )
			{
				if( enemyMatrix[num][i] )
				{
					// check enemy matrix
					if( enemyMatrix[num][i]==1 )
					{
						buildEnemy01(box);
					}
					if( enemyMatrix[num][i]==2 )
					{
						buildEnemy02(box);
					}
					if( enemyMatrix[num][i]==3 )
					{
						buildEnemy03(box);
					}
					if( enemyMatrix[num][i]==4 )
					{
						buildEnemy04(box);
					}
					if( enemyMatrix[num][i]==5 )
					{
						buildEnemy05(box);
					}
					if( enemyMatrix[num][i]==6 )
					{
						buildEnemy06(box);
					}
					if( enemyMatrix[num][i]==7 )
					{
						buildEnemy07(box);
					}
					if( enemyMatrix[num][i]==8 )
					{
						buildEnemy08(box);
					}
			
					// check boss matrix
					if( enemyMatrix[num][i]==101 )
					{
						buildBoss01(box);
					}
					if( enemyMatrix[num][i]==201 )
					{
						buildBoss02(box);
					}
					if( enemyMatrix[num][i]==301 )
					{
						game.paused = true;
						buildBoss03(box);
						game.paused = false;
					}
				}
			}
				
			// check water matrix
			if( waterMatrix[num] )
			{
				if( waterMatrix[num][i] )
				{
					if( waterMatrix[num][i]==1 )
					{
						buildWater(box);
					}
				}
			}
			
		}
		
	}
	
	function removeRow(num)
	{
		//console.log('remove row: ' + num);
		if(num <= -1){return}
		
		var i;
		var tileSet = allTiles[num]
		for(i=0; i<tileSet.length; i++)
		{
			var box = tileSet[i];
			
			if(box.glow)
			{
				box.glow.destroy();
			}
			
			box.destroy();
		}
		allTiles[num] = null;
	}
	
	function swapRows(newRow)
	{
		var minRow = player.curRow - (ROW_LIMIT*.5);
		var maxRow = player.curRow + (ROW_LIMIT*.5);
		
		// add bottom row, remove top
		if(newRow > player.curRow)
		{
			removeRow(minRow);
			addRow(maxRow+1);
		}
		
		// add top row, remove bottom
		if(newRow < player.curRow)
		{
			removeRow(maxRow);
			addRow(minRow-1);
		}
	}
	
	//--------------------------- MAP METHODS:
	
	function checkDrill(mode)
	{
		//console.log(player.x, player.y);
		
		var curRow = player.curRow;
		var curCol = player.curCol;
		var pCenterX = player.x + (player.width*.5);
		var pCenterY = player.y + (player.height*.5);
		
		// check tile
		if( mode == 'down' )
		{
			curRow = curRow + 1;
		}
		if( mode == 'up' )
		{
			curRow = curRow - 1;
		}
		if( mode == 'left' )
		{
			curCol = curCol - 1;
		}
		if( mode == 'right' )
		{
			curCol = curCol + 1;
		}
		
		// on side drilling on surface
		if( curRow == -1 )
		{
			if( (mode=='left') || (mode=='right') || (mode=='up') )
			{
				//console.log('no side surface');
				return;
			}
		}
		
		// check for null tile
		if( curRow > allTiles.length ){ return };
		if( curRow < 0 ){ return };
				
		// get tile
		var box = allTiles[ curRow ][ curCol ];

		if( box )
		{
			var dx = (box.x + (TILE_WIDTH*.5)) - pCenterX;
			var dy = (box.y + (TILE_WIDTH*.5)) - pCenterY;
			var dt = Math.sqrt( (dx*dx) + (dy*dy) );
			if( dt < DRILL_THRESH )
			{
				drillTile(box, mode);
			}
		}
		else
		{
			//console.log('no tile there');
		}
		
	}
	
	function drillTile(box, mode)
	{
		if(box.isDirt){return}
		if(box.isStone){return}
		
		// check fuel
		if( player.fuel==0 )
		{
			//console.log('no fuel');
			showFuelWarning();
			return;
		}
		
		// update health
		box.health-=DRILL_POWER;
		if(box.health<=0)
		{
			breakTile(box);
		}
		
		// drop piece
		var id = "zone" + box.zoneStr + '_piece_' + box.depthStr;
		//var p = game.add.sprite(box.x, box.y, id);
		var p = game.add.sprite( box.x, box.y, id);
		game.physics.arcade.enable(p);
		p.anchor.setTo(0.5, 0.5);
		p.body.gravity.y = 800;
		p.body.velocity.x = (Math.random() * -200) + 100;
		p.body.velocity.y = (Math.random() * -100) - 200;
		p.body.angularVelocity = ( (Math.random() * -20) + 10) * 40;
		effectsLayer.add(p);
		
		// set by direction
		if( mode=='down' )
		{
			p.x += 32;
			p.x = (player.x+(player.width*.5));
			
			if( player.body.velocity.x ==0 )
			{
				var dx = (player.x+(player.width*.5)) - (box.x+32);
				if(Math.abs(dx)>4)
				{
					if( dx>0 )
					{
						player.body.velocity.x=-DRILL_SLIDE;
					}
					else
					{
						player.body.velocity.x=DRILL_SLIDE;
					}
				}
				
			}
			
		}
		if( mode=='up' )
		{
			p.x += 32;
			p.y += 64;
			p.body.velocity.y *= -.5;
			p.x = (player.x+(player.width*.5));
		}
		if( mode=='left' )
		{
			p.x += 64;
			p.y += 32;
			p.body.velocity.x += 100;
		}
		if( mode=='right' )
		{
			p.y += 32;
			p.body.velocity.x -= 100;
		}
		
		TweenMax.to( p, .5, {delay:2.0, alpha:0, onComplete:removeImg, onCompleteParams:[p]});
		
		// consume energy
		player.fuel--;
		setGuiFuel();
	}
	
	function breakTile(box)
	{
		// update matrix
		tileMatrix[box.row][box.col] = 0;
		
		// check for gem
		if( box.gem )
		{
			// check storage
			if( player.storage==PLAYER_STORAGE )
			{
				//console.log('no storage');
				showStorageWarning(box);
			}
			else
			{
				// add to storage
				showGemBonus(box);
				player.storage++;
				setGuiStorage();
			}
		}
		
		// add back dirt
		var dirt = game.add.sprite(0, 0, 'back0' + backMatrix[box.row][box.col]);
		dirt.x = box.x;
		dirt.y = box.y;
		dirt.isDirt = true;
		backtiles.add(dirt);
		allTiles[box.row][box.col] = dirt;
		
		// add shards
		var bx = box.x + (TILE_WIDTH*.5);
		var by = box.y + (TILE_WIDTH*.5);
		
		var i;
		for(i=0; i<4; i++)
		{
			var id = "zone" + box.zoneStr + '_shard_' + box.depthStr;
			var shard = game.add.sprite(bx, by, id);
			game.physics.arcade.enable(shard);
			shard.anchor.setTo(0.5, 0.5);
			shard.body.gravity.y = 800;
			shard.body.velocity.x = (Math.random() * -200) + 100;
			shard.body.velocity.y = (Math.random() * -100) - 200;
			shard.body.angularVelocity = ( (Math.random() * -20) + 10) * 40;
			effectsLayer.add(shard);
			
			TweenMax.to( shard, .5, {delay:2.0, alpha:0, onComplete:removeImg, onCompleteParams:[shard]});
		}
		
		// check tile above for boulder
		if( box.row>1 )
		{
			if(allTiles[box.row-1])
			{
				var uptile = allTiles[box.row-1][box.col]
				if( uptile.isBoulder )
				{
					TweenMax.delayedCall(1.0, breakTile, [uptile]);
				}
			}
		}
		
		// check for boulder in tile
		if( box.isBoulder )
		{
			addBoulder(box);
		}
		
		// remove box
		box.destroy();
		
		// audio
		var randA = Math.floor(Math.random()*4)+1;
		background.audio['dig'+randA].play('',0,sfxVolume);
			
	}
	
	//--------------------------- BOULDER METHODS:
	
	function addBoulder(box)
	{
		console.log('add boulder');
		
		var sprite = game.add.sprite(0, 0, 'boulder'+box.isBoulder);
		sprite.x = box.x;
		sprite.y = box.y;
		boulders.add( sprite );
		
		game.physics.arcade.enable(sprite);
		sprite.id = 'boulder';
		sprite.body.gravity.y = 500;
	    sprite.body.collideWorldBounds = true;
		sprite.body.outOfBoundsKill = true;
		sprite.zoneStr = box.isBoulder;
	}
	
	function breakBoulder(boulder)
	{
		if(!boulder.x){return;}
		
		// add shards
		var bx = boulder.x + 16;
		var by = boulder.y + 16;
		
		var i;
		for(i=0; i<4; i++)
		{
			var id = "boulder" + boulder.zoneStr + '_shard';
			var shard = game.add.sprite(bx, by, id);
			game.physics.arcade.enable(shard);
			shard.anchor.setTo(0.5, 0.5);
			shard.body.gravity.y = 800;
			shard.body.velocity.x = (Math.random() * -200) + 100;
			shard.body.velocity.y = (Math.random() * -100) - 200;
			shard.body.angularVelocity = ( (Math.random() * -20) + 10) * 40;
			effectsLayer.add(shard);
			
			TweenMax.to( shard, .5, {delay:2.0, alpha:0, onComplete:removeImg, onCompleteParams:[shard]});
		}
		
		// remove box
		boulder.destroy();

		// audio
		background.audio.boulder.play('',0,sfxVolume);
			
	}
	
	function onBoulderCollision( other, boulder )
	{
		if(other.row)
		{
			//console.log('tile');
		}
		else
		{
			if(other.id=='player')
			{
				
				var dy = player.y - boulder.y;
				console.log('player boulder: ' + dy);
				if( (dy>50) && (dy<72) )
				{
					var dmg = 1;
					
					// check for powerups
					if( (gui.powerup1.isActive) )
					{
						if( gui.powerup1.info.name=='Hard Hat' )
						{
							dmg = 0;
						}
					}
					if( (gui.powerup2.isActive) )
					{
						if( gui.powerup2.info.name=='Hard Hat' )
						{
							dmg = 0;
						}
					}
					
					// damage player
					if(dmg>0)
					{
						damagePlayer( dmg );
					}
					
				}
				breakBoulder(boulder);
			}
		}
	}

	//--------------------------- WATER METHODS:
	
	function buildWaterCavern(row, col)
	{
		//console.log( 'add water cavern: ' + row + ', ' + col );
		
		// check matrix
		var val = tileMatrix[row][col]
		if( val < .7 ){ return; }
		
		// build matrix
		var i;
		var j;
		var cH = 3;
		var cW = 6;
		
		for(i=row; i<row+cH; i++)
		{
			for(j=col; j<col+cW; j++)
			{
				if((j==col)||(j==(col+cW-1))||(i==row+cH-1))
				{
					tileMatrix[i][j] = 1000;
				}
				else
				{
					tileMatrix[i][j] = 0;
				}
			}
		}
		
		// add water
		waterMatrix[row][col+1] = 1;
		
	}
	
	function buildWater(box)
	{
		
		// check for lava zone
		var pool;
		var curZone = Math.floor(box.row/ZONE_MARK)+1;
		if(curZone==5)
		{
			pool = game.add.sprite(0, 0, 'pool02');
		}
		else
		{
			pool = game.add.sprite(0, 0, 'pool01');
		}
		
		// position
		pool.x = box.x;
		pool.y = box.y+0;
		
		// lower water line
		pool.height -= 32;
		pool.y += 32;
		
		water.add(pool);
	}
	
	function onWaterCollision( player, water )
	{
		var d = player.y - (water.y+4);
		if(d<0){ d=0; }
		if(d>10){ d=10; }
		
		player.body.velocity.y -= (.3*d);
		player.inWater = true;
	}
	
	function checkWater()
	{
		var i;
		var e;
		var erow;
		var prow;
		var dx;
		
		for(i=(water.children.length-1); i>=0; i--)
		{
			e = water.children[i];

			erow = Math.floor ( (e.y-HORIZON_Y)/64 );
			prow = Math.floor ( (player.y-HORIZON_Y)/64 );
			
			// remove
			if( Math.abs(erow-prow) >= 10 )
			{
				console.log( 'water out of range, remove' );
				e.destroy();
			}
			
		}
	}
		
	//--------------------------- UTILITY METHODS:
	
	function removeImg(img)
	{
		//img.destroy();
		img.destroy();
	}
	
	function removeGrp(grp)
	{
		grp.destroy();
		grp = null;
	}
	
	function removeFuelWarning(grp)
	{
		grp.destroy();
		fuelWarning = null;
	}
	
	function addCommas(x) 
	{
	    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
	}
	
	//----------------------------------------------


window.Main = Main;
}(window));